"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ArgousPagination_1 = __importDefault(require("../ArgousPagination"));
var Paper_1 = __importDefault(require("@material-ui/core/Paper"));
var styles_1 = require("@material-ui/core/styles");
var Table_1 = __importDefault(require("@material-ui/core/Table"));
var TableBody_1 = __importDefault(require("@material-ui/core/TableBody"));
var TableCell_1 = __importDefault(require("@material-ui/core/TableCell"));
var TableContainer_1 = __importDefault(require("@material-ui/core/TableContainer"));
var TableHead_1 = __importDefault(require("@material-ui/core/TableHead"));
var TableRow_1 = __importDefault(require("@material-ui/core/TableRow"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var ArgousSimpleTable = function (props) {
    var useStyles = styles_1.makeStyles({
        table: {
            minWidth: 650,
        },
    });
    var _a = react_1.useState({ acao: '', pgAtl: 1, qtRegs: 0 }), ctrlPgn = _a[0], setCtrlPgn = _a[1];
    var _b = react_1.useState(false), iniciado = _b[0], setIniciado = _b[1];
    var _c = react_1.useState({ tpOrdem: 'D' }), tpOrdenacao = _c[0], setTpOrdenacao = _c[1];
    var _d = react_1.useState([]), listaChildrens = _d[0], setListaChildrens = _d[1];
    var classes = useStyles();
    function getCellContent(vlr, line) {
        if (props.columnOptions) {
            for (var _i = 0, _a = props.columnOptions; _i < _a.length; _i++) {
                var element = _a[_i];
                if (element.alias === line) {
                    return element.customJsx({ value: vlr });
                }
            }
        }
        return vlr;
    }
    function clickNaLinha(row) {
        if (props.onClick) {
            props.onClick(props.rows[row]);
        }
    }
    function onChangePage(prm) {
        var pgAtual = props.ctrlPgnReturn.pgAtl;
        if (prm === 'P') {
            if (pgAtual > 1) {
                setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: prm, qtPaginas: props.ctrlPgnReturn.qtPaginas, pgAtl: pgAtual, qtRegs: props.ctrlPgnReturn.qtRegs }));
            }
        }
        else if (pgAtual < props.ctrlPgnReturn.qtPaginas) {
            setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: prm, qtPaginas: props.ctrlPgnReturn.qtPaginas, pgAtl: pgAtual, qtRegs: props.ctrlPgnReturn.qtRegs }));
        }
    }
    function onChangeRowsPerPage(prm) {
        setCtrlPgn(__assign(__assign({}, ctrlPgn), { qtRegs: prm }));
    }
    function onChangePageNumber(prm) {
        setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: "S=" + parseInt(prm), pgAtl: parseInt(prm), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas }));
    }
    function selecionaOrdenacao(prm) {
        if (tpOrdenacao.indOrdem) {
            if (tpOrdenacao.indOrdem === prm) {
                var tpOrdem = 'D';
                if (tpOrdenacao.tpOrdem === 'D') {
                    tpOrdem = 'A';
                }
                setTpOrdenacao({ indOrdem: prm, tpOrdem: tpOrdem });
                setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: undefined, indOrdem: prm, tpOrdem: tpOrdem, pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas }));
            }
            else {
                setTpOrdenacao({ indOrdem: prm, tpOrdem: 'D' });
                setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: undefined, indOrdem: prm, tpOrdem: 'D', pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas }));
            }
        }
        else {
            var tpOrdem = 'D';
            if (tpOrdenacao.tpOrdem) {
                if (tpOrdenacao.tpOrdem === 'D') {
                    tpOrdem = 'A';
                }
            }
            setTpOrdenacao({ indOrdem: prm, tpOrdem: tpOrdem });
            setCtrlPgn(__assign(__assign({}, ctrlPgn), { acao: undefined, indOrdem: prm, tpOrdem: tpOrdem, pgAtl: parseInt(props.ctrlPgnReturn.pgAtl), qtRegs: props.ctrlPgnReturn.qtRegs, qtPaginas: props.ctrlPgnReturn.qtPaginas }));
        }
    }
    function listaFilhos() {
        var children = props.children;
        if (children) {
            if (!children.length) {
                return [children];
            }
            return children;
        }
        return [];
    }
    react_1.useEffect(function () {
        if (iniciado) {
            props.ctrlPgn({ ctrlPgn: ctrlPgn });
        }
        else {
            setListaChildrens(listaFilhos());
            setIniciado(true);
        }
    }, [ctrlPgn]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(TableContainer_1.default, { component: Paper_1.default },
            react_1.default.createElement(Table_1.default, { className: classes.table, size: 'small', style: { tableLayout: 'fixed', width: '100%' } },
                react_1.default.createElement(TableHead_1.default, null,
                    react_1.default.createElement(TableRow_1.default, null,
                        props.head.map(function (coluna, index) {
                            var width = 'auto';
                            if (props.columnWidths && props.columnWidths[index]) {
                                width = props.columnWidths[index];
                            }
                            var ordena = false;
                            if (props.ctrlPgnReturn && props.ctrlPgnReturn.ordCols) {
                                ordena = props.ctrlPgnReturn.ordCols[index];
                            }
                            if (ordena) {
                                return (react_1.default.createElement(TableCell_1.default, { onClick: function () { return selecionaOrdenacao(index); }, style: { width: "" + width, whiteSpace: 'nowrap', cursor: 'pointer', fontSize: 14 }, key: index },
                                    coluna,
                                    (tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem !== index) &&
                                        react_1.default.createElement("i", { style: { right: '-10px', position: 'relative', color: '#999' }, className: 'glyph-icon tooltip-button demo-icon icon-sort' }),
                                    (tpOrdenacao.indOrdem === undefined) && (tpOrdenacao.indOrdem !== index) &&
                                        react_1.default.createElement("i", { style: { right: '-10px', position: 'relative' }, className: 'glyph-icon tooltip-button demo-icon icon-sort' }),
                                    (tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem === index) && (tpOrdenacao.tpOrdem === 'A') &&
                                        react_1.default.createElement("i", { style: { right: '-10px', position: 'relative' }, className: 'glyph-icon tooltip-button demo-icon icon-sort-amount-asc' }),
                                    (tpOrdenacao.indOrdem !== undefined) && (tpOrdenacao.indOrdem === index) && (tpOrdenacao.tpOrdem === 'D') &&
                                        react_1.default.createElement("i", { style: { right: '-10px', position: 'relative' }, className: 'glyph-icon tooltip-button demo-icon icon-sort-amount-desc' })));
                            }
                            return (react_1.default.createElement(TableCell_1.default, { style: { width: "" + width, fontSize: 14 }, key: index }, coluna));
                        }),
                        listaChildrens.map(function (item, index) { return (react_1.default.createElement(TableCell_1.default, { style: { width: '30px', fontSize: 14 }, key: "act" + index }, " ")); }))),
                react_1.default.createElement(TableBody_1.default, null, props.rows && props.rows.map(function (linha, index) {
                    if (props.maxRows) {
                        if (index >= props.maxRows) {
                            return null;
                        }
                    }
                    var estilo = {
                        cursor: 'pointer'
                    };
                    if (props.onClick === undefined) {
                        estilo = { cursor: 'text' };
                    }
                    if (props.indexes) {
                        return (react_1.default.createElement(TableRow_1.default, { key: index, style: estilo, onClick: function () { return clickNaLinha(index); } },
                            props.indexes.map(function (ind, keyInd) {
                                var oEstilo = {};
                                if (props.columnStyles && props.columnStyles[keyInd]) {
                                    oEstilo = props.columnStyles[keyInd];
                                }
                                var aClasse = '';
                                if (props.columnClasses && props.columnClasses[keyInd]) {
                                    aClasse = props.columnClasses[keyInd];
                                }
                                return (react_1.default.createElement(TableCell_1.default, { className: aClasse, style: oEstilo, key: keyInd }, getCellContent(linha[ind], keyInd)));
                            }),
                            listaChildrens.map(function (act, index3) { return (react_1.default.createElement(TableCell_1.default, { style: { width: '30px' }, key: "act_" + index3 }, react_1.default.cloneElement(act, { item: linha }))); })));
                    }
                    return (react_1.default.createElement(TableRow_1.default, { key: index, style: estilo, onClick: function () { return clickNaLinha(index); } }, linha.map(function (ln, keyInd) {
                        return (react_1.default.createElement(TableCell_1.default, { style: { whiteSpace: 'nowrap', textOverflow: 'ellipsis', overflow: 'hidden' }, key: keyInd }, getCellContent(ln, keyInd)));
                    })));
                })))),
        (props.ctrlLinhasPorPagina) && (props.ctrlPgnReturn) &&
            react_1.default.createElement(ArgousPagination_1.default, { linhasPorPagina: props.ctrlLinhasPorPagina, paginas: props.ctrlPgnReturn.qtPaginas, ctrlPgnReturn: props.ctrlPgnReturn, onChangePage: onChangePage, onChangeRowsPerPage: onChangeRowsPerPage, onChangePageNumber: onChangePageNumber })));
};
exports.default = ArgousSimpleTable;
