"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("./../");
var fieldsRedux_1 = require("../../fieldsRedux");
var api_1 = require("../../utils/api");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_custom_scrollbars_1 = require("react-custom-scrollbars");
/**
 * @deprecated
 */
var AutoComplete = /** @class */ (function (_super) {
    __extends(AutoComplete, _super);
    function AutoComplete() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            typeMessage: -1,
            resultHeight: 0
        };
        _this.changeTypeMessage = function (value) {
            _this.buscarServidorEMensagensFeedback(value);
            _this.removerSelecionadoSeHouverEdicao();
        };
        _this.removerSelecionadoSeHouverEdicao = function () {
            var selected = _this.props.getField().selected;
            if (selected) {
                var onChangeSelected = _this.props.onChangeSelected;
                _this.props.setField({ selected: undefined });
                if (onChangeSelected)
                    onChangeSelected({});
            }
        };
        _this.buscarServidorEMensagensFeedback = function (value) {
            var _a = _this.props.dados, dados = _a === void 0 ? {} : _a;
            clearTimeout(_this.searchTimeout);
            fieldsRedux_1.setField("results-" + _this.props.field, { value: undefined });
            _this.setState({ typeMessage: 2, resultHeight: 50 });
            _this.searchTimeout = setTimeout(function () {
                api_1.serverAction(_this.props.method, __assign({ value: value }, dados)).then(function (res) {
                    if (res.result) {
                        fieldsRedux_1.setField("results-" + _this.props.field, { value: res.result });
                        _this.setState({ typeMessage: 0, resultHeight: res.result.length * 38 });
                    }
                    else {
                        _this.setState({ typeMessage: 3, resultHeight: 50 });
                    }
                });
            }, 350);
        };
        _this.focusTypeMessage = function (e) {
            var thisField = _this.props.getField();
            var resultsData = fieldsRedux_1.getField("results-" + _this.props.field, 'value');
            if (!thisField.selected) {
                if (resultsData.length === 0) {
                    _this.setState({ typeMessage: 1, resultHeight: 50 });
                }
                else {
                    _this.setState({ typeMessage: 0, resultHeight: resultsData.length * 38 });
                }
            }
            if (thisField.selected) {
                e.target.select();
            }
        };
        _this.blurTypeMessage = function (e) {
            var onBlur = _this.props.onBlur;
            if (onBlur && typeof onBlur === 'function') {
                onBlur(e);
            }
            _this.blurTimeout = setTimeout(function () {
                _this.setState({ typeMessage: -1, resultHeight: 0 });
            }, 250);
        };
        _this.selectResult = function (value) {
            var _a = _this.props, alias = _a.alias, aliasInputValue = _a.aliasInputValue, onChangeSelected = _a.onChangeSelected;
            var v = '';
            for (var _i = 0, _b = aliasInputValue || alias; _i < _b.length; _i++) {
                var a = _b[_i];
                if (typeof value[a] !== 'undefined')
                    v += value[a].toString().trim() + " ";
            }
            fieldsRedux_1.setField(_this.props.field, 'value', v);
            fieldsRedux_1.setField(_this.props.field, 'selected', value);
            if (onChangeSelected)
                onChangeSelected(value);
        };
        return _this;
    }
    AutoComplete.prototype.componentDidUpdate = function (prevProps, prevState) {
        if (prevState.typeMessage !== 0 && this.state.typeMessage === 0) {
            var resultsDiv = document.getElementById("results-" + this.props.field);
            if (resultsDiv)
                this.setState({ resultHeight: resultsDiv.clientHeight });
        }
    };
    AutoComplete.prototype.componentWillUnmount = function () {
        this.props.clearField("results-" + this.props.field);
        clearTimeout(this.searchTimeout);
        clearTimeout(this.blurTimeout);
    };
    AutoComplete.prototype.render = function () {
        var _a = this.state, typeMessage = _a.typeMessage, resultHeight = _a.resultHeight;
        var _b = this.props, field = _b.field, placeholder = _b.placeholder, alias = _b.alias, inputClassName = _b.inputClassName, dropdownClassName = _b.dropdownClassName, dropdownMaxHeight = _b.dropdownMaxHeight, head = _b.head, showOnlyResults = _b.showOnlyResults;
        return (react_1.default.createElement("table", { className: 'argous-groupselect reset-border' },
            react_1.default.createElement("tbody", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement("td", null,
                        react_1.default.createElement(__1.Input, { field: field, onFocus: this.focusTypeMessage, onBlur: this.blurTypeMessage, onChange: this.changeTypeMessage, fieldListener: this.fieldListener, placeholder: placeholder, className: inputClassName }))),
                react_1.default.createElement("tr", null,
                    react_1.default.createElement("td", null, typeMessage > -1 &&
                        react_1.default.createElement("div", { className: dropdownClassName ? dropdownClassName : 'argous-list-dropdown', style: { height: !showOnlyResults ? resultHeight : typeMessage === 0 ? resultHeight : 0, maxHeight: dropdownMaxHeight } },
                            react_1.default.createElement(react_custom_scrollbars_1.Scrollbars, null,
                                typeMessage > 0 && !showOnlyResults && (react_1.default.createElement("div", { className: 'padding-top-sm padding-bottom-sm color999 text-center' },
                                    typeMessage === 1 && 'Escreva para começar a buscar',
                                    typeMessage === 2 && 'Pesquisando...',
                                    typeMessage === 3 && 'Nenhum resultado foi encontrado')),
                                react_1.default.createElement(__1.SimpleTable, { id: "results-" + field, field: "results-" + field, alias: alias, head: typeMessage === 0 ? head : undefined, onClick: this.selectResult, className: 'reset-margin' }))))))));
    };
    return AutoComplete;
}(react_1.Component));
AutoComplete.propTypes = {
    field: prop_types_1.default.string.isRequired,
    alias: prop_types_1.default.array.isRequired,
    method: prop_types_1.default.string.isRequired,
    head: prop_types_1.default.array,
    aliasInputValue: prop_types_1.default.array,
    placeholder: prop_types_1.default.string,
    inputClassName: prop_types_1.default.string,
    dropdownClassName: prop_types_1.default.string,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    dropdownMaxHeight: prop_types_1.default.number,
    onChangeSelected: prop_types_1.default.func,
    showOnlyResults: prop_types_1.default.bool,
    dados: prop_types_1.default.object
};
exports.default = fieldsRedux_1.createField(AutoComplete, { disableInitField: true });
