"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomTooltip = void 0;
var api_1 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var lab_1 = require("@material-ui/lab");
var clsx_1 = __importDefault(require("clsx"));
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
var io_1 = require("react-icons/io");
var useStyles = core_1.makeStyles(function (theme) { return ({
    subHeader: {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'space-between',
        backgroundColor: theme.palette.background.default,
        height: 25
    },
    divButton: {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
    },
    areaButton: {
        padding: '0px 8px 0px 8px'
    },
    button: theme.palette.type === 'light' ? {
        width: 15,
        height: 15,
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        cursor: 'pointer',
        color: 'rgba(0, 0, 0, 0.4)',
        '&:hover': {
            fontWeight: 500,
            color: '#000000',
        }
    } : {
        width: 15,
        height: 15,
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        cursor: 'pointer',
        color: 'rgba(255, 255, 255, 0.4)',
        '&:hover': {
            fontWeight: 500,
            color: '#ffffff',
        }
    },
    buttonActive: theme.palette.type === 'light' ? {
        color: 'rgba(0, 0, 0, 0.8)',
        '&:hover': {
            fontWeight: 600,
        }
    } : {
        color: 'rgba(255, 255, 255, 0.8)',
        '&:hover': {
            fontWeight: 600,
        }
    },
    listItem: {
        padding: 0,
        width: '100%',
        cursor: 'pointer',
        '&:hover': {
            background: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.05)' : 'rgba(255, 255, 255, 0.08)'
        }
    },
    hoverListItem: {
        background: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.05)' : 'rgba(255, 255, 255, 0.08)'
    },
    listItemText: {
        margin: 0,
        width: '100%',
        direction: 'ltr',
        overflow: 'visible',
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        padding: '0px 0px 0px 6px',
    },
    box: {
        padding: 0,
        overflowX: 'hidden',
        '&::-webkit-scrollbar': {
            width: 5
        },
        '&::-webkit-scrollbar-track': {
            background: '#0000'
        },
        '&::-webkit-scrollbar-thumb': {
            background: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.1)' : 'rgba(255, 255, 255, 0.1)'
        }
    },
    searchButton: {
        color: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.4)' : 'rgba(255, 255, 255, 0.5)',
        '&:hover': {
            color: theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.8)' : 'rgba(255, 255, 255, 0.9)',
            background: '#0000'
        }
    },
    popper: {
        zIndex: 1300,
        width: function (_a) {
            var widthListBox = _a.widthListBox;
            return widthListBox ? "" + widthListBox + (testWidth(widthListBox.toString()) ? 'px' : '') + " !important" : '';
        },
    }
}); });
var testWidth = function (value) { var _a; return ((_a = value.replace(/[0-9]/g, '')) === null || _a === void 0 ? void 0 : _a.length) ? false : true; };
var CustomPopper = function (props, classes) { return react_1.default.createElement(core_1.Popper, __assign({}, props, { className: classes.popper })); };
exports.CustomTooltip = core_1.withStyles(function (theme) { return ({
    tooltip: theme.palette.type === 'light' ? {
        fontSize: 15,
        fontWeight: 400,
        color: '#FFF',
        backgroundColor: '#333333e3',
    } : {
        fontSize: 15,
        fontWeight: 400,
        color: '#000',
        backgroundColor: '#fbfbfbd1',
    },
    arrow: {
        color: theme.palette.type === 'light' ? '#333333e3' : '#fbfbfbd1'
    }
}); })(core_1.Tooltip);
var ListboxFavorites = react_1.forwardRef(function (props, ref) {
    var classes = useStyles();
    var children = props.children, favoritePage = props.favoritePage, dados = props.dados, setDados = props.setDados, group = props.group, groupHeaderColor = props.groupHeaderColor, groupTitleColor = props.groupTitleColor;
    var pageNumber = dados.pageNumber, favoritosLength = dados.favoritosLength, direction = dados.direction, slide = dados.slide, cursor = dados.cursor;
    function retornaInicio() {
        switch (pageNumber) {
            case 1:
                return 0;
            case 2:
                return 7;
            case 3:
                return 14;
            default: return;
        }
    }
    function retornaFim() {
        switch (pageNumber) {
            case 1:
                return 7;
            case 2:
                return 14;
            case 3:
                return favoritosLength;
            default: return;
        }
    }
    function retornaArray(sectionIndex, section) {
        if (sectionIndex === 0 && favoritePage && favoritosLength > 7)
            return section.props.children[1].props.children.slice(retornaInicio(), retornaFim());
        return section.props.children[1].props.children;
    }
    function retornaEstrutura(sectionIndex, item, itemIndex) {
        var _a;
        var index = itemIndex ? itemIndex : sectionIndex;
        var content = react_1.default.createElement(exports.CustomTooltip, { title: item.props.children, arrow: true, enterDelay: '1000', enterNextDelay: '1000', placement: 'top-end', TransitionComponent: core_1.Fade, TransitionProps: { timeout: { enter: 100, exit: 500 } } },
            react_1.default.createElement(core_1.ListItem, __assign({}, item.props, { id: 'listItem', key: item.key, className: clsx_1.default(classes.listItem, (_a = {}, _a[classes.hoverListItem] = (cursor === null || cursor === void 0 ? void 0 : cursor.index) === index && (cursor === null || cursor === void 0 ? void 0 : cursor.page) === pageNumber, _a)) }),
                react_1.default.createElement(core_1.ListItemText, { primary: item.props.children, className: classes.listItemText })));
        if (sectionIndex === 0 && favoritePage && favoritosLength > 7) {
            return react_1.default.createElement(core_1.Slide, { in: slide, direction: direction }, content);
        }
        return content;
    }
    function buttonClick(evento, value) {
        evento.preventDefault();
        evento.stopPropagation();
        if (value !== pageNumber) {
            verificaSaidaSlide(value);
            setDados(function (v) { return (__assign(__assign({}, v), { slide: false })); });
            setTimeout(function () {
                setDados(function (v) { return (__assign(__assign({}, v), { pageNumber: value, direction: retornaDirection(value) })); });
                setTimeout(function () { return setDados(function (v) { return (__assign(__assign({}, v), { slide: true })); }); }, 100);
            }, 200);
        }
    }
    function verificaSaidaSlide(value) {
        var direction = '';
        if ((value === 2 || value === 3) && pageNumber === 1)
            direction = 'right';
        else if (value === 3 && pageNumber === 2)
            direction = 'right';
        else if (value === 1 && pageNumber === 2)
            direction = 'left';
        direction && setDados(function (v) { return (__assign(__assign({}, v), { direction: direction })); });
    }
    function retornaDirection(value) {
        if (value < pageNumber)
            return 'right';
        return 'left';
    }
    return react_1.default.createElement("ul", __assign({}, props, { id: 'listBox', className: clsx_1.default('MuiAutocomplete-listbox', classes.box) }), children.map(function (section, sectionIndex) {
        var _a, _b, _c;
        return (group ?
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("ul", __assign({}, props, { id: 'listBox', className: clsx_1.default('MuiAutocomplete-listbox', classes.box) }),
                    react_1.default.createElement(core_1.ListSubheader, { className: classes.subHeader, style: { backgroundColor: groupHeaderColor === null || groupHeaderColor === void 0 ? void 0 : groupHeaderColor[sectionIndex], color: groupTitleColor === null || groupTitleColor === void 0 ? void 0 : groupTitleColor[sectionIndex] } },
                        section.props.children[0].props.children,
                        react_1.default.createElement(core_1.Fade, { in: sectionIndex === 0 && favoritePage && favoritosLength > 7 },
                            react_1.default.createElement("div", { className: classes.divButton },
                                react_1.default.createElement("div", { className: classes.areaButton },
                                    react_1.default.createElement("div", { onClick: function (e) { return buttonClick(e, 1); }, className: clsx_1.default((_a = {}, _a[classes.buttonActive] = pageNumber === 1, _a), classes.button) }, "1")),
                                react_1.default.createElement("div", { className: classes.areaButton },
                                    react_1.default.createElement("div", { onClick: function (e) { return buttonClick(e, 2); }, className: clsx_1.default((_b = {}, _b[classes.buttonActive] = pageNumber === 2, _b), classes.button) }, "2")),
                                favoritosLength > 14 &&
                                    react_1.default.createElement(react_1.default.Fragment, null,
                                        react_1.default.createElement("div", { className: classes.areaButton },
                                            react_1.default.createElement("div", { onClick: function (e) { return buttonClick(e, 3); }, className: clsx_1.default((_c = {}, _c[classes.buttonActive] = pageNumber === 3, _c), classes.button) }, "3")))))),
                    retornaArray(sectionIndex, section).map(function (item, itemIndex) { return retornaEstrutura(sectionIndex, item, itemIndex); })))
            : retornaEstrutura(sectionIndex, section));
    }));
});
var AutoCompleteFavorites = function (_a) {
    var _b;
    var action = _a.action, busca = _a.busca, resposta = _a.resposta, autoSearch = _a.autoSearch, label = _a.label, value = _a.value, pgCode = _a.pgCode, favoritePage = _a.favoritePage, _c = _a.group, group = _c === void 0 ? false : _c, groupName = _a.groupName, groupHeaderColor = _a.groupHeaderColor, groupTitleColor = _a.groupTitleColor, loadingColor = _a.loadingColor, widthListBox = _a.widthListBox, filterFunction = _a.filterFunction, getOptionLabel = _a.getOptionLabel, searchParams = _a.searchParams, autoSelectFirstOption = _a.autoSelectFirstOption, _d = _a.onChange, onChange = _d === void 0 ? function (e) { return e; } : _d, _e = _a.textFieldProps, textFieldProps = _e === void 0 ? {} : _e, props = __rest(_a, ["action", "busca", "resposta", "autoSearch", "label", "value", "pgCode", "favoritePage", "group", "groupName", "groupHeaderColor", "groupTitleColor", "loadingColor", "widthListBox", "filterFunction", "getOptionLabel", "searchParams", "autoSelectFirstOption", "onChange", "textFieldProps"]);
    var classes = useStyles({ widthListBox: widthListBox });
    var _f = react_1.useState({
        lista: [],
        slide: true,
        cursor: { index: '', page: '' },
        direction: '',
        favoritosLength: '',
        pageNumber: favoritePage ? 1 : undefined,
    }), dados = _f[0], setDados = _f[1];
    var _g = react_1.useState(false), loading = _g[0], setLoading = _g[1];
    var _h = react_1.useState(''), inputValue = _h[0], setInputValue = _h[1];
    var interval = react_1.useRef(null);
    var _j = react_1.useState(1), seconds = _j[0], setSeconds = _j[1];
    var startCounter = function () { return interval.current = setInterval(function () { return setSeconds(1); }, 1000); };
    var stopCounter = function () {
        clearInterval(interval.current);
        setSeconds(0);
    };
    var setInput = function (value) {
        if (loading)
            return;
        stopCounter();
        setInputValue(value);
        autoSearch && startCounter();
    };
    function carimbaLista(lista) {
        return __awaiter(this, void 0, void 0, function () {
            var completo;
            return __generator(this, function (_a) {
                completo = [];
                lista.map(function (arr, index) {
                    index === 0 && favoritePage && setDados(function (v) { return (__assign(__assign({}, v), { favoritosLength: arr.length })); });
                    return arr.map(function (itemArr) { return itemArr.length < itemArr.length + 1 && itemArr.push(groupName[index]); });
                });
                lista.map(function (v) { return v.map(function (d) { return completo.push(d); }); });
                setDados(function (v) { return (__assign(__assign({}, v), { lista: completo })); });
                return [2 /*return*/];
            });
        });
    }
    var buscar = react_1.useCallback(function (valor) { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        var _a;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    stopCounter();
                    setLoading(true);
                    return [4 /*yield*/, api_1.serverAction(action, __assign((_a = {}, _a[busca] = valor || inputValue, _a), searchParams), true, pgCode)];
                case 1:
                    res = _c.sent();
                    if (!(((_b = res[resposta || 'result']) === null || _b === void 0 ? void 0 : _b.length) > 1 && group)) return [3 /*break*/, 3];
                    return [4 /*yield*/, carimbaLista(res[resposta || 'result'])];
                case 2:
                    _c.sent();
                    return [3 /*break*/, 4];
                case 3:
                    if (res[resposta || 'result'])
                        setDados(function (v) { return (__assign(__assign({}, v), { lista: res[resposta || 'result'] || [] })); });
                    _c.label = 4;
                case 4:
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); }, [inputValue, searchParams]);
    react_1.useEffect(function () { return autoSearch && seconds === 1 && buscar(); }, [autoSearch, seconds, buscar]);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    react_1.useEffect(function () { return lodash_1.isString(value) && buscar(value); }, []);
    react_1.useEffect(function () { var _a; return (value !== ((_a = dados.cursor) === null || _a === void 0 ? void 0 : _a.linha)) && setDados(function (v) { return (__assign(__assign({}, v), { cursor: { index: '', page: '' } })); }); }, [value, (_b = dados.cursor) === null || _b === void 0 ? void 0 : _b.linha]);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    react_1.useEffect(function () { var _a; return autoSelectFirstOption && !!inputValue.length && onChange(undefined, ((_a = dados === null || dados === void 0 ? void 0 : dados.lista) === null || _a === void 0 ? void 0 : _a[0]) || null); }, [dados.lista]);
    var keyDown = function (e) {
        ((e.key === 'Enter' || e.key === 'Tab') && !loading) && buscar();
        (e.key === 'ArrowDown' || e.key === 'ArrowUp') && selectListboxItem(e.key);
    };
    var keyUp = function (e) { return (e.key === 'Enter' || e.key === 'Tab') && e.stopPropagation(); };
    var numbersOnly = function (value) { return value.replace(/[^0-9]/g, ''); };
    var getFinder = function (v) {
        var _a;
        var elInnerText = v.innerText;
        var endIndexCode = elInnerText.indexOf('-') - 1;
        var code = elInnerText.substring(0, endIndexCode);
        var finder = ((_a = numbersOnly(code)) === null || _a === void 0 ? void 0 : _a.length) ? code : elInnerText;
        return finder;
    };
    function validateLine(value, finder, el) {
        var _a, _b, _c;
        var retorno = false;
        if (el) {
            var elIndex = parseInt((_b = (_a = el === null || el === void 0 ? void 0 : el.attributes) === null || _a === void 0 ? void 0 : _a[4]) === null || _b === void 0 ? void 0 : _b.value);
            var itemSelecionado = (_c = dados.lista) === null || _c === void 0 ? void 0 : _c[elIndex];
            if (lodash_1.isObject(itemSelecionado))
                retorno = JSON.stringify(value) === JSON.stringify(itemSelecionado) ? true : false;
            else if (lodash_1.isArray(itemSelecionado))
                retorno = value.equals(itemSelecionado) ? true : false;
        }
        else if (lodash_1.isArray(value)) {
            value.forEach(function (v) {
                if (retorno)
                    return;
                if (v && v.toString() === finder)
                    retorno = true;
            });
        }
        else if (lodash_1.isObject(value)) {
            Object.values(value).forEach(function (v) {
                if (retorno)
                    return;
                if (v && v.toString() === finder)
                    retorno = true;
            });
        }
        return retorno;
    }
    function selectListboxItem(key) {
        var _a;
        var directionIndex = key === 'ArrowDown' ? 1 : key === 'ArrowUp' ? -1 : 0;
        var itens = document.querySelectorAll('#listItem');
        var array = Array.from(itens);
        var el = '';
        var linha = '';
        var indexCapture = 0;
        if (value) {
            array.forEach(function (v, i) {
                var finder = getFinder(v);
                if (linha)
                    return;
                if (validateLine(value, finder, v)) {
                    var nextIndex = i + directionIndex;
                    if (nextIndex < array.length)
                        indexCapture = nextIndex > -1 ? nextIndex : i;
                    else
                        indexCapture = i;
                    linha = dados.lista[indexCapture];
                }
            });
            el = array[indexCapture];
        }
        if (!linha)
            linha = dados.lista[indexCapture];
        var elTop = 0;
        var elTotalHeight = 0;
        var lastScrollTop = 0;
        var elListBox = document.getElementById('listBox');
        if (el) {
            elTop = (_a = el === null || el === void 0 ? void 0 : el.getBoundingClientRect()) === null || _a === void 0 ? void 0 : _a.top;
            elTotalHeight = el.offsetHeight + el.offsetTop;
        }
        if (elListBox)
            lastScrollTop = elListBox.scrollTop;
        linha && setDados(function (v) { return (__assign(__assign({}, v), { cursor: { index: indexCapture, page: v.pageNumber, linha: linha, elTop: elTop, elTotalHeight: elTotalHeight, lastScrollTop: lastScrollTop } })); });
        if (linha !== value)
            onChange(undefined, linha);
    }
    var scrollToSelected = react_1.useCallback(function () {
        var _a, _b, _c, _d;
        var elListBox = document.getElementById('listBox');
        if (elListBox) {
            var clientHeight = elListBox === null || elListBox === void 0 ? void 0 : elListBox.clientHeight;
            if (clientHeight < ((_a = dados.cursor) === null || _a === void 0 ? void 0 : _a.elTotalHeight)) {
                var valueScrollTop = ((_b = dados.cursor) === null || _b === void 0 ? void 0 : _b.elTop) - clientHeight;
                if ((_c = dados.cursor) === null || _c === void 0 ? void 0 : _c.lastScrollTop)
                    valueScrollTop += (_d = dados.cursor) === null || _d === void 0 ? void 0 : _d.lastScrollTop;
                elListBox.scrollTop = valueScrollTop;
            }
        }
    }, [dados]);
    react_1.useEffect(function () { var _a; return ((_a = dados.lista) === null || _a === void 0 ? void 0 : _a.length) && setTimeout(function () { return scrollToSelected(); }, 0); }, [dados.lista, scrollToSelected]);
    return (react_1.default.createElement(lab_1.Autocomplete, __assign({}, props, { value: value, onChange: onChange }, { autoComplete: true, autoHighlight: true, openText: 'Abrir', clearText: 'Limpar', filterSelectedOptions: true, onInputChange: function (e) { var _a; return setInput(((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value) || ''); }, getOptionSelected: function (o, v) { return o[0] === v; }, getOptionLabel: getOptionLabel && (function (option) { return getOptionLabel(option, dados === null || dados === void 0 ? void 0 : dados.lista); }), noOptionsText: inputValue.length < 2 ? 'Digite para pesquisar' : 'Não Encontrado', options: lodash_1.isObject(value) ? dados === null || dados === void 0 ? void 0 : dados.lista.filter(function (v) { return filterFunction ? filterFunction(v, value) : true || v[0] !== value[0]; }) : dados === null || dados === void 0 ? void 0 : dados.lista, renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ margin: 'dense', variant: 'outlined', label: label }, params, textFieldProps, { onKeyUp: function (e) { return keyUp(e); }, inputProps: __assign(__assign({}, params.inputProps), { onKeyDown: function (e) { return keyDown(e); } }), InputProps: __assign(__assign(__assign({}, textFieldProps.InputProps), params.InputProps), { endAdornment: (react_1.default.createElement(react_1.default.Fragment, null,
                    params.InputProps.endAdornment,
                    react_1.default.createElement(core_1.Fade, { in: loading },
                        react_1.default.createElement(core_1.CircularProgress, { disableShrink: true, color: loadingColor || 'inherit', size: 20 })),
                    !autoSearch && react_1.default.createElement(core_1.IconButton, { size: 'small', onClick: function (e) { return buscar(); }, className: classes.searchButton },
                        react_1.default.createElement(io_1.IoIosSearch, { size: 20 })))) }) }))); }, ListboxComponent: ListboxFavorites, ListboxProps: { dados: dados, setDados: setDados, favoritePage: favoritePage, group: group, groupHeaderColor: groupHeaderColor, groupTitleColor: groupTitleColor }, PopperComponent: function (props) { return CustomPopper(props, classes); } })));
};
exports.default = AutoCompleteFavorites;
