import { IconType } from 'react-icons';

export interface BarraFerramentasProps {
  titulo?: string,
  abas?: [string, 'active' | undefined][],
  ferramentas?: [IconType, string, string | (() => void) ][][],
  habCrud?: boolean,
  habNavegador?: boolean,
  nmFuncaoVoltar?: string,
  nmCompartilhar?: string,
  linkCompartilhamento?: string,
  threads?: Array<any>,
  currentProgram?: string,
  nmSalva?: string, 
  nmExclui?: string, 
  executaFuncao?: (prm: string) => void,
  habWidget?: boolean,
  addWidget?: () => void,
  snAnotacaoPrograma: boolean,
  openAnnotations: (event: Event) => void,
  toolbarLoading: object
}

declare function BarraFerramentas(props: BarraFerramentasProps): JSX.Element

export default BarraFerramentas;