"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var fieldsRedux_1 = require("../../fieldsRedux");
var utils_1 = require("../../utils");
var api_1 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var io_1 = require("react-icons/io");
var md_1 = require("react-icons/md");
function CartaoUsuario(_a) {
    var _this = this;
    var anchor = _a.anchor, idUsuario = _a.idUsuario;
    var tempo = react_1.useRef();
    var deixaMostrar = react_1.useRef(false);
    var limpar = react_1.useRef(true);
    var idUsuarioLogado = utils_1.useStore().usuarioLogado.idUsuario;
    var _b = react_1.useState(anchor), localAnchor = _b[0], setLocalAnchor = _b[1];
    var _c = react_1.useState(idUsuario), localIdUsuario = _c[0], setLocalIdUsuario = _c[1];
    var _d = react_1.useState({}), dados = _d[0], setDados = _d[1];
    var _e = react_1.useState(false), mostrar = _e[0], setMostrar = _e[1];
    react_1.useEffect(function () {
        if (anchor && idUsuario) {
            setLocalAnchor(anchor);
            setLocalIdUsuario(idUsuario);
            deixaMostrar.current = true;
        }
        else {
            clearTimeout(tempo.current);
            deixaMostrar.current = false;
            setTimeout(function () {
                if (!limpar.current)
                    return;
                setDados({});
                setMostrar(false);
            }, 200);
        }
    }, [anchor, idUsuario, mostrar]);
    var busca = react_1.useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!localIdUsuario || !localAnchor) {
                        setMostrar(false);
                        clearTimeout(tempo.current);
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, api_1.serverAction('getInfoUsuario', { idUsuario: localIdUsuario }, 'Argous.MntUsuarios', true)];
                case 1:
                    res = _a.sent();
                    tempo.current = setTimeout(function () {
                        if (deixaMostrar.current) {
                            setDados(res);
                            setMostrar(true);
                        }
                    }, 500);
                    return [2 /*return*/];
            }
        });
    }); }, [localAnchor, localIdUsuario]);
    react_1.useEffect(function () { return void (busca()); }, [busca]);
    var retornaUser = function () {
        return { idUsuario: idUsuario, titulo: dados.dsNomeUsuario, subTitulo: dados.dsFuncaoUsuario, msgsNaoLidas: 0, online: false };
    };
    function mouseLeave() {
        setLocalAnchor(null);
        setLocalIdUsuario(null);
        clearTimeout(tempo.current);
        limpar.current = true;
    }
    function mouseEnter() {
        clearTimeout(limpar.current);
        limpar.current = false;
    }
    if (localIdUsuario && mostrar)
        return (react_1.default.createElement(core_1.Portal, null,
            react_1.default.createElement(core_1.Popper, { onClick: function (e) { return e.stopPropagation(); }, style: { zIndex: 5 }, onMouseLeave: mouseLeave, onMouseEnter: mouseEnter, open: (!!anchor || !!localAnchor) && !!dados.dsNomeUsuario, anchorEl: anchor || localAnchor },
                react_1.default.createElement(core_1.Card, { variant: 'outlined', style: { padding: '10px', maxWidth: '350px' } },
                    react_1.default.createElement(core_1.Grid, { container: true, spacing: 1 },
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 'auto' },
                            react_1.default.createElement(__1.ArgousAvatar, { style: { width: '50px', height: '50px', margin: '10px' }, nome: dados.dsNomeUsuario, idUsuario: idUsuario || localIdUsuario })),
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 'auto' },
                            react_1.default.createElement(core_1.Typography, { variant: 'h6', style: { overflow: 'hidden', width: '250px', textOverflow: 'ellipsis', whiteSpace: 'nowrap' } }, dados.dsNomeUsuario),
                            react_1.default.createElement(core_1.Typography, { variant: 'body2', style: { width: '250px' } }, dados.dsFuncaoUsuario),
                            react_1.default.createElement(core_1.Typography, { variant: 'caption', style: { width: '250px' } }, dados.dsSetor)),
                        dados.dtExclusaoUsuario ?
                            react_1.default.createElement(core_1.Typography, { variant: 'h6' },
                                "Usu\u00E1rio excluido em ",
                                dados.dtExclusaoUsuario)
                            :
                                ((idUsuario && (idUsuarioLogado !== idUsuario)) || (localIdUsuario && (idUsuarioLogado !== localIdUsuario))) &&
                                    react_1.default.createElement(react_1.default.Fragment, null,
                                        dados.nrRamalUsuario &&
                                            react_1.default.createElement(core_1.Grid, { item: true, xs: true },
                                                react_1.default.createElement(core_1.Button, { fullWidth: true, variant: 'contained', href: "tel: " + dados.nrRamalUsuario, title: "Ramal: " + dados.nrRamalUsuario },
                                                    react_1.default.createElement(io_1.IoIosCall, null),
                                                    "\u00A0",
                                                    dados.nrRamalUsuario)),
                                        react_1.default.createElement(core_1.Grid, { item: true, xs: true },
                                            react_1.default.createElement(core_1.Button, { fullWidth: true, variant: 'contained', href: "mailto: " + dados.dsEmailUsuario, title: dados.dsEmailUsuario },
                                                react_1.default.createElement(md_1.MdMail, null),
                                                "\u00A0Email")),
                                        react_1.default.createElement(core_1.Grid, { item: true, xs: true },
                                            react_1.default.createElement(core_1.Button, { fullWidth: true, variant: 'contained', onClick: function () { return fieldsRedux_1.setAnotherProgramField('janelaChatOpen', retornaUser(), 'argousSystem'); }, title: 'Abrir chat de conversa' },
                                                react_1.default.createElement(md_1.MdMessage, null),
                                                "\u00A0Mensagem"))))))));
    return null;
}
exports.default = CartaoUsuario;
