"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../../api/index");
var index_2 = require("../../utils/index");
var core_1 = require("@material-ui/core");
var lab_1 = require("@material-ui/lab");
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var useStyles = core_1.makeStyles({
    fundoCompartilhar: {
        width: '500px',
        padding: '20px',
        marginTop: 5,
    }
});
var Compartilhar = react_1.forwardRef(function (props, ref) {
    var _a = react_1.useState(''), metodoCompartilhar = _a[0], setMetodoCompartilhar = _a[1];
    var _b = react_1.useState(''), mensagemEmail = _b[0], setMensagemEmail = _b[1];
    var _c = react_1.useState([]), email = _c[0], setEmail = _c[1];
    var _d = react_1.useState(''), stringEmail = _d[0], setStringEmail = _d[1];
    var _f = react_1.useState([]), notificacao = _f[0], setNotificacao = _f[1];
    var _g = react_1.useState(''), stringNotificacao = _g[0], setStringNotificacao = _g[1];
    var _h = react_1.useState(''), mensagemNotificação = _h[0], setMensagemNotificacao = _h[1];
    var link = props.linkCompartilhamento;
    var _j = react_1.useState(false), copiado = _j[0], setCopiado = _j[1];
    var _k = react_1.useState(false), enviado = _k[0], setEnviado = _k[1];
    var _l = react_1.useState([]), options = _l[0], setOptions = _l[1];
    var erroVazio = { email: '', stringEmail: '', notificacao: '', stringNotificacao: '' };
    var _m = react_1.useState(erroVazio), erro = _m[0], setErro = _m[1];
    var classes = useStyles();
    function copiarParaAreaDeTransferencia() {
        var link = document.getElementById('link');
        link.select();
        link.setSelectionRange(0, 99999);
        document.execCommand('copy');
        setCopiado(true);
        setTimeout(function () {
            setCopiado(false);
        }, 3500);
    }
    react_1.useEffect(function () {
        if (stringEmail.length < 3 && stringNotificacao.length < 3)
            return;
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, index_1.searchUsers({ dsFiltroNome: metodoCompartilhar === 'email' ? stringEmail : stringNotificacao })];
                    case 1:
                        res = _a.sent();
                        if (res.status) {
                            setOptions(res.users);
                        }
                        else
                            index_2.setError(res.dsErro);
                        return [2 /*return*/];
                }
            });
        }); })();
    }, [stringEmail, stringNotificacao, metodoCompartilhar]);
    function enviaCompartilhamento(tpComp) {
        return __awaiter(this, void 0, void 0, function () {
            var temp, not, mail, dados, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        temp = false;
                        if (tpComp === 'E') {
                            if (email.length === 0 && mensagemEmail === '') {
                                setErro(__assign(__assign({}, erro), { email: 'Campo Obrigatório', stringEmail: 'Campo Obrigatório' }));
                                temp = true;
                            }
                            else {
                                if (email.length === 0) {
                                    setErro(__assign(__assign({}, erro), { email: 'Campo Obrigatório' }));
                                    temp = true;
                                }
                                if (mensagemEmail === '') {
                                    setErro(__assign(__assign({}, erro), { stringEmail: 'Campo Obrigatório' }));
                                    temp = true;
                                }
                            }
                        }
                        else if (notificacao.length === 0 && mensagemNotificação === '') {
                            setErro(__assign(__assign({}, erro), { notificacao: 'Campo Obrigatório', stringNotificacao: 'Campo Obrigatório' }));
                            temp = true;
                        }
                        else if (notificacao.length === 0) {
                            setErro(__assign(__assign({}, erro), { notificacao: 'Campo Obrigatório' }));
                            temp = true;
                        }
                        else if (mensagemNotificação === '') {
                            setErro(__assign(__assign({}, erro), { stringNotificacao: 'Campo Obrigatório' }));
                            temp = true;
                        }
                        if (temp)
                            return [2 /*return*/];
                        not = notificacao.map(function (item) { return item[0]; });
                        mail = email.map(function (item) { return item[0]; });
                        dados = {
                            mensagem: mensagemNotificação || mensagemEmail,
                            usuarios: not.length > 0 ? not : mail,
                            tpMensagem: tpComp,
                            link: link
                        };
                        return [4 /*yield*/, index_1.enviaCompartilhamentoDePrograma(dados)];
                    case 1:
                        res = _a.sent();
                        if (res.status) {
                            setNotificacao([]);
                            setEmail([]);
                            setMensagemEmail('');
                            setStringEmail('');
                            setStringNotificacao('');
                            setMensagemNotificacao('');
                            setEnviado(true);
                            setTimeout(function () {
                                setEnviado(false);
                            }, 3500);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    return (react_1.default.createElement(core_1.Grid, { innerRef: ref, className: classes.fundoCompartilhar, component: core_1.Paper, elevation: 2, onClick: function (e) { return e.stopPropagation(); } },
        react_1.default.createElement(core_1.Grid, { container: true, spacing: 2, style: { position: 'relative', padding: '6px 12px', display: 'flex' }, justifyContent: 'center' },
            react_1.default.createElement(core_1.Typography, { component: 'h3', style: { fontSize: '24px', textAlign: 'center', marginTop: '0px' } }, "Compartilhar"),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12, className: 'row' },
                react_1.default.createElement(core_1.TextField, { label: 'Link', value: link, readOnly: true, id: 'link', fullWidth: true, variant: 'outlined', margin: 'dense', InputProps: {
                        endAdornment: (react_1.default.createElement(core_1.InputAdornment, { position: 'end' },
                            react_1.default.createElement(core_1.IconButton, { onClick: function () { return copiarParaAreaDeTransferencia(); }, title: 'Copiar Link' },
                                react_1.default.createElement(md_1.MdLink, null)))),
                    } }),
                react_1.default.createElement(core_1.Collapse, { in: copiado },
                    react_1.default.createElement(core_1.Typography, { variant: 'body2', component: 'div', color: 'primary' }, "Link copiado para a \u00E1rea de transfer\u00EAncia!"))),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 6, style: { display: 'flex', justifyContent: 'center' } },
                react_1.default.createElement(core_1.IconButton, { size: 'medium', title: 'Enviar link por notifica\u00E7\u00E3o', onClick: function () {
                        setErro(erroVazio);
                        setEmail([]);
                        setStringEmail('');
                        setMetodoCompartilhar(metodoCompartilhar === 'notificacao' ? '' : 'notificacao');
                    } },
                    react_1.default.createElement(core_1.Typography, { component: 'span', variant: 'body1', className: 'icon-linecons-megaphone icon-lg', style: {
                            fontSize: '45px',
                            width: '75px',
                            height: '75px',
                            color: 'white',
                            background: '#009C6A',
                            borderRadius: '50px',
                            border: '5px solid #33b088',
                        } }))),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 6, style: { display: 'flex', justifyContent: 'center' } },
                react_1.default.createElement(core_1.IconButton, { size: 'medium', title: 'Enviar link por email', onClick: function () {
                        setErro(erroVazio);
                        setNotificacao([]);
                        setStringNotificacao('');
                        setMetodoCompartilhar(metodoCompartilhar === 'email' ? '' : 'email');
                    } },
                    react_1.default.createElement(core_1.Typography, { component: 'span', variant: 'body1', className: 'glyph-icon icon-envelope icon-lg', style: {
                            fontSize: '45px',
                            width: '75px',
                            height: '75px',
                            color: 'white',
                            background: '#009C6A',
                            borderRadius: '50px',
                            border: '5px solid #33b088',
                        } }))),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 6, style: { display: 'flex', justifyContent: 'center', paddingTop: 0, marginBottom: '5px' } },
                react_1.default.createElement(core_1.Typography, { component: 'label', variant: 'body1' }, "Notifica\u00E7\u00E3o")),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 6, style: { display: 'flex', justifyContent: 'center', paddingTop: 0, marginBottom: '5px' } },
                react_1.default.createElement(core_1.Typography, { component: 'label', variant: 'body1' }, "Email")),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12, style: { padding: 0 } },
                react_1.default.createElement(core_1.Collapse, { in: metodoCompartilhar === 'notificacao' },
                    react_1.default.createElement(core_1.Grid, { container: true, spacing: 2 },
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                            react_1.default.createElement(lab_1.Autocomplete, { multiple: true, value: notificacao, options: options, getOptionLabel: function (option) { return index_2.formataNome(option[1]); }, size: 'small', limitTags: 1, onChange: function (_e, value) { return setNotificacao(value); }, disableCloseOnSelect: true, disablePortal: true, noOptionsText: stringEmail.length < 3 && stringNotificacao.length < 3 ? 'Digite para começar a pesquisar' : 'Não Encontrado', renderTags: function (value, getTagProps) { return (value.map(function (option, index) { return (react_1.default.createElement(core_1.Chip, __assign({ variant: 'outlined', label: option[1] || option }, getTagProps({ index: index })))); })); }, renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ variant: 'outlined', margin: 'dense', label: 'Contatos:', onChange: function (e) { return setStringNotificacao(e.target.value); }, placeholder: notificacao.length === 0 ? 'Selecionar' : undefined, InputLabelProps: { shrink: true }, error: !!erro.notificacao, helperText: erro.notificacao }, params))); } })),
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                            react_1.default.createElement(core_1.TextField, { variant: 'outlined', margin: 'dense', label: 'Mensagem:', placeholder: 'Mensagem da Notifica\u00E7\u00E3o', fullWidth: true, value: mensagemNotificação, onChange: function (e) { return setMensagemNotificacao(e.target.value); }, error: !!erro.stringNotificacao, helperText: erro.stringNotificacao })),
                        react_1.default.createElement(core_1.Grid, { container: true, style: { display: 'flex ' }, direction: 'row-reverse' },
                            react_1.default.createElement(core_1.Grid, { item: true, xs: 2 },
                                react_1.default.createElement(core_1.Button, { color: 'primary', variant: 'contained', onClick: function () { return enviaCompartilhamento('N'); } }, "Enviar")),
                            react_1.default.createElement(core_1.Grid, { item: true, xs: 10 },
                                react_1.default.createElement(core_1.Collapse, { in: enviado },
                                    react_1.default.createElement(core_1.Typography, { variant: 'body2', component: 'div', color: 'primary' }, "Link enviado com sucesso!"))))))),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12, style: { padding: 0 } },
                react_1.default.createElement(core_1.Collapse, { in: metodoCompartilhar === 'email' },
                    react_1.default.createElement(core_1.Grid, { container: true, spacing: 2 },
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                            react_1.default.createElement(lab_1.Autocomplete, { multiple: true, freeSolo: true, value: email, options: options, getOptionLabel: function (option) { return option[2]; }, size: 'small', limitTags: 1, onChange: function (_e, value) { return setEmail(value); }, disableCloseOnSelect: true, disablePortal: true, noOptionsText: stringEmail.length < 3 && stringNotificacao.length < 3 ? 'Digite para começar a pesquisar' : 'Não Encontrado', renderTags: function (value, getTagProps) { return (value.map(function (option, index) { return (react_1.default.createElement(core_1.Chip, __assign({ variant: 'outlined', label: option[2] || option }, getTagProps({ index: index })))); })); }, renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ variant: 'outlined', margin: 'dense', label: 'Emails:', onChange: function (e) { return setStringEmail(e.target.value); }, placeholder: email.length === 0 ? 'Selecionar' : undefined, InputLabelProps: { shrink: true }, error: !!erro.email, helperText: erro.email }, params))); } })),
                        react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                            react_1.default.createElement(core_1.TextField, { multiline: true, label: 'Mensagem:', minRows: '2', margin: 'dense', variant: 'outlined', fullWidth: true, placeholder: 'Mensagem do Email', value: mensagemEmail, onChange: function (e) { return setMensagemEmail(e.target.value); }, style: { resize: 'vertical', height: '50px' }, error: !!erro.stringEmail, helperText: erro.stringEmail })),
                        react_1.default.createElement(core_1.Grid, { container: true, style: { display: 'flex' }, direction: 'row-reverse' },
                            react_1.default.createElement(core_1.Grid, { item: true, xs: 2 },
                                react_1.default.createElement(core_1.Button, { color: 'primary', variant: 'contained', onClick: function () { return enviaCompartilhamento('E'); } }, "Enviar")),
                            react_1.default.createElement(core_1.Grid, { item: true, xs: 10 },
                                react_1.default.createElement(core_1.Collapse, { in: enviado },
                                    react_1.default.createElement(core_1.Typography, { variant: 'body2', component: 'div', color: 'primary' }, "Link enviado com sucesso!"))))))))));
});
exports.default = Compartilhar;
