"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importDefault(require("react"));
var BasicModal = function (_a) {
    var _b = _a.okLabel, okLabel = _b === void 0 ? 'Ok' : _b, _c = _a.cancelLabel, cancelLabel = _c === void 0 ? 'Cancelar' : _c, _d = _a.title, title = _d === void 0 ? '' : _d, _e = _a.description, description = _e === void 0 ? '' : _e, open = _a.open, proceed = _a.proceed, dialogProps = _a.dialogProps, cancel = _a.cancel;
    return (react_1.default.createElement(core_1.Dialog, __assign({ open: open, onClose: function () { return cancel(false); } }, dialogProps),
        react_1.default.createElement(core_1.DialogTitle, null, title),
        react_1.default.createElement(core_1.DialogContent, null,
            react_1.default.createElement(core_1.DialogContentText, { component: 'div' }, description)),
        react_1.default.createElement(core_1.DialogActions, null,
            react_1.default.createElement(core_1.Button, { variant: 'contained', color: 'secondary', onClick: function () { return proceed(false); } }, cancelLabel),
            react_1.default.createElement(core_1.Button, { variant: 'contained', color: 'primary', onClick: function () { return proceed(true); } }, okLabel))));
};
exports.default = BasicModal;
