import { DialogProps } from '@material-ui/core';
import React from 'react';
export interface WrapperModalProps {
    okLabel: React.ReactNode;
    cancelLabel: React.ReactNode;
    title: React.ReactNode;
    dialogProps: Omit<DialogProps, 'open'>;
    /**
     * @ignore
     */
    proceed: Function;
    /**
     * @ignore
     */
    open: boolean;
}
declare const WrapperModal: (Component: (props: any) => JSX.Element) => ({ proceed, open, title, cancelLabel, okLabel, dialogProps, ...props }: WrapperModalProps) => React.JSX.Element;
export default WrapperModal;
