"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Icons = exports.IconsComponent = void 0;
var api_1 = require("../../api");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var reqSvgs = require.context('./icons', true, /\.svg$/);
var loadSvg = function (svg, path) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b, _c;
    var _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                _d = {};
                _a = path.replace(/.\/|.svg/g, '');
                _c = (_b = URL).createObjectURL;
                return [4 /*yield*/, fetch((svg === null || svg === void 0 ? void 0 : svg.default) || svg)];
            case 1: return [4 /*yield*/, (_e.sent()).blob()];
            case 2: return [2 /*return*/, (_d[_a] = _c.apply(_b, [_e.sent()]), _d)];
        }
    });
}); };
var iconClasses = {
    'application/pdf': 'pdf',
    'application/msword': 'doc',
    'application/vnd.ms-word': 'doc',
    'application/vnd.oasis.opendocument.text': 'doc',
    'application/vnd.openxmlformats-officedocument.wordprocessingml': 'doc',
    'application/vnd.ms-excel': 'xls',
    'application/vnd.openxmlformats-officedocument.spreadsheetml': 'xls',
    'application/vnd.oasis.opendocument.spreadsheet': 'xls',
    'application/vnd.ms-powerpoint': 'ppt',
    'application/vnd.openxmlformats-officedocument.presentationml': 'ppt',
    'application/vnd.oasis.opendocument.presentation': 'ppt',
    'text/rtf': 'rtf',
    'text/plain': 'txt',
    'text/html': 'html',
    'text/css': 'css',
    'text/csv': 'csv',
    'application/json': 'json',
    'image/vnd.adobe.photoshop': 'psd',
    'image/photoshop': 'psd',
    'image/x-photoshop': 'psd',
    'image/psd': 'psd',
    'application/photoshop': 'psd',
    'application/psd': 'psd',
    'zz-application/zz-winassoc-psd': 'psd',
    'video/x-msvideo': 'avi',
    'application/gzip': 'zip1',
    'application/zip': 'zip',
    'application/acad': 'dwg',
    'image/vnd.dwg': 'dwg',
    'image/x-dwg': 'dwg',
    'application/octet-stream': 'exe',
    'audio/flac': 'fla',
    'image/jpeg': 'jpg',
    'image/jpg': 'jpg',
    'text/javascript': 'js',
    'audio/mpeg': 'mp3',
    'video/mpeg': 'mp4',
    'audio/mp4': 'mp4',
    'image/png': 'png',
    'application/xml': 'xml',
    'application/x-7z-compressed': 'zip1',
    'application/x-compressed-tar': 'zip1',
    'application/vnd.rar': 'zip1',
    'modelo/contrato': 'mod',
    image: 'image',
    audio: 'audio',
    video: 'video'
};
var icones;
(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, Promise.all(reqSvgs.keys()
                    .map(function (path) { return loadSvg(reqSvgs(path), path); }))];
            case 1: return [4 /*yield*/, (_a.sent()).reduce(function (acc, item) { return (__assign(__assign({}, acc), item)); }, {})];
            case 2:
                icones = _a.sent();
                return [2 /*return*/];
        }
    });
}); })();
// eslint-disable-next-line valid-jsdoc
/**
 * @typedef {'ai'|'audio'|'avi'|'css'|'csv'|'dbf'|'doc'|'dwg'|'exe'|'file'|'fla'|'html'|'image'|'iso'|'jpg'|'js'|'json'|'mod'|'mp3'|'mp4'|'pdf'|'png'|'ppt'|'psd'|'rtf'|'search'|'svg'|'txt'|'video'|'xls'|'xml'|'zip'|'zip1'} Extencoes
 *
 * @typedef {object} Tipos
 * @property {Extencoes} type - Tipos de arquivos suportados
 * @property {string} mimeType - MimeType do arquivo
 * @property {string} fileName - Nome do arquivo
 *
 * @param {React.ImgHTMLAttributes<HTMLImageElement> & Tipos} props - props
 * @returns {JSX.Element} retorno
 */
var IconsComponent = function (_a) {
    var type = _a.type, fileName = _a.fileName, mimeType = _a.mimeType, idDocumento = _a.idDocumento, link = _a.link, props = __rest(_a, ["type", "fileName", "mimeType", "idDocumento", "link"]);
    /** @type {[FileIcons, React.Dispatch<FileIcons>]} */
    var _b = react_1.useState(icones), state = _b[0], setState = _b[1];
    var _c = react_1.useState(), preview = _c[0], setPreview = _c[1];
    var setarState = react_1.useCallback(function () {
        if (state)
            return;
        if (icones)
            setState(icones);
        else
            setTimeout(setarState, 200);
    }, [state]);
    react_1.useEffect(setarState, [setarState]);
    var selectedImage = react_1.useMemo(function () {
        var _a;
        if (type)
            return type;
        /** @type {Extencoes} */
        var extension = (_a = fileName === null || fileName === void 0 ? void 0 : fileName.match(/\.([^.]*)$/)) === null || _a === void 0 ? void 0 : _a.at(1);
        if (!state)
            return '';
        if (Object.keys(state).includes(extension))
            return extension;
        for (var key in iconClasses)
            if (Object.prototype.hasOwnProperty.call(iconClasses, key))
                if ((mimeType === null || mimeType === void 0 ? void 0 : mimeType.search(key)) === 0)
                    return iconClasses[key];
        return 'file';
    }, [type, mimeType, fileName, state]);
    var buscaImagemPreview = react_1.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var file, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(idDocumento && (mimeType === null || mimeType === void 0 ? void 0 : mimeType.includes('image')))) return [3 /*break*/, 3];
                    _a = api_1.getFileFromLink;
                    return [4 /*yield*/, api_1.getLink(idDocumento)];
                case 1: return [4 /*yield*/, _a.apply(void 0, [_b.sent()])];
                case 2:
                    file = _b.sent();
                    setPreview(file);
                    _b.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    }); }, [mimeType, idDocumento]);
    react_1.useEffect(function () { return void (buscaImagemPreview()); }, [buscaImagemPreview]);
    if (!state)
        return react_1.default.createElement(core_1.CircularProgress, { disableShrink: true });
    return react_1.default.createElement(react_1.default.Fragment, null, (preview) ? (react_1.default.createElement("img", __assign({ src: preview, alt: type }, props, { style: { position: 'absolute', left: 0, right: 0, top: 0, bottom: 0, width: '100%', height: '100%', objectFit: 'contain' } }))) : (react_1.default.createElement("img", __assign({ src: state[selectedImage], alt: type }, props))));
};
exports.IconsComponent = IconsComponent;
/**
 * @typedef {object} FileIcons - Objeto de icones
 * @property {JSX.Element} ai -Icone de arquivos do Ilustrator
 * @property {JSX.Element} audio -Icone genérico de Audio
 * @property {JSX.Element} avi -Icone de videos AVI
 * @property {JSX.Element} css -Icone de arquivos CSS
 * @property {JSX.Element} csv -Icone de arquivos CSV
 * @property {JSX.Element} dbf -Icone de arquivos DBF
 * @property {JSX.Element} doc -Icone de arquivos Word
 * @property {JSX.Element} dwg -Icone de arquivos DWG
 * @property {JSX.Element} exe -Icone de arquivos EXE
 * @property {JSX.Element} file -Icone de arquivos genéricos
 * @property {JSX.Element} fla -Icone de arquivos FLA
 * @property {JSX.Element} html -Icone de arquivos HTML
 * @property {JSX.Element} image -Icone genérico de Imagens
 * @property {JSX.Element} iso -Icone de imagens ISO
 * @property {JSX.Element} jpg -Icone de imagens JPG
 * @property {JSX.Element} js -Icone de arquivos Javascript
 * @property {JSX.Element} json -Icone de arquivos JSON
 * @property {JSX.Element} mod -Icone de modelos de documentos
 * @property {JSX.Element} mp3 -Icone de músicas MP3
 * @property {JSX.Element} mp4 -Icone de vídeos MP4
 * @property {JSX.Element} pdf -Icone de arquivos PDP
 * @property {JSX.Element} png -Icone de imagens PNG
 * @property {JSX.Element} ppt -Icone de arquivos do Power Point
 * @property {JSX.Element} psd -Icone de arquivos do Photoshop
 * @property {JSX.Element} rtf -Icone de arquivos RTF
 * @property {JSX.Element} search -Icone genérico de Busca
 * @property {JSX.Element} svg -Icone de arquivos SVG
 * @property {JSX.Element} txt -Icone de arquivos de Texto
 * @property {JSX.Element} video -Icone genérico de Vídeo
 * @property {JSX.Element} xls -Icone de arquivos do Excel
 * @property {JSX.Element} xml -Icone de arquivos XML
 * @property {JSX.Element} zip -Icone de arquivos ZIP
 * @property {JSX.Element} zip1 -Icone genérico de arquivos comprimidos
 */
/** @type {FileIcons}  */
exports.Icons = reqSvgs.keys().reduce(function (images, path) {
    var key = path.replace(/.\/|.svg/g, '');
    images[key] = react_1.default.createElement(exports.IconsComponent, { type: key });
    return images;
}, {});
exports.default = exports.Icons;
