"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Visualizacao_1 = __importDefault(require("./Visualizacao"));
var index_1 = require("../../utils/index");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var ModalVisualizacaoDocumentos = function (_a) {
    var open = _a.open, proceed = _a.proceed, tokenSistema = _a.tokenSistema, props = __rest(_a, ["open", "proceed", "tokenSistema"]);
    var _b = react_1.useState(props), visualizando = _b[0], setVisualizando = _b[1];
    return (react_1.default.createElement(core_1.Dialog, { fullScreen: true, open: open, onClose: function () { return proceed(undefined); }, onKeyDown: index_1.stopPrntScr, onContextMenu: function (e) { return e.preventDefault(); } },
        react_1.default.createElement(core_1.AppBar, { style: { position: 'relative' } },
            react_1.default.createElement(core_1.Toolbar, null,
                react_1.default.createElement(core_1.IconButton, { edge: 'start', color: 'inherit', onClick: function () { return proceed(undefined); } },
                    react_1.default.createElement(md_1.MdClose, null)),
                react_1.default.createElement(core_1.Typography, { variant: 'h6', style: { flexGrow: '1' } }, visualizando === null || visualizando === void 0 ? void 0 : visualizando.nome),
                !(visualizando === null || visualizando === void 0 ? void 0 : visualizando.sensible) && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(core_1.IconButton, { onClick: function (_) {
                            var _a;
                            if (!((_a = visualizando === null || visualizando === void 0 ? void 0 : visualizando.linkPronto) === null || _a === void 0 ? void 0 : _a.length)) {
                                index_1.geraLog(visualizando.idDocumento, 'Impressão do documento', '3', tokenSistema);
                            }
                            index_1.printUrl(visualizando.URL ? visualizando.URL : visualizando.linkPronto);
                        }, color: 'inherit', title: 'Imprimir arquivo' },
                        react_1.default.createElement(md_1.MdPrint, null)),
                    react_1.default.createElement(core_1.IconButton, { onClick: function () {
                            var _a;
                            if (!((_a = visualizando === null || visualizando === void 0 ? void 0 : visualizando.linkPronto) === null || _a === void 0 ? void 0 : _a.length)) {
                                index_1.geraLog(visualizando.idDocumento, 'Download do documento', '3', tokenSistema);
                                index_1.downloadFromUrl(visualizando === null || visualizando === void 0 ? void 0 : visualizando.URL, visualizando === null || visualizando === void 0 ? void 0 : visualizando.nome);
                            }
                            else {
                                index_1.downloadBase64(visualizando === null || visualizando === void 0 ? void 0 : visualizando.linkPronto, visualizando === null || visualizando === void 0 ? void 0 : visualizando.nome);
                            }
                        }, color: 'inherit', title: 'Baixar arquivo' },
                        react_1.default.createElement(md_1.MdFileDownload, null)))))),
        react_1.default.createElement(core_1.Box, { display: 'flex', justifyContent: 'center', alignItems: 'center', width: '100%', height: '100%' },
            react_1.default.createElement(Visualizacao_1.default, __assign({}, __assign(__assign({ setVisualizando: setVisualizando }, visualizando), { tokenSistema: tokenSistema, proceed: proceed }))))));
};
exports.default = ModalVisualizacaoDocumentos;
