"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../../api");
var api_2 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var lab_1 = require("@material-ui/lab");
var clsx_1 = __importDefault(require("clsx"));
var immer_1 = require("immer");
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var useStyles = core_1.makeStyles(function (_theme) { return ({
    tag: {
        margin: 3,
        maxWidth: 'calc(100% - 6px)',
    },
    inputRoot: {
        flexWrap: 'wrap',
        '$hasPopupIcon &, $hasClearIcon &': {
            paddingRight: 26 + 4,
        },
        '$hasPopupIcon$hasClearIcon &': {
            paddingRight: 52 + 4,
        },
        '& $input': {
            width: 0,
            minWidth: 30,
        },
        '&[class*="MuiInput-root"]': {
            paddingBottom: 1,
            '& $input': {
                padding: 4,
            },
            '& $input:first-child': {
                padding: '6px 0',
            },
        },
        '&[class*="MuiOutlinedInput-root"]': {
            padding: 9,
            paddingRight: 26 + 4 + 9,
            '$hasClearIcon &': {
                paddingRight: 52 + 4 + 9,
            },
            '& $input': {
                padding: '9.5px 4px',
            },
            '& $input:first-child': {
                paddingLeft: 6,
            },
            '& $endAdornment': {
                right: 9,
            },
        },
        '&[class*="MuiOutlinedInput-root"][class*="MuiOutlinedInput-marginDense"]': {
            padding: 6,
            '& $input': {
                padding: '4.5px 4px',
            },
        },
    },
    input: {
        flexGrow: 1,
        textOverflow: 'ellipsis',
        opacity: 0,
    },
    inputFocused: {
        opacity: 1,
    },
    clearIndicator: {
        marginRight: -2,
        padding: 4,
        visibility: 'hidden',
    },
    clearIndicatorDirty: {},
    root: {
        display: 'flex',
        flexGrow: 1,
        '&$focused $clearIndicatorDirty': {
            visibility: 'visible',
        },
        '@media (pointer: fine)': {
            '&:hover $clearIndicatorDirty': {
                visibility: 'visible',
            },
        },
    },
    loading: {},
    endAdornment: {
        position: 'absolute',
        right: 0,
        top: 'calc(50% - 24px)',
        '$loading &': {
            top: 'calc(50% - 14px)',
        },
    },
    rename: {
        borderRadius: 10,
        padding: '5px !important'
    }
}); });
var FilePreparer = function (_a, ref) {
    var _b, _c, _d;
    var onChange = _a.onChange, TextFieldProps = _a.TextFieldProps, placeholder = _a.placeholder, label = _a.label, multiple = _a.multiple, ChipProps = _a.ChipProps, disabled = _a.disabled, fileInputProps = _a.fileInputProps, valuePlaceHolder = _a.valuePlaceHolder, concat = _a.concat, _e = _a.initialFiles, initialFiles = _e === void 0 ? [] : _e, props = __rest(_a, ["onChange", "TextFieldProps", "placeholder", "label", "multiple", "ChipProps", "disabled", "fileInputProps", "valuePlaceHolder", "concat", "initialFiles"]);
    var classes = useStyles();
    var inputRef = react_1.useRef();
    var _f = react_1.useState(false), loading = _f[0], setLoading = _f[1];
    var _g = react_1.useState(initialFiles), files = _g[0], setFiles = _g[1];
    var _h = react_1.useState(), motivo = _h[0], setMotivo = _h[1];
    react_1.useEffect(function () {
        if (valuePlaceHolder && !multiple)
            setFiles(function (f) { return [__assign(__assign({}, f[0]), { name: valuePlaceHolder })]; });
    }, [valuePlaceHolder, multiple]);
    var handleChange = function (_, v, reason) {
        setMotivo(reason);
        inputRef.current.value = '';
        setFiles(v || []);
        onChange && onChange(multiple ? v || [] : (v || [])[0], motivo);
    };
    var preparaArquivo = react_1.useCallback(function (file) { return __awaiter(void 0, void 0, void 0, function () {
        var reqs, i, res, resps;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!file)
                        return [2 /*return*/];
                    setLoading(true);
                    reqs = [];
                    if (file.map)
                        reqs = file;
                    else
                        for (i = 0; i < file.length; i++)
                            reqs.push(file[i]);
                    return [4 /*yield*/, Promise.all(reqs.map(function (item) { return api_1.prepareFile(item.fileObject || item); }))];
                case 1:
                    res = _a.sent();
                    resps = [];
                    res.forEach(function (item, i) {
                        if (item.idRecebimento)
                            resps.push(__assign(__assign({}, item), { path: file[i].fullPath }));
                        else
                            api_2.setError(item.dsErro);
                    });
                    setFiles(function (f) { return concat && multiple ? (__spreadArray(__spreadArray([], f), resps)) : resps; });
                    setLoading(false);
                    onChange && onChange(multiple ? concat ? __spreadArray(__spreadArray([], files), resps) : resps : resps[0], motivo);
                    return [2 /*return*/];
            }
        });
    }); }, [concat, files, motivo, multiple, onChange]);
    // useUpdateEffect(() => {
    //   onChange && onChange(multiple ? files : files[0], motivo);
    //   setMotivo(undefined);
    // }, [files]);
    react_1.useImperativeHandle(ref, function () { return ({ preparaArquivo: preparaArquivo, loading: loading, setLoading: setLoading, setFiles: setFiles }); }, [preparaArquivo, loading]);
    var _j = lab_1.useAutocomplete({
        value: files,
        inputValue: files.length ? '' : placeholder || 'Selecione um arquivo',
        options: [],
        onChange: handleChange,
        multiple: true,
        componentName: 'FilePreparer'
    }), getInputProps = _j.getInputProps, getTagProps = _j.getTagProps, setAnchorEl = _j.setAnchorEl, focusedTag = _j.focusedTag, getClearProps = _j.getClearProps, dirty = _j.dirty;
    var _k = react_1.useState(), editando = _k[0], setEditando = _k[1];
    var handleEditing = function (index) { return function (e) {
        e.stopPropagation();
        if (files[index].idRecebimento)
            setEditando(index);
    }; };
    var handleRename = function (e) {
        setFiles(immer_1.produce(function (file) { return void (file[editando].name = e.target.value); }));
        setEditando(undefined);
    };
    var handleClick = function () { return !loading && !files.length && !disabled && inputRef.current.click(); };
    return (react_1.default.createElement("div", __assign({ className: clsx_1.default(classes.root, (_b = {}, _b[classes.loading] = loading, _b)) }, props),
        react_1.default.createElement("input", __assign({ ref: inputRef, type: 'file' }, { multiple: multiple }, { onChange: function (e) { var _a, _b; return ((_b = (_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.files) === null || _b === void 0 ? void 0 : _b.length) && preparaArquivo(e.target.files); }, style: { display: 'none' } }, fileInputProps)),
        react_1.default.createElement(core_1.TextField, __assign({ ref: setAnchorEl, variant: 'outlined', label: label || 'Arquivo', margin: 'dense', onClick: handleClick, style: { flexGrow: '1' }, InputProps: {
                readOnly: true,
                startAdornment: files.length > 0 ?
                    files.map(function (option, index) { return editando === index ? (react_1.default.createElement(core_1.FilledInput, { className: classes.rename, defaultValue: option.name, autoFocus: true, onBlur: handleRename, multiline: true, disableUnderline: true })) : (react_1.default.createElement(core_1.Chip, __assign({ className: clsx_1.default(classes.tag), label: option.name, onClick: handleEditing(index), clickable: true }, __assign({ disabled: disabled }, ChipProps), getTagProps({ index: index })))); }) : undefined,
                className: classes.inputRoot,
                endAdornment: react_1.default.createElement("div", { className: classes.endAdornment }, loading ? react_1.default.createElement(core_1.CircularProgress, { disableShrink: true, size: 24 }) : react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(core_1.IconButton, __assign({ disabled: disabled }, getClearProps(), { className: clsx_1.default(classes.clearIndicator, (_c = {},
                            _c[classes.clearIndicatorDirty] = dirty,
                            _c)) }),
                        react_1.default.createElement(md_1.MdClear, null)),
                    react_1.default.createElement(core_1.IconButton, { disabled: disabled, onClick: function (e) {
                            e.stopPropagation();
                            inputRef.current.click();
                        } },
                        react_1.default.createElement(md_1.MdAttachment, null))))
            }, inputProps: __assign({ className: clsx_1.default(classes.input, (_d = {},
                    _d[classes.inputFocused] = focusedTag === -1,
                    _d)), disabled: disabled }, getInputProps()) }, TextFieldProps))));
};
exports.default = react_1.forwardRef(FilePreparer);
