"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var MaterialButton_1 = __importDefault(require("../../components/MaterialButton"));
var utils_1 = require("../../utils");
var store_1 = require("../../utils/store");
var moment_1 = __importDefault(require("@date-io/moment"));
var core_1 = require("@material-ui/core");
var Autocomplete_1 = __importDefault(require("@material-ui/lab/Autocomplete"));
var pickers_1 = require("@material-ui/pickers");
var lodash_1 = require("lodash");
var moment_2 = __importDefault(require("moment"));
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var use_immer_1 = require("use-immer");
var reducer = function (state, _a) {
    if (state === void 0) { state = {}; }
    var fase = _a.fase, documento = _a.documento, field = _a.field, value = _a.value;
    state[fase][documento][field] = value;
};
var init = function (initialValues) { return function (initialState) {
    if (lodash_1.isArray(initialValues) && !lodash_1.isArray(initialValues[0])) {
        return initialState.map(function (fase, i) { return fase.map(function (_, j) { return initialValues[i].documentos[j].values; }); });
    }
    return initialValues;
}; };
var FormVisualizer = function (_a) {
    var _b = _a.json, json = _b === void 0 ? {} : _b, _c = _a.initialValues, initialValues = _c === void 0 ? [] : _c, _d = _a.onChange, onChange = _d === void 0 ? function () { return ''; } : _d, disabled = _a.disabled;
    var classes = core_1.makeStyles(json.classes)();
    var _f = use_immer_1.useImmerReducer(reducer, json.fases.map(function (fase) { return fase.documentos.map(function (documento) { return documento.linhas.reduce(function (a, linha) { return (__assign(__assign({}, a), linha.colunas.reduce(function (ac, _a) {
        var _b;
        var obj = _a.obj;
        return obj.name ? (__assign(__assign({}, ac), (_b = {}, _b[obj.name] = obj.value, _b))) : ac;
    }, {}))); }, {}); }); }), init(initialValues)), state = _f[0], dispatch = _f[1];
    utils_1.useUpdateEffect(function () {
        onChange(state);
    }, [state]);
    return (react_1.default.createElement(core_1.Card, { style: { padding: '10px' } },
        react_1.default.createElement(core_1.Typography, { variant: 'h4', component: 'div', align: 'center', style: { marginBottom: '10px' } }, json.nome),
        json.fases && json.fases.map(function (fase, i) { return (react_1.default.createElement(core_1.Card, { key: fase.idFase, className: classes[fase.className], style: __assign(__assign({}, fase.style), { padding: '10px', margin: '10px' }) },
            react_1.default.createElement(core_1.Typography, { variant: 'h5', component: 'div', align: 'center', style: { marginBottom: '5px' } }, fase.nome),
            fase.documentos.map(function (documento, j) { return (react_1.default.createElement(core_1.Paper, { elevation: 3, key: documento.idDoc, className: classes[documento.className], style: __assign(__assign({}, documento.style), { padding: '10px', margin: '10px' }) },
                react_1.default.createElement(core_1.Typography, { variant: 'h6', component: 'div', align: 'center', style: { marginBottom: '5px' } }, documento.nome),
                documento.linhas.map(function (linha, k) { return (react_1.default.createElement(core_1.Grid, { container: true, spacing: linha.spacing || 2, key: "" + k, className: classes[linha.className], style: linha.style }, linha.colunas.map(function (_a, l) {
                    var span = _a.span, className = _a.className, style = _a.style, _b = _a.obj, name = _b.name, obj = __rest(_b, ["name"]);
                    return (react_1.default.createElement(core_1.Grid, { item: true, key: l, xs: span, className: classes[className], style: style },
                        console.log(state[i][j][name]),
                        react_1.default.createElement(RetornaComponente, __assign({ value: obj.value || state[i][j][name], fase: i, documento: j }, __assign(__assign({}, obj), { name: name, dispatch: dispatch, disabled: disabled })))));
                }))); }))); }))); })));
};
exports.default = FormVisualizer;
var RetornaComponente = react_1.memo(function (_a) {
    var tp = _a.tp, name = _a.name, dispatch = _a.dispatch, disabled = _a.disabled, fase = _a.fase, documento = _a.documento, props = __rest(_a, ["tp", "name", "dispatch", "disabled", "fase", "documento"]);
    switch (tp) {
        case 'label':
            return react_1.default.createElement(Label, __assign({ disabled: disabled }, props));
        case 'text':
            return react_1.default.createElement(Text, __assign({ disabled: disabled, dispatch: function (value) { return dispatch({ fase: fase, documento: documento, field: name, value: value }); } }, props));
        case 'data':
            return react_1.default.createElement(Data, __assign({ disabled: disabled, dispatch: function (value) { return dispatch({ fase: fase, documento: documento, field: name, value: value }); } }, props));
        case 'checkBox':
            return react_1.default.createElement(Selection, __assign({ disabled: disabled, dispatch: function (value) { return dispatch({ fase: fase, documento: documento, field: name, value: value }); } }, props));
        case 'assinatura':
            return react_1.default.createElement(Signature, __assign({ disabled: disabled, dispatch: function (value) { return dispatch({ fase: fase, documento: documento, field: name, value: value }); } }, props));
        default:
            break;
    }
}, lodash_1.isEqual);
var Label = function (_a) {
    var className = _a.className, style = _a.style, value = _a.value, props = __rest(_a, ["className", "style", "value"]);
    return react_1.default.createElement(core_1.Typography, __assign({}, __assign({ className: className, style: style }, props)), value);
};
var useStyles = core_1.makeStyles({
    textArea: {
        '& textarea': {
            resize: 'vertical',
            minHeight: '50px'
        }
    }
});
var Text = function (_a) {
    var variant = _a.variant, label = _a.label, multiple = _a.multiple, className = _a.className, style = _a.style, options = _a.options, value = _a.value, dispatch = _a.dispatch, path = _a.path, props = __rest(_a, ["variant", "label", "multiple", "className", "style", "options", "value", "dispatch", "path"]);
    var classes = useStyles();
    if (variant === 'select')
        return (react_1.default.createElement(Autocomplete_1.default, __assign({}, { multiple: multiple, options: options }, { defaultValue: value, limitTags: 1, disableCloseOnSelect: multiple, disablePortal: true, closeText: 'Fechar', clearText: 'Limpar', openText: 'Abrir', onChange: function (_e, value_) {
                dispatch(value_);
            } }, props, { renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ variant: 'outlined', margin: 'dense', fullWidth: true }, { label: label, style: style, className: className }, params))); } })));
    return (react_1.default.createElement(core_1.TextField, __assign({ className: classes.textArea + " mostraSpinner " + className, variant: 'outlined', margin: 'dense', fullWidth: true, multiline: variant === 'multiline' }, { label: label, style: style }, { defaultValue: value, onBlur: function (e) {
            e.persist();
            if (e.target.value === value)
                return;
            dispatch(e.target.value);
        } }, props)));
};
var Data = function (_a) {
    var label = _a.label, className = _a.className, style = _a.style, value = _a.value, dispatch = _a.dispatch, path = _a.path, props = __rest(_a, ["label", "className", "style", "value", "dispatch", "path"]);
    var _b = react_1.useState(value), state = _b[0], setState = _b[1];
    react_1.useEffect(function () {
        if ((value || undefined) === (lodash_1.isString(state) ? state || undefined : state === null || state === void 0 ? void 0 : state.format('YYYY-MM-DD')))
            return;
        var time = setTimeout(function () {
            dispatch(state ? moment_2.default(state).format('YYYY-MM-DD') : '');
        }, 100);
        return function () { return clearTimeout(time); };
        // eslint-disable-next-line
    }, [state, path]);
    return (react_1.default.createElement(pickers_1.MuiPickersUtilsProvider, { utils: moment_1.default },
        react_1.default.createElement(pickers_1.KeyboardDatePicker, __assign({ fullWidth: true, invalidDateMessage: 'Data inv\u00E1lida', autoOk: true, variant: 'inline', inputVariant: 'outlined', label: 'Data inicial', margin: 'dense', InputAdornmentProps: { position: 'end' }, format: 'DD/MM/YYYY' }, { className: className, label: label, style: style }, props, { value: state || null, onChange: setState }))));
};
var Selection = function (_a) {
    var label = _a.label, multiple = _a.multiple, className = _a.className, style = _a.style, options = _a.options, value = _a.value, dispatch = _a.dispatch, path = _a.path, props = __rest(_a, ["label", "multiple", "className", "style", "options", "value", "dispatch", "path"]);
    var _b = react_1.useState(value || (multiple ? [] : '')), state = _b[0], setState = _b[1];
    var atualizaDados = react_1.useCallback(function () {
        dispatch(state);
        // eslint-disable-next-line
    }, [state]);
    utils_1.useUpdateEffect(function () { return atualizaDados(); }, [state, atualizaDados]);
    var changeCheckBox = function (e) {
        if (e.target.checked) {
            setState(__spreadArray(__spreadArray([], state), [e.target.value]));
        }
        else {
            var temp = state;
            temp.splice(temp.indexOf(e.target.value), 1);
            setState(temp);
        }
        atualizaDados();
    };
    if (multiple)
        return (react_1.default.createElement(core_1.Grid, { container: true },
            react_1.default.createElement(core_1.Grid, __assign({ item: true, xs: 12, style: __assign(__assign({}, style), { display: 'flex', alignItems: 'center', justifyContent: 'space-between', padding: 5 }) }, { className: className }),
                label && react_1.default.createElement(core_1.FormLabel, { style: { marginBottom: '0px' } }, label),
                react_1.default.createElement(core_1.FormGroup, { row: true, style: { flexGrow: 1, justifyContent: label ? 'flex-end' : 'space-evenly' } }, options.map(function (item, i) { return (react_1.default.createElement(core_1.FormControlLabel, { key: i, value: item, control: react_1.default.createElement(core_1.Checkbox, __assign({ name: item, onChange: changeCheckBox }, { style: style }, props)), label: item, labelPlacement: 'start' })); })))));
    return (react_1.default.createElement(core_1.Grid, { container: true },
        react_1.default.createElement(core_1.Grid, __assign({ item: true, xs: 12, style: __assign(__assign({}, style), { display: 'flex', alignItems: 'center', justifyContent: 'space-between', padding: 5 }) }, { className: className }),
            label && react_1.default.createElement(core_1.FormLabel, { style: { marginBottom: '0px' } }, label),
            react_1.default.createElement(core_1.RadioGroup, { row: true, defaultValue: value, onChange: function (e) { return setState(e.target.value); }, style: { flexGrow: 1, justifyContent: label ? 'flex-end' : 'space-evenly' } }, options.map(function (item, i) { return (react_1.default.createElement(core_1.FormControlLabel, { key: i, value: item, control: react_1.default.createElement(core_1.Radio, __assign({}, { style: style }, props)), label: item, labelPlacement: 'start' })); })))));
};
var Signature = function (_a) {
    var label = _a.label, grupos = _a.grupos, usuarios = _a.usuarios, className = _a.className, style = _a.style, value = _a.value, dados = _a.dados, setDados = _a.setDados, path = _a.path;
    var usuario = store_1.getStore().getState().argous.usuarioLogado;
    var podeAssinar = (usuarios.filter(function (id) { return id === usuario.idUsuario; })).length > 0;
    var _b = react_1.useState({ modal: false, password: '', showPassword: false, senhaIncorreta: '' }), values = _b[0], setValues = _b[1];
    //action para checar se o usuario é do grupo para poder assinar 
    function confirmaAssinatura() {
        return __awaiter(this, void 0, void 0, function () {
            var res, temp;
            return __generator(this, function (_a) {
                res = { status: true, hash: 'sdfghil349' };
                if (res.status) {
                    setValues(__assign(__assign({}, values), { senhaIncorreta: '' }));
                    temp = __assign({}, dados);
                    lodash_1.set(temp, path, [usuario.idUsuario, usuario.nome, moment_2.default(new Date()).format('YYYY-MM-DD HH:mm:ss'), res.hash]);
                    setDados(temp);
                    setValues(__assign(__assign({}, values), { modal: false }));
                }
                else
                    setValues(__assign(__assign({}, values), { senhaIncorreta: 'Senha Incorreta!' }));
                return [2 /*return*/];
            });
        });
    }
    if (value.length > 0)
        return (react_1.default.createElement("div", __assign({}, { className: className }, { style: __assign(__assign({}, style), { height: '50px', display: 'flex', justifyContent: 'flex-end', alignItems: ' flex-end' }) }),
            react_1.default.createElement(core_1.Typography, { title: value[3], variant: 'subtitle2', style: { textAlign: 'right' } }, value[1] + " - " + moment_2.default(value[2]).format('DD/MM/YYYY HH:mm:ss'))));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Grid, __assign({ container: true, direction: 'row-reverse' }, { className: className, style: style }),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12, sm: 6, md: 4, lg: 2, xl: 1 },
                react_1.default.createElement(MaterialButton_1.default, { title: label, color: 'primary', variant: 'contained', fullWidth: true, disabled: !podeAssinar, onClick: function () { return setValues(__assign(__assign({}, values), { modal: true })); } }, "Assinar"))),
        react_1.default.createElement(core_1.Dialog, { open: values.modal, onClose: function () { return setValues(__assign(__assign({}, values), { modal: false })); }, style: { padding: '0px 10px 5px' } },
            react_1.default.createElement(core_1.DialogTitle, null, "Confirme sua senha"),
            react_1.default.createElement(core_1.DialogContent, null,
                react_1.default.createElement(core_1.TextField, { variant: 'outlined', label: 'Senha', fullWidth: true, type: values.showPassword ? 'text' : 'password', value: values.password, onChange: function (e) { return setValues(__assign(__assign({}, values), { password: e.target.value })); }, InputProps: {
                        endAdornment: (react_1.default.createElement(core_1.InputAdornment, { position: 'end' },
                            react_1.default.createElement(core_1.IconButton, { onClick: function () { return setValues(__assign(__assign({}, values), { showPassword: !values.showPassword })); }, onMouseDown: function (e) { return e.preventDefault(); } }, values.showPassword ? react_1.default.createElement(md_1.MdVisibility, null) : react_1.default.createElement(md_1.MdVisibilityOff, null))))
                    }, error: !!values.senhaIncorreta, helperText: values.senhaIncorreta })),
            react_1.default.createElement(core_1.DialogActions, null,
                react_1.default.createElement(MaterialButton_1.default, { title: 'Cancelar', color: 'warning', variant: 'contained', fullWidth: true, onClick: function () { return setValues(__assign(__assign({}, values), { modal: false })); } }, "Cancelar"),
                react_1.default.createElement(MaterialButton_1.default, { title: 'Confirmar', color: 'success', variant: 'contained', fullWidth: true, onClick: confirmaAssinatura }, "Confirmar")))));
};
