"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var core_1 = require("@material-ui/core");
var lab_1 = require("@material-ui/lab");
var lodash_1 = require("lodash");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var InputTags = /** @class */ (function (_super) {
    __extends(InputTags, _super);
    function InputTags(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (_, value, reason) {
            var _a;
            if (reason === 'create-option') {
                var text_1 = value.pop();
                if (((_a = _this.props.getField().value) === null || _a === void 0 ? void 0 : _a.findIndex(function (item) { return item.text === text_1 || item.id === text_1; })) === -1)
                    _this.props.setField({ value: __spreadArray(__spreadArray([], value), [{ id: text_1, text: text_1 }]) });
            }
            else
                _this.props.setField({ value: value });
        };
        _this.handleDelete = function (i) { return function () {
            var tags = _this.props.getField().value || [];
            _this.props.setField({ value: tags.filter(function (tag, index) { return index !== i; }) });
        }; };
        _this.checkProps = function () {
            var tags = _this.props.getField().value || [];
            if (typeof tags === 'string') {
                try {
                    tags = JSON.parse(tags);
                }
                catch (e) { }
            }
            return __assign({ tags: tags, handleChange: _this.handleChange, handleDelete: _this.handleDelete }, _this.props);
        };
        var propValue = _this.props.getField().value;
        if (lodash_1.isArray(propValue))
            _this.props.setField({ value: propValue });
        else {
            try {
                _this.props.setField({ value: JSON.parse(propValue) });
            }
            catch (error) {
                _this.props.setField({ value: [] });
            }
        }
        return _this;
    }
    InputTags.prototype.render = function () {
        var _a = this.checkProps(), handleChange = _a.handleChange, handleDelete = _a.handleDelete, tags = _a.tags, handleInputChange = _a.handleInputChange, label = _a.label, placeholder = _a.placeholder, suggestions = _a.suggestions, props = __rest(_a, ["handleChange", "handleDelete", "tags", "handleInputChange", "label", "placeholder", "suggestions"]);
        return (react_1.default.createElement(core_1.Grid, { container: true, spacing: 1 },
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12 }, tags.map(function (item, index) { return (react_1.default.createElement(core_1.Chip, { key: index, label: item.text, onDelete: handleDelete(index) })); })),
            react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                react_1.default.createElement(lab_1.Autocomplete, __assign({ onInputChange: function (_, value) { return handleInputChange(value); }, multiple: true, freeSolo: true, disableClearable: true, value: tags, options: suggestions === null || suggestions === void 0 ? void 0 : suggestions.filter(function (searched) { return tags.findIndex(function (item) { var _a; return ((_a = item.id) === null || _a === void 0 ? void 0 : _a.localeCompare(searched.id, undefined, { sensitivity: 'accent' })) === 0; }) < 0; }), getOptionLabel: function (option) { return option.text || option; }, onChange: handleChange, noOptionsText: 'N\u00E3o Encontrado', size: 'small', renderTags: function () { return null; }, renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ fullWidth: true, margin: 'dense', color: 'secondary', label: label, placeholder: placeholder }, params))); } }, props)))));
    };
    return InputTags;
}(react_1.Component));
InputTags.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool
};
exports.default = fieldsRedux_1.createField(InputTags);
