"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var fa_1 = require("react-icons/fa");
/**
 * @deprecated
 */
var MenuBar = /** @class */ (function (_super) {
    __extends(MenuBar, _super);
    function MenuBar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            liWidths: [],
            guidePositionX: 0,
            guidePositionY: 0,
        };
        _this.initSelectedGuide = function () {
            var _a = _this.props, _b = _a.guides, guides = _b === void 0 ? [] : _b, setField = _a.setField, getField = _a.getField;
            var _c = getField(), selectedGuide = _c.selectedGuide, selectedGuideRow = _c.selectedGuideRow;
            if (guides.length > 0 && typeof selectedGuide !== 'undefined' && typeof selectedGuideRow !== 'undefined') {
                _this.alterGuide(guides[selectedGuideRow].indexOf(selectedGuide));
            }
            else if (guides.length > 0) {
                setField({ selectedGuide: guides[0][0], selectedGuideRow: 0 });
            }
        };
        _this.setLiWidths = function (callback) {
            var _a = _this.props.guides, guides = _a === void 0 ? [] : _a;
            var liWidths = [];
            for (var _i = 0, guides_1 = guides; _i < guides_1.length; _i++) {
                var g = guides_1[_i];
                liWidths.push(100 / g.length);
            }
            _this.setState({ liWidths: liWidths }, callback);
        };
        _this.updateWindowDimensions = function () {
            var _a = _this.props, _b = _a.guides, guides = _b === void 0 ? [] : _b, getField = _a.getField;
            var _c = getField(), selectedGuide = _c.selectedGuide, selectedGuideRow = _c.selectedGuideRow;
            _this.alterGuide(guides[selectedGuideRow].indexOf(selectedGuide));
        };
        _this.alterGuide = function (index) {
            var liWidths = _this.state.liWidths;
            var _a = _this.props, _b = _a.positionSpace, positionSpace = _b === void 0 ? 16.5 : _b, getField = _a.getField;
            var selectedGuideRow = getField().selectedGuideRow;
            if (_this.fpLineGuide) {
                var lineGuideWidth = _this.fpLineGuide.offsetWidth;
                var guidePositionX = (((lineGuideWidth * liWidths[selectedGuideRow]) / 100) * index);
                var heightChildrens = 0;
                for (var i = 0; i < _this.fpLineGuide.children.length; i++) {
                    if (i === selectedGuideRow) {
                        break;
                    }
                    heightChildrens += _this.fpLineGuide.children[i].offsetHeight;
                }
                var guidePositionY = heightChildrens + selectedGuideRow * positionSpace;
                _this.setState({ guidePositionX: guidePositionX, guidePositionY: guidePositionY });
            }
        };
        return _this;
    }
    MenuBar.prototype.componentDidMount = function () {
        var _this = this;
        this.setLiWidths(function () {
            _this.initSelectedGuide();
            _this.updateWindowDimensions();
            window.addEventListener('resize', _this.updateWindowDimensions);
        });
    };
    MenuBar.prototype.componentWillUnmount = function () {
        window.removeEventListener('resize', this.updateWindowDimensions);
    };
    MenuBar.prototype.componentDidUpdate = function (prevProps) {
        var _a = this.props, _b = _a.guides, guides = _b === void 0 ? [] : _b, getField = _a.getField, getPreviousField = _a.getPreviousField;
        var _c = getField(), selectedGuide = _c.selectedGuide, selectedGuideRow = _c.selectedGuideRow;
        var _d = getPreviousField(prevProps), selectedGuidePrev = _d.selectedGuide, selectedGuideRowPrev = _d.selectedGuideRow;
        if (selectedGuide !== selectedGuidePrev || selectedGuideRow !== selectedGuideRowPrev) {
            if (guides[selectedGuideRow]) {
                this.alterGuide(guides[selectedGuideRow].indexOf(selectedGuide));
            }
        }
    };
    MenuBar.prototype.render = function () {
        var _this = this;
        var _a = this.state, liWidths = _a.liWidths, guidePositionX = _a.guidePositionX, guidePositionY = _a.guidePositionY;
        var _b = this.props, movingTabColor = _b.movingTabColor, _c = _b.guides, guides = _c === void 0 ? [] : _c, getField = _b.getField, setField = _b.setField, style = _b.style, className = _b.className;
        var _d = getField(), selectedGuide = _d.selectedGuide, selectedGuideRow = _d.selectedGuideRow, _e = _d.preenchidos, preenchidos = _e === void 0 ? [] : _e;
        return (react_1.default.createElement("div", { ref: function (input) {
                _this.fpLineGuide = input;
            }, style: style, className: "fp-container-line-guide " + className },
            guides.map(function (g, indexG) {
                return react_1.default.createElement("ul", { key: indexG }, g.map(function (item, index) { return (react_1.default.createElement("li", { key: index, style: { width: liWidths[indexG] + "%" }, onClick: function () {
                        setField({ selectedGuide: item, selectedGuideRow: indexG });
                        _this.alterGuide(index);
                    } },
                    item,
                    preenchidos.indexOf(item) >= 0 && react_1.default.createElement(fa_1.FaCheck, { className: 'fp-chck-g' }))); }));
            }),
            react_1.default.createElement("div", { className: 'fp-moving-tab', style: {
                    backgroundColor: movingTabColor,
                    boxShadow: movingTabColor ? "0 16px 26px -14px " + movingTabColor : undefined,
                    width: liWidths[selectedGuideRow] + "%",
                    transform: "translate3d(" + guidePositionX + "px, " + guidePositionY + "px, 0px)",
                } },
                selectedGuide,
                preenchidos.indexOf(selectedGuide) >= 0 && react_1.default.createElement(fa_1.FaCheck, { className: 'fp-chck-w' }))));
    };
    return MenuBar;
}(react_1.Component));
MenuBar.propTypes = {
    field: prop_types_1.default.string.isRequired,
    guides: prop_types_1.default.array.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    movingTabColor: prop_types_1.default.string,
    positionSpace: prop_types_1.default.number,
};
exports.default = fieldsRedux_1.createField(MenuBar);
