"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_maskedinput_1 = __importDefault(require("react-maskedinput"));
/**
 * @deprecated
 */
var MonthPicker = /** @class */ (function (_super) {
    __extends(MonthPicker, _super);
    function MonthPicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mobj = [
            [{
                    mes: '01',
                    nome: 'Janeiro'
                }, {
                    mes: '02',
                    nome: 'Fevereiro'
                }, {
                    mes: '03',
                    nome: 'Março'
                }], [{
                    mes: '04',
                    nome: 'Abril'
                }, {
                    mes: '05',
                    nome: 'Maio'
                }, {
                    mes: '06',
                    nome: 'Junho'
                }], [{
                    mes: '07',
                    nome: 'Julho'
                }, {
                    mes: '08',
                    nome: 'Agosto'
                }, {
                    mes: '09',
                    nome: 'Setembro'
                }], [{
                    mes: '10',
                    nome: 'Outubro'
                }, {
                    mes: '11',
                    nome: 'Novembro'
                }, {
                    mes: '12',
                    nome: 'Dezembro'
                }]
        ];
        _this.state = {
            initialized: false,
            year: 0,
            stageMonths: [],
            selectOpen: false,
            selectOpenClicks: 0
        };
        _this.fieldListener = function (fieldObject, prevFieldObject) {
            var initialized = _this.state.initialized;
            var fieldListener = _this.props.fieldListener;
            if (!initialized && typeof fieldObject.defaultValue !== 'undefined') {
                if (fieldObject.defaultValue.length > 0) {
                    if (typeof fieldObject.value[0] !== 'string') {
                        var stringifyedValues = fieldObject.value.map(function (v) { return v.toString(); });
                        fieldsRedux_1.setField(_this.props.field, 'value', stringifyedValues);
                    }
                    var last = fieldObject.defaultValue[fieldObject.defaultValue.length - 1].toString();
                    _this.setState({ year: parseInt(last.slice(0, 4), 10) });
                }
                _this.handleinputValue(fieldObject.defaultValue);
                _this.setState({ initialized: true });
            }
            if (fieldObject.value !== prevFieldObject.value) {
                _this.handleinputValue(fieldObject.value ? fieldObject.value : []);
            }
            if (fieldListener) {
                fieldListener(fieldObject);
            }
        };
        _this.onClick = function (values, month) {
            var year = _this.state.year;
            var _a = _this.props.type, type = _a === void 0 ? 'single' : _a;
            var formatedValue = "" + year + month;
            var newValue;
            if (values && values.length > 0) {
                newValue = _this.handleExistentValue(values, formatedValue, month);
                if (type === 'stage' || type === 'multiple') {
                    newValue = newValue.sort(function (a, b) { return a > b ? 1 : 0; });
                }
            }
            else {
                newValue = [formatedValue];
            }
            _this.handleinputValue(newValue);
            _this.props.handleUpdates(newValue);
            if (type === 'single' && newValue.length > 0) {
                _this.closeSelect();
            }
        };
        _this.handleExistentValue = function (value, formatedValue, month) {
            var _a = _this.props, field = _a.field, _b = _a.type, type = _b === void 0 ? 'single' : _b;
            var indexValue = value.indexOf(formatedValue);
            if (indexValue > -1) {
                value.splice(indexValue, 1);
                return __spreadArray([], value);
            }
            switch (type) {
                case 'single':
                    return [formatedValue];
                case 'stage': {
                    var fieldValueLgt2 = fieldsRedux_1.getField(field, 'value').length === 2;
                    var newValue = fieldValueLgt2 ? [formatedValue] : [value[0], formatedValue];
                    if (!fieldValueLgt2) {
                        _this.closeSelect();
                    }
                    return newValue;
                }
                case 'multiple':
                    return __spreadArray(__spreadArray([], value), [formatedValue]);
                default:
                    return [formatedValue];
            }
        };
        _this.handleinputValue = function (value) {
            var _a = _this.props, field = _a.field, _b = _a.type, type = _b === void 0 ? 'single' : _b;
            value = __spreadArray([], value);
            var sortedValues = value.sort(function (a, b) { return a > b ? 1 : 0; });
            var inputValues = sortedValues.map(function (v) { return "" + v.toString().slice(4) + v.toString().slice(0, 4); });
            switch (type) {
                case 'single':
                    fieldsRedux_1.setField(field, 'inputValue', inputValues[0]);
                    break;
                case 'stage':
                    fieldsRedux_1.setField(field, 'inputValue', "" + inputValues[0] + (inputValues[1] ? inputValues[1] : ''));
                    break;
                case 'multiple': {
                    var multipleValue = '';
                    for (var _i = 0, inputValues_1 = inputValues; _i < inputValues_1.length; _i++) {
                        var v = inputValues_1[_i];
                        multipleValue += v.slice(0, 2) + "/" + v.slice(2) + " ";
                    }
                    fieldsRedux_1.setField(field, 'inputValue', multipleValue);
                    break;
                }
                default:
                    fieldsRedux_1.setField(field, 'inputValue', inputValues[0]);
            }
        };
        _this.isActive = function (values, month) {
            var _a = _this.state, year = _a.year, stageMonths = _a.stageMonths;
            var formatedValue = "" + year + month;
            return (values.indexOf(formatedValue) < 0 ? '' : 'active') + " " + (stageMonths.indexOf(formatedValue) < 0 ? '' : 'hovered');
        };
        _this.restYear = function () {
            var date = new Date();
            _this.setState({ year: date.getFullYear() });
        };
        _this.onValueCapture = function (v) {
            var field = _this.props.field;
            var value = v.target.value;
            fieldsRedux_1.setField(field, 'inputValue', value);
            value = value.replace(/\D+/g, '');
            var valueLength = value.length;
            var resolvedValues = [];
            if (valueLength >= 6) {
                var resto = valueLength % 6;
                var valueAux = value.slice(0, valueLength - resto);
                var length_1 = valueAux.length / 6;
                for (var i = 0; i < length_1; i++) {
                    var aux = i * 6;
                    var mes = valueAux.slice(aux, aux + 2);
                    var ano = valueAux.slice(aux + 2, aux + 6);
                    if (parseInt(mes, 10) <= 12 && parseInt(mes, 10) >= 1) {
                        resolvedValues.push("" + ano + mes);
                    }
                }
            }
            _this.props.handleUpdates(resolvedValues);
        };
        _this.openSelect = function () {
            var selectOpen = _this.state.selectOpen;
            if (!selectOpen) {
                _this.setState({ selectOpen: true, selectOpenClicks: 0 });
                window.addEventListener('click', _this.closeSelect);
            }
        };
        _this.closeSelect = function () {
            var selectOpenClicks = _this.state.selectOpenClicks;
            if (selectOpenClicks > 0) {
                _this.setState({ selectOpen: false });
                window.removeEventListener('click', _this.closeSelect);
            }
            _this.setState({ selectOpenClicks: selectOpenClicks + 1 });
        };
        return _this;
    }
    MonthPicker.prototype.componentDidMount = function () {
        this.restYear();
    };
    MonthPicker.prototype.componentWillUnmount = function () {
        window.removeEventListener('click', this.closeSelect);
    };
    MonthPicker.prototype.componentDidUpdate = function (prevProps) {
        var field = this.props.field;
        fieldsRedux_1.fieldChangeListener(field, this.fieldListener, prevProps);
    };
    MonthPicker.prototype.render = function () {
        var _this = this;
        var _a = this.props, field = _a.field, _b = _a.type, type = _b === void 0 ? 'single' : _b;
        var _c = this.state, year = _c.year, selectOpen = _c.selectOpen;
        var values = fieldsRedux_1.getField(field, 'value');
        var inputValue = fieldsRedux_1.getField(field, 'inputValue');
        var mask = type === 'single' ? '11/1111' : '11/1111 à 11/1111';
        return (react_1.default.createElement("div", { className: 'monthPickermaxwidth' },
            (type === 'single' || type === 'stage') && (react_1.default.createElement(react_maskedinput_1.default, { value: inputValue, onClick: this.openSelect, onChange: this.onValueCapture, mask: mask, className: 'pg-monthpicker-input' })),
            type === 'multiple' && (react_1.default.createElement("input", { value: inputValue, onClick: this.openSelect, onChange: this.onValueCapture, className: 'pg-monthpicker-input' })),
            selectOpen && (react_1.default.createElement("div", { onClick: function (e) { return e.stopPropagation(); }, className: 'monthPickerSelect' },
                react_1.default.createElement("div", { className: 'pg-monthpicker-year', onClick: this.restYear }, year),
                react_1.default.createElement("div", { className: 'system-btn-group pull-left', style: { width: '100%' } },
                    react_1.default.createElement("span", { onClick: function () { return _this.setState({ year: year - 1 }); }, className: 'btn system-btn-white', style: { width: '50%', borderRadius: 0 } },
                        react_1.default.createElement("i", { className: 'glyphicon glyphicon-chevron-left' })),
                    react_1.default.createElement("span", { onClick: function () { return _this.setState({ year: year + 1 }); }, className: 'btn system-btn-white', style: { width: '50%', borderRadius: 0 } },
                        react_1.default.createElement("i", { className: 'glyphicon glyphicon-chevron-right' }))),
                react_1.default.createElement("table", { className: 'table table-bordered table-monthpicker' },
                    react_1.default.createElement("tbody", null, this.mobj.map(function (item, index) { return (react_1.default.createElement("tr", { key: index }, item.map(function (month, index) { return (react_1.default.createElement("td", { key: index, className: _this.isActive(values, month.mes), onClick: function () { return _this.onClick(values, month.mes); } }, month.nome)); }))); })))))));
    };
    return MonthPicker;
}(react_1.Component));
MonthPicker.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    receiveUpdates: prop_types_1.default.array,
    sendUpdates: prop_types_1.default.array,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    type: prop_types_1.default.oneOf(['single', 'stage', 'multiple'])
};
exports.default = fieldsRedux_1.createField(MonthPicker, { disableFieldChangeListener: true });
