"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var MultipleSelect = /** @class */ (function (_super) {
    __extends(MultipleSelect, _super);
    function MultipleSelect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (val) {
            var _a = _this.props, onChange = _a.onChange, field = _a.field;
            var value = val.toString();
            var fldValue = fieldsRedux_1.getField(field, 'value') || [];
            var newValue = __spreadArray([], fldValue);
            var index = newValue.indexOf(value);
            if (index >= 0) {
                newValue.splice(index, 1);
            }
            else {
                newValue.push(value);
            }
            value = newValue;
            if (onChange) {
                onChange(value);
            }
            _this.props.handleUpdates(value);
        };
        _this.checkListSelectProps = function () {
            var _a = _this.props, className = _a.className, disabled = _a.disabled, multiple = _a.multiple, style = _a.style;
            return {
                className: className,
                disabled: disabled,
                multiple: multiple,
                style: style,
            };
        };
        return _this;
    }
    MultipleSelect.prototype.componentDidMount = function () {
        var _a = this.props, optionsField = _a.optionsField, optionsDefaultValue = _a.optionsDefaultValue;
        fieldsRedux_1.initField(optionsField, optionsDefaultValue);
    };
    MultipleSelect.prototype.componentWillUnmount = function () {
        var _a = this.props, optionsField = _a.optionsField, destroyOnUnmount = _a.destroyOnUnmount;
        if (destroyOnUnmount) {
            fieldsRedux_1.clearField(optionsField);
        }
    };
    MultipleSelect.prototype.render = function () {
        var _a = this, checkListSelectProps = _a.checkListSelectProps, onChange = _a.onChange;
        var _b = this.props, field = _b.field, optionsField = _b.optionsField, optionsValue = _b.optionsValue, optionsLabel = _b.optionsLabel, classActive = _b.classActive;
        var selectProps = checkListSelectProps();
        var value = fieldsRedux_1.getField(field, 'value') || [];
        var options = fieldsRedux_1.getField(optionsField, 'value') || [];
        return (react_1.default.createElement("ul", __assign({}, selectProps), options.map(function (item, index) { return (react_1.default.createElement("li", { 
            // eslint-disable-next-line
            className: value.indexOf(item[optionsValue].toString()) >= 0 ? classActive : '', key: index, title: item[optionsLabel], onClick: function () { return onChange(item[optionsValue]); } }, item[optionsLabel])); })));
    };
    return MultipleSelect;
}(react_1.Component));
MultipleSelect.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    sendUpdates: prop_types_1.default.array,
    receiveUpdates: prop_types_1.default.array,
    onChange: prop_types_1.default.func,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    optionsField: prop_types_1.default.string.isRequired,
    optionsDefaultValue: prop_types_1.default.oneOfType([prop_types_1.default.object, prop_types_1.default.array]),
    optionsValue: prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.number]),
    optionsLabel: prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.number]),
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    classActive: prop_types_1.default.string,
};
exports.default = fieldsRedux_1.createField(MultipleSelect);
