import { OutlinedTextFieldProps } from '@material-ui/core';
import React from 'react';
export interface Props extends Omit<OutlinedTextFieldProps, 'onChange' | 'variant'> {
    numInputs?: number;
    onChange?: (otp: string) => void;
    separator?: React.ReactNode;
    inputStyle?: Object;
    value?: string;
    onConfirm?: (otp: string) => void;
}
export interface SingleProps extends Partial<Omit<Props, 'onChange'>> {
    isLastChild: boolean;
    focus: boolean;
    index: number;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
declare const OtpInput: ({ numInputs, onChange, value, onConfirm, ...props }: Props) => React.JSX.Element;
export default OtpInput;
