"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var OutputText = /** @class */ (function (_super) {
    __extends(OutputText, _super);
    function OutputText() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleDecimalValues = function (value) {
            var _a = _this.props, decimalSeparator = _a.decimalSeparator, decimalScale = _a.decimalScale;
            if (typeof decimalScale !== 'undefined') {
                try {
                    if (!isNaN(value))
                        value = parseFloat(value, 10).toFixed(decimalScale);
                }
                catch (e) { }
            }
            if (decimalSeparator) {
                value = value.replace('.', decimalSeparator);
            }
            return value;
        };
        return _this;
    }
    OutputText.prototype.render = function () {
        var _a = this.props, field = _a.field, _b = _a.renderize, renderize = _b === void 0 ? 'span' : _b, className = _a.className, style = _a.style, _c = _a.prefixo, prefixo = _c === void 0 ? '' : _c, _d = _a.sufixo, sufixo = _d === void 0 ? '' : _d;
        var value = fieldsRedux_1.getField(field, 'value');
        value = typeof value !== 'object' ? value : JSON.stringify(value);
        value = this.handleDecimalValues(value);
        value = "" + prefixo + value + sufixo;
        return react_1.default.createElement(renderize, { className: className, style: style }, value);
    };
    return OutputText;
}(react_1.Component));
OutputText.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    renderize: prop_types_1.default.string,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    prefixo: prop_types_1.default.string,
    sufixo: prop_types_1.default.string,
    decimalSeparator: prop_types_1.default.string,
    decimalScale: prop_types_1.default.number,
};
exports.default = fieldsRedux_1.createField(OutputText);
