export interface PercentageDisplayProps {
  /**
   * Identificação do elemento
   */
  id?: string,
  /**
   * Porcentagem
   */
  percentage?: number|string,
  /**
   * Tamanho do componente
   */
  size?: number,
  /**
   * Largura da barra
   */
  barWidth?: number,
  /**
   * Tamanho da fonte da porcentagem
   */
  fontSize?: string,
  /**
   * Cor da fonte
   */
  color?: string,
  /**
   * Cor de fundo
   */ 
  backgroundColor?: string,
  /**
   * Cor da barra
   */
  barColor?: string,
  /**
   * Cor de fundo da barra
   */
  barBackgroundColor?: string
}

declare function PercentageDisplay(props: PercentageDisplayProps): JSX.Element

export default PercentageDisplay;