"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var useStyles = core_1.makeStyles({
    container: {
        display: 'grid',
        placeItems: 'center'
    },
    circularProgress: {
        height: function (_a) {
            var size = _a.size;
            return size;
        },
        width: function (_a) {
            var size = _a.size;
            return size;
        },
        backgroundColor: function (_a) {
            var barBackgroundColor = _a.barBackgroundColor;
            return barBackgroundColor;
        },
        borderRadius: '50%',
        display: 'grid',
        placeItems: 'center',
        '&::before': {
            content: '""',
            position: 'absolute',
            height: function (_a) {
                var progressBarWidth = _a.progressBarWidth;
                return progressBarWidth;
            },
            width: function (_a) {
                var progressBarWidth = _a.progressBarWidth;
                return progressBarWidth;
            },
            borderRadius: '50%',
            backgroundColor: function (_a) {
                var backgroundColor = _a.backgroundColor;
                return backgroundColor;
            }
        }
    },
    valueContainer: {
        position: 'relative',
        color: function (_a) {
            var color = _a.color;
            return color;
        },
        fontSize: function (_a) {
            var fontSize = _a.fontSize;
            return fontSize;
        }
    }
});
var PercentageDisplay = function (_a) {
    var id = _a.id, _b = _a.percentage, percentage = _b === void 0 ? 0 : _b, _c = _a.size, size = _c === void 0 ? 50 : _c, _d = _a.barWidth, barWidth = _d === void 0 ? 6 : _d, _e = _a.fontSize, fontSize = _e === void 0 ? '0.9rem' : _e, _f = _a.color, color = _f === void 0 ? '#000' : _f, _g = _a.backgroundColor, backgroundColor = _g === void 0 ? '#fff' : _g, _h = _a.barColor, barColor = _h === void 0 ? '#00995d' : _h, _j = _a.barBackgroundColor, barBackgroundColor = _j === void 0 ? '#00995d26' : _j;
    var progressBarWidth = size - barWidth;
    var classes = useStyles({ color: color, backgroundColor: backgroundColor, barColor: barColor, barBackgroundColor: barBackgroundColor, size: size, progressBarWidth: progressBarWidth, fontSize: fontSize });
    var percentageDisplayProgressId = id + "-percentageDisplayProgress";
    var createProgress = react_1.useCallback(function () {
        var porcentagem = parseInt(percentage);
        var progressBar = document.getElementById(percentageDisplayProgressId);
        if (!progressBar)
            return;
        progressBar.style.background = "conic-gradient(" + barColor + " " + porcentagem * 3.6 + "deg, " + barBackgroundColor + " " + porcentagem * 3.6 + "deg)";
    }, [barBackgroundColor, barColor, percentage, percentageDisplayProgressId]);
    react_1.useEffect(function () { return createProgress(); }, [percentage, createProgress]);
    return react_1.default.createElement("div", { className: classes.container },
        react_1.default.createElement("div", { id: percentageDisplayProgressId, className: classes.circularProgress },
            react_1.default.createElement("div", { className: classes.valueContainer }, percentage + "%")));
};
exports.default = PercentageDisplay;
