"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var ProgressBar = /** @class */ (function (_super) {
    __extends(ProgressBar, _super);
    function ProgressBar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getProgressType = function () {
            var type = _this.props.type;
            switch (type) {
                case 'success':
                    return 'bg-success';
                case 'warning':
                    return 'bg-warning';
                case 'purple':
                    return 'bg-purple';
                case 'yellow':
                    return 'bg-yellow';
                case 'danger':
                    return 'bg-danger';
                default:
                    return 'bg-blue-alt';
            }
        };
        return _this;
    }
    ProgressBar.prototype.render = function () {
        var getProgressType = this.getProgressType;
        var _a = this.props, _b = _a.padding, padding = _b === void 0 ? '2px' : _b, _c = _a.fontSize, fontSize = _c === void 0 ? '13px' : _c, _d = _a.showValue, showValue = _d === void 0 ? true : _d, _e = _a.value, value = _e === void 0 ? 0 : _e, _f = _a.trailClass, trailClass = _f === void 0 ? '' : _f, _g = _a.progressClass, progressClass = _g === void 0 ? '' : _g;
        var stylesValue = {
            width: value + "%",
            paddingTop: padding,
            paddingBottom: padding,
            fontSize: fontSize
        };
        return (react_1.default.createElement("div", { title: value + "%", className: "argous-progress-bar " + trailClass },
            react_1.default.createElement("div", { className: progressClass + " " + getProgressType(), style: stylesValue }, showValue && value + "%")));
    };
    return ProgressBar;
}(react_1.Component));
ProgressBar.propTypes = {
    value: prop_types_1.default.number,
    fontSize: prop_types_1.default.string,
    padding: prop_types_1.default.string,
    showValue: prop_types_1.default.bool,
    type: prop_types_1.default.oneOf([
        'blue',
        'success',
        'warning',
        'purple',
        'yellow',
        'danger'
    ]),
    trailClass: prop_types_1.default.string,
    progressClass: prop_types_1.default.string
};
exports.default = ProgressBar;
