"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (event) {
            var onChange = _this.props.onChange;
            var value = event.target.value;
            if (onChange) {
                onChange(value);
            }
            _this.props.handleUpdates(value);
        };
        _this.checkSelectProps = function () {
            var _a = _this.props, field = _a.field, autoFocus = _a.autoFocus, disabled = _a.disabled, form = _a.form, multiple = _a.multiple, name = _a.name, required = _a.required, size = _a.size, style = _a.style;
            var value = fieldsRedux_1.getField(field, 'value');
            var className = "" + (_this.props.className
                ? _this.props.className
                : 'form-control');
            var onChange = _this.onChange;
            return {
                value: value,
                onChange: onChange,
                className: className,
                autoFocus: autoFocus,
                disabled: disabled,
                form: form,
                multiple: multiple,
                name: name,
                required: required,
                size: size,
                style: style,
            };
        };
        return _this;
    }
    Select.prototype.componentDidMount = function () {
        var _a = this.props, optionsField = _a.optionsField, optionsDefaultValue = _a.optionsDefaultValue;
        fieldsRedux_1.initField(optionsField, optionsDefaultValue);
    };
    Select.prototype.componentWillUnmount = function () {
        var _a = this.props, optionsField = _a.optionsField, destroyOnUnmount = _a.destroyOnUnmount, keepOptions = _a.keepOptions;
        if (destroyOnUnmount && !keepOptions) {
            fieldsRedux_1.clearField(optionsField);
        }
    };
    Select.prototype.render = function () {
        var checkSelectProps = this.checkSelectProps;
        var _a = this.props, optionsField = _a.optionsField, optionsValue = _a.optionsValue, optionsLabel = _a.optionsLabel, children = _a.children;
        var selectProps = checkSelectProps();
        var options = fieldsRedux_1.getField(optionsField, 'value');
        return (react_1.default.createElement("select", __assign({}, selectProps),
            children,
            options.length > 0 && options.map(function (item, index) { return (react_1.default.createElement("option", { key: index, value: item[optionsValue], label: item[optionsLabel] }, item[optionsLabel])); })));
    };
    return Select;
}(react_1.Component));
Select.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    sendUpdates: prop_types_1.default.array,
    receiveUpdates: prop_types_1.default.array,
    onChange: prop_types_1.default.func,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    optionsField: prop_types_1.default.string.isRequired,
    optionsDefaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    optionsValue: prop_types_1.default.string,
    optionsLabel: prop_types_1.default.string,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    children: prop_types_1.default.node,
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    autoFocus: prop_types_1.default.bool,
    disabled: prop_types_1.default.bool,
    form: prop_types_1.default.string,
    multiple: prop_types_1.default.bool,
    name: prop_types_1.default.string,
    required: prop_types_1.default.bool,
    size: prop_types_1.default.string
};
exports.default = fieldsRedux_1.createField(Select);
