"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Cursor = function (_a) {
    var id = _a.id, _b = _a.speed, speed = _b === void 0 ? 500 : _b, className = _a.className;
    var cursorId = id + "-cursor-component";
    var intervalIdRef = react_1.useRef(null);
    react_1.useEffect(function () {
        var cursorElement = document.getElementById(cursorId);
        if (cursorElement)
            cursorElement.style.opacity = '1';
        intervalIdRef.current = setInterval(function () {
            if (cursorElement)
                cursorElement.style.opacity = (cursorElement.style.opacity === '0') ? '1' : '0';
        }, speed);
        return function () { return clearInterval(intervalIdRef.current); };
    });
    return react_1.default.createElement("span", { id: cursorId, className: "" + className }, "|");
};
exports.default = Cursor;
