"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../../api");
var ProgressBar_1 = __importDefault(require("../../components/ProgressBar"));
var SimpleTable_1 = __importDefault(require("../../components/SimpleTable"));
var fieldsRedux_1 = require("../../fieldsRedux");
var config_1 = require("../../utils/config");
var date_1 = require("../../utils/date");
var core_1 = require("@material-ui/core");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var fa_1 = require("react-icons/fa");
var ti_1 = require("react-icons/ti");
var react_spinkit_1 = __importDefault(require("react-spinkit"));
/**
 * @deprecated
 */
var ThreadLog = /** @class */ (function (_super) {
    __extends(ThreadLog, _super);
    function ThreadLog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            mouseOver: false,
            open: false,
            loading: false,
            selectPanelClicks: 0,
            infoProcesso: {
                open: false,
                info: {},
                confs: {},
                current: {}
            }
        };
        _this.mouseOver = function (boolean) {
            _this.setState({ mouseOver: boolean });
        };
        _this.openDetails = function () {
            var _a = _this.state, open = _a.open, infoProcesso = _a.infoProcesso;
            _this.setState({ open: !open, selectPanelClicks: 0 });
            window.addEventListener('click', _this.closePanel);
            if (!open) {
                var _b = _this.props, thread = _b.thread, _c = _b.qt, qt = _c === void 0 ? 15 : _c, _d = _b.nrPg, nrPg = _d === void 0 ? 0 : _d;
                _this.setState({ loading: true });
                if (infoProcesso.open)
                    _this.buscaInfoProcesso(infoProcesso.info[0]);
                api_1.recebeThread({ cdThread: thread.thread, qt: qt, nrPg: nrPg }).then(function (res) {
                    var processos = res.processos.map(function (item) {
                        switch (item[3]) {
                            case 'P':
                                item[3] = 'Pronto';
                                break;
                            case 'R':
                                item[3] = 'Executando';
                                break;
                            default: item[3] = 'Finalizado';
                        }
                        switch (item[4]) {
                            case 'N':
                                item[4] = 'Normal';
                                break;
                            case 'C':
                                item[4] = 'Cancelado';
                                break;
                            case 'E':
                                item[4] = 'Erro';
                                break;
                            default: item[4] = '';
                        }
                        var inicio = date_1.sqlDateToReadableDate(item[6]);
                        var fim = date_1.sqlDateToReadableDate(item[7]);
                        item[6] = inicio.hour + " - " + inicio.date;
                        item[7] = fim.hour + " - " + fim.date;
                        return item;
                    });
                    _this.setState({ loading: false });
                    fieldsRedux_1.setField(_this.props.currentProgram + "-threads", 'value', processos);
                });
            }
        };
        _this.visualizaProcesso = function (processo) {
            _this.setState({ loading: true });
            _this.buscaInfoProcesso(processo[0]);
        };
        _this.buscaInfoProcesso = function (idProcesso) {
            api_1.recebeInfoThread({ idProcesso: idProcesso }).then(function (res) {
                var confs = JSON.parse(res.infoProcesso[6]);
                var arr = [];
                for (var _i = 0, _a = Object.keys(confs); _i < _a.length; _i++) {
                    var key = _a[_i];
                    arr.push([key, confs[key].toString()]);
                }
                if (res.currentStatus) {
                    _this.timeoutInfoProcesso = setTimeout(function () {
                        _this.buscaInfoProcesso(idProcesso);
                    }, 3000);
                }
                _this.setState({
                    infoProcesso: {
                        open: true,
                        info: res.infoProcesso,
                        confs: arr,
                        current: res.currentStatus
                    },
                    loading: false
                });
            });
        };
        _this.closeInfoProcesso = function () {
            clearTimeout(_this.timeoutInfoProcesso);
            _this.setState({
                infoProcesso: {
                    open: false,
                    info: {},
                    confs: {},
                    current: {}
                }
            });
        };
        _this.closePanel = function () {
            var selectPanelClicks = _this.state.selectPanelClicks;
            if (selectPanelClicks > 0) {
                _this.setState({ open: false });
                window.removeEventListener('click', _this.closePanel);
            }
            _this.setState({ selectPanelClicks: selectPanelClicks + 1 });
        };
        return _this;
    }
    ThreadLog.prototype.componentWillUnmount = function () {
        window.removeEventListener('click', this.closePanel);
        clearTimeout(this.timeoutInfoProcesso);
    };
    ThreadLog.prototype.render = function () {
        var _a = this.state, open = _a.open, loading = _a.loading, infoProcesso = _a.infoProcesso;
        var _b = this.props, currentProgram = _b.currentProgram, thread = _b.thread;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(core_1.IconButton, { title: thread.nome, onClick: this.openDetails },
                react_1.default.createElement(ti_1.TiCog, { key: 'leave' })),
            open && (react_1.default.createElement("div", { onClick: function (e) { return e.stopPropagation(); } },
                react_1.default.createElement("h3", { className: 'reset-margin-top bg-blue-alt' },
                    infoProcesso.open && react_1.default.createElement("span", { className: 'pointer', onClick: this.closeInfoProcesso },
                        react_1.default.createElement(fa_1.FaAngleLeft, null)),
                    infoProcesso.open ? infoProcesso.info[2] : thread.nome),
                loading && (react_1.default.createElement("div", { className: 'loading-default margin-top-md margin-bottom-md' },
                    react_1.default.createElement(react_spinkit_1.default, { name: 'ball-scale-multiple', fadeIn: 'half' }))),
                !loading && (react_1.default.createElement("div", null,
                    infoProcesso.open && (react_1.default.createElement("div", null,
                        infoProcesso.current &&
                            react_1.default.createElement("div", { className: 'padding-sm' },
                                react_1.default.createElement("span", null, infoProcesso.current[7]),
                                react_1.default.createElement("span", { className: 'color999' },
                                    " - ",
                                    infoProcesso.current[6]),
                                react_1.default.createElement(ProgressBar_1.default, { value: parseInt(((infoProcesso.current[5] * 100) / infoProcesso.current[4]).toFixed(2), 10) }),
                                react_1.default.createElement("div", { className: 'over-hidden' },
                                    react_1.default.createElement("h6", { className: 'pull-left' },
                                        react_1.default.createElement("span", { className: 'color999' }, "Executando h\u00E1:"),
                                        " ",
                                        infoProcesso.current[1]),
                                    react_1.default.createElement("h6", { className: 'pull-right' },
                                        react_1.default.createElement("span", { className: 'color999' }, "Tempo estimado:"),
                                        " ",
                                        infoProcesso.current[3]))),
                        react_1.default.createElement(SimpleTable_1.default, { field: currentProgram + "-thread-info", className: 'reset-margin-bottom', defaultValue: infoProcesso.confs, destroyOnUnmount: true }),
                        infoProcesso.info[9].relatorios.length > 0 &&
                            react_1.default.createElement("div", null,
                                react_1.default.createElement("hr", { className: 'reset-margin' }),
                                react_1.default.createElement("div", { className: 'text-right padding-sm' }, infoProcesso.info[9].relatorios.map(function (item, index) {
                                    return react_1.default.createElement("a", { key: index, className: 'ag-threadlog-print', href: "" + (config_1.getConfig().ssl ? 'https' : 'http') + api_1.server() + "}r" + infoProcesso.info[0] + "s" + item[0] + ".agrel", target: '_blank', rel: 'noreferrer' },
                                        item[1],
                                        item[2] > 0 && react_1.default.createElement("span", { className: 'agtl-size' },
                                            "- ",
                                            item[2],
                                            " kb"),
                                        react_1.default.createElement("span", { className: 'agtl-print bg-blue-alt' },
                                            react_1.default.createElement(fa_1.FaPrint, null)));
                                }))))),
                    !infoProcesso.open && (react_1.default.createElement(SimpleTable_1.default, { field: currentProgram + "-threads", rows: 5, className: 'process-threads reset-margin-bottom', onClick: this.visualizaProcesso, head: ['Descrição', 'Status', 'Finalização', 'Início', 'Fim'], alias: [2, 3, 4, 6, 7] }))))))));
    };
    return ThreadLog;
}(react_1.Component));
ThreadLog.propTypes = {
    thread: prop_types_1.default.object,
    currentProgram: prop_types_1.default.string,
    qt: prop_types_1.default.number,
    nrPg: prop_types_1.default.number
};
exports.default = ThreadLog;
