"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("./fieldsRedux");
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
/**
 * @deprecated
 * @param {*} WrappedComponent -
 * @returns {*} -
 */
var passFields = function (WrappedComponent) {
    var HOCComponent = /** @class */ (function (_super) {
        __extends(HOCComponent, _super);
        function HOCComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.getField = function (field, key) {
                return fieldsRedux_1.getField(field, key);
            };
            _this.getPreviousField = function (p1, p2, p3) {
                return fieldsRedux_1.getPreviousField(p1, p2, p3);
            };
            _this.setField = function (p1, p2, p3) {
                if (typeof p2 === 'object') {
                    return fieldsRedux_1.setField(p1, p2);
                }
                return fieldsRedux_1.setField(p1, p2, p3);
            };
            _this.setFieldsByObject = function (object, prefix) {
                fieldsRedux_1.setFieldsByObject(object, prefix);
            };
            _this.getFieldsByPrefix = function (prefix, letPrefix) {
                return fieldsRedux_1.getFieldsByPrefix(prefix, letPrefix);
            };
            _this.waitFieldsData = function (wFields, wDatas, rejectMilliseconds, milliseconds) {
                if (wFields === void 0) { wFields = []; }
                if (wDatas === void 0) { wDatas = []; }
                if (rejectMilliseconds === void 0) { rejectMilliseconds = 5000; }
                if (milliseconds === void 0) { milliseconds = 100; }
                return fieldsRedux_1.waitFieldsData(wFields, wDatas, rejectMilliseconds, milliseconds);
            };
            _this.setServerValueToField = function (field) {
                return fieldsRedux_1.setServerValueToField(field);
            };
            _this.setFieldValueToServer = function (field) {
                return fieldsRedux_1.setFieldValueToServer(field);
            };
            _this.clearField = function (field) {
                fieldsRedux_1.clearField(field);
            };
            return _this;
        }
        HOCComponent.prototype.render = function () {
            return react_1.default.createElement(WrappedComponent, __assign({ getField: this.getField, getPreviousField: this.getPreviousField, setField: this.setField, waitFieldsData: this.waitFieldsData, setServerValueToField: this.setServerValueToField, setFieldValueToServer: this.setFieldValueToServer, clearField: this.clearField, setFieldsByObject: this.setFieldsByObject, getFieldsByPrefix: this.getFieldsByPrefix }, this.props));
        };
        return HOCComponent;
    }(react_1.Component));
    var mapStateToProps = function (state) {
        return { fields: state.argous.fields };
    };
    return react_redux_1.connect(mapStateToProps)(HOCComponent);
};
exports.default = passFields;
