"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var argous = function (state, action) {
    var _a, _b, _c, _d;
    if (state === void 0) { state = {
        usuarioLogado: {},
        loading: true,
        processos: [],
        favorites: [],
        initialPage: '/',
        fields: {},
        block: false,
        vldPsw: false,
        sidebar: true,
        rightSidebar: false,
        addProgramWidget: undefined,
        programAnnotation: {}
    }; }
    switch (action.type) {
        case 'setUsuarioLogado':
            return __assign(__assign({}, state), { usuarioLogado: action.usuarioLogado });
        case 'setLoading':
            return __assign(__assign({}, state), { loading: action.loading });
        case 'setProcesso':
            return __assign(__assign({}, state), { processos: action.processo });
        case 'setNotificacao':
            return __assign(__assign({}, state), { notificacao: action.notificacao });
        case 'setInitialPage':
            return __assign(__assign({}, state), { initialPage: action.initialPage });
        case 'setCurrentProgram':
            return __assign(__assign({}, state), { currentProgram: action.currentProgram });
        case 'setCurrentField':
            return __assign(__assign({}, state), { fields: state.fields[action.program]
                    ? __assign(__assign({}, state.fields), (_a = {}, _a[action.program] = __assign(__assign({}, state.fields[action.program]), (_b = {}, _b[action.field] = action.value, _b)), _a)) : __assign(__assign({}, state.fields), (_c = {}, _c[action.program] = (_d = {},
                    _d[action.field] = action.value,
                    _d), _c)) });
        case 'clearAllFields':
            return __assign(__assign({}, state), { fields: {} });
        case 'setFields':
            return __assign(__assign({}, state), { fields: action.fields });
        case 'setFavorites':
            return __assign(__assign({}, state), { favorites: action.favorites });
        case 'setBlockUser':
            return __assign(__assign({}, state), { block: action.block });
        case 'setVldPsw':
            return __assign(__assign({}, state), { block: action.vldPsw });
        case 'setSidebar':
            return __assign(__assign({}, state), { sidebar: action.sidebar });
        case 'setRightSidebar':
            return __assign(__assign({}, state), { rightSidebar: action.rightSidebar });
        case 'setAddProgramWidget':
            return __assign(__assign({}, state), { addProgramWidget: action.addProgramWidget });
        case 'setMensagensNaoLidas':
            return __assign(__assign({}, state), { mensagensNaoLidas: action.mensagensNaoLidas });
        case 'setProgramAnnotation':
            return __assign(__assign({}, state), { programAnnotation: action.programAnnotation });
        default:
            return state;
    }
};
exports.default = argous;
