"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopPrntScr = exports.printUrl = exports.geraLog = exports.printScreen = exports.cpfTest = exports.dataUrlToBlob = exports.formatCpfCnpj = exports.bytesTranslator = exports.storageMeasures = exports.confirm = exports.copyToClipboard = exports.toFloat = exports.currencyMask = exports.numbersOnly = exports.formataCpf = exports.useWebSocket = exports.formataTelefone = exports.reduxDispatch = exports.useStore = exports.useModal = exports.useGraph = exports.randomColor = exports.humanFileSize = exports.sanitizaHTML = exports.formataDinheiro = exports.useUpdateEffect = exports.usePrevious = exports.getNumeroFromInitials = exports.getInitials = exports.getRandomColor = exports.printPdf = exports.downloadFromUrl = exports.downloadBase64 = exports.formataNome = exports.addExtraZero = exports.getCookie = exports.widthToCenterVertically = void 0;
var api_1 = require("./api");
var store_1 = require("./store");
var api_2 = require("../api");
var ModalProvider_1 = require("../components/ConfirmModal/ModalProvider");
var fieldsRedux_1 = require("../fieldsRedux");
var core_1 = require("@material-ui/core");
var colors = __importStar(require("@material-ui/core/colors"));
var dom_to_image_1 = __importDefault(require("dom-to-image"));
var lodash_1 = require("lodash");
var moment_1 = __importDefault(require("moment"));
var react_1 = require("react");
var widthToCenterVertically = function (content) {
    var B = document.body;
    var H = document.documentElement;
    var height = Math.max(B.scrollHeight, B.offsetHeight, H.clientHeight, H.scrollHeight, H.offsetHeight);
    return (height - content) / 2;
};
exports.widthToCenterVertically = widthToCenterVertically;
var getCookie = function (cName) {
    if (document.cookie.length > 0) {
        var cStart = document.cookie.indexOf(cName + '=');
        if (cStart !== -1) {
            cStart = cStart + cName.length + 1;
            var cEnd = document.cookie.indexOf(';', cStart);
            if (cEnd === -1) {
                cEnd = document.cookie.length;
            }
            return unescape(document.cookie.substring(cStart, cEnd));
        }
    }
    return '';
};
exports.getCookie = getCookie;
var addExtraZero = function (vl) { return (vl < 10) ? "0" + (typeof vl === 'string' ? parseInt(vl) : vl) : vl; };
exports.addExtraZero = addExtraZero;
var formataNome = function (value) {
    if (value) {
        var nome = value.toLowerCase().split(' ');
        for (var i = 0; i < nome.length; i++)
            nome[i] = nome[i].charAt(0).toUpperCase() + nome[i].substring(1);
        return nome.join(' ');
    }
    return '';
};
exports.formataNome = formataNome;
function downloadBase64(base64, fileName, fileExtension) {
    var element = document.createElement('a');
    element.setAttribute('href', base64);
    element.setAttribute('download', fileExtension ? fileName + "." + fileExtension : fileName);
    element.style.display = 'none';
    document.body.appendChild(element);
    element.click();
    document.body.removeChild(element);
}
exports.downloadBase64 = downloadBase64;
/**
 * Função faz o download de qualquer url
 *
 * @param {string} url - Url a ser baixada
 * @param {string} fileName - Nome do arquivo baixado
 * @param {string=} fileExtension - Extenção do arquivo baixado
 *
 * @returns {void}
 */
function downloadFromUrl(url, fileName, fileExtension) {
    return __awaiter(this, void 0, void 0, function () {
        var blob, urlCreator, tag;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(url, { method: 'GET', headers: api_2.headers() })];
                case 1: return [4 /*yield*/, (_a.sent()).blob()];
                case 2:
                    blob = _a.sent();
                    urlCreator = URL || window.URL || window.webkitURL;
                    tag = document.createElement('a');
                    tag.href = urlCreator.createObjectURL(blob);
                    tag.download = fileExtension ? fileName + "." + fileExtension : fileName;
                    tag.style.display = 'none';
                    document.body.appendChild(tag);
                    tag.click();
                    document.body.removeChild(tag);
                    return [2 /*return*/];
            }
        });
    });
}
exports.downloadFromUrl = downloadFromUrl;
var printPdf = function (URL) {
    if (URL === void 0) { URL = ''; }
    return __awaiter(void 0, void 0, void 0, function () {
        var url, iframe;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, api_2.getFileFromLink({ URL: URL })];
                case 1:
                    url = _a.sent();
                    iframe = document.createElement('iframe');
                    document.body.appendChild(iframe);
                    iframe.style.display = 'none';
                    iframe.onload = function () { var _a; return (_a = iframe.contentWindow) === null || _a === void 0 ? void 0 : _a.print(); };
                    if (iframe.contentWindow)
                        iframe.contentWindow.onafterprint = function () { return document.removeChild(iframe); };
                    iframe.src = url;
                    return [2 /*return*/];
            }
        });
    });
};
exports.printPdf = printPdf;
var getRandomColor = function () {
    var letters = '0123456789ABCDEF';
    var color = '#';
    for (var i = 0; i < 6; i++)
        color += letters[Math.floor(Math.random() * 16)];
    return color;
};
exports.getRandomColor = getRandomColor;
var RNG = /** @class */ (function () {
    function RNG(seed) {
        // LCG using GCC's constants
        this.m = 0x80000000; // 2**31;
        this.a = 1103515245;
        this.c = 12345;
        this.state = seed ? seed : Math.floor(Math.random() * (this.m - 1));
    }
    RNG.prototype.nextInt = function () {
        this.state = (this.a * this.state + this.c) % this.m;
        return this.state;
    };
    RNG.prototype.nextFloat = function () {
        return this.nextInt() / (this.m - 1);
    };
    RNG.prototype.nextRange = function (start, end) {
        var rangeSize = end - start;
        var randomUnder1 = this.nextInt() / this.m;
        return start + Math.floor(randomUnder1 * rangeSize);
    };
    RNG.prototype.choice = function (array) {
        return array[this.nextRange(0, array.length)];
    };
    return RNG;
}());
var getInitials = function (nome) {
    if (nome === void 0) { nome = ''; }
    return "" + nome.split(' ')[0].substring(0, 1).toUpperCase() + nome.split(' ')[nome.split(' ').length - 1].substring(0, 1).toUpperCase();
};
exports.getInitials = getInitials;
var getNumeroFromInitials = function (initials, length) { return Math.ceil(new RNG((initials.charCodeAt(0) + initials.charCodeAt(1) - 130) * length / 5).nextFloat() * 10) - 1; };
exports.getNumeroFromInitials = getNumeroFromInitials;
var usePrevious = function (value) {
    var ref = react_1.useRef();
    react_1.useEffect(function () {
        ref.current = value;
    });
    return ref.current;
};
exports.usePrevious = usePrevious;
/**
 * Igual o useEffect, mas não ativa quando o componente monta
 *
 * @param {React.EffectCallback} effect - Função imperativa que pode retornar uma função de limpeza
 * @param {React.DependencyList} dependencies - Dependencias que quando atualizadas rodarão o efeito
 *
 * @returns {void} Sem retorno
 */
function useUpdateEffect(effect, dependencies) {
    var isInitialMount = react_1.useRef(true);
    react_1.useEffect(function () {
        if (isInitialMount.current)
            isInitialMount.current = false;
        else
            effect();
    }, dependencies);
}
exports.useUpdateEffect = useUpdateEffect;
function formataDinheiro(n) {
    if (n >= 0)
        return new Intl.NumberFormat('pt-BR', { minimumFractionDigits: 2 }).format(n);
    return "(" + new Intl.NumberFormat('pt-BR', { minimumFractionDigits: 2 }).format(Math.abs(n)) + ")";
}
exports.formataDinheiro = formataDinheiro;
var sanitizaHTML = function (html) {
    if (html === void 0) { html = ''; }
    return (html === null || html === void 0 ? void 0 : html.replace(/(<script>)|(<\/script>)|(\bon[^ ]*=('|"))/gi, '')) || '';
};
exports.sanitizaHTML = sanitizaHTML;
/**
 * Format bytes as human-readable text.
 *
 * @param {number} bytes - Number of bytes.
 * @param {boolean} si - True to use metric (SI) units, aka powers of 1000. False to use binary (IEC) units, aka powers of 1024.
 * @param {number} dp - Number of decimal places to display.
 *
 * @returns {string} Formatted string.
 */
var humanFileSize = function (bytes, si, dp) {
    if (si === void 0) { si = true; }
    if (dp === void 0) { dp = 2; }
    var thresh = si ? 1000 : 1024;
    if (Math.abs(bytes) < thresh)
        return bytes + " B";
    var units = si
        ? ['kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB']
        : ['KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'];
    var u = -1;
    var r = Math.pow(10, dp);
    do {
        bytes /= thresh;
        ++u;
    } while (Math.round(Math.abs(bytes) * r) / r >= thresh && u < units.length - 1);
    return bytes.toFixed(dp) + " " + units[u];
};
exports.humanFileSize = humanFileSize;
var chaves = Object.keys(colors).filter(function (i) { return i !== 'common'; });
var randomColor = function () {
    var color = colors[chaves[Math.floor(chaves.length * Math.random())]];
    var chavesCor = Object.keys(color);
    return color[chavesCor[Math.floor(chavesCor.length * Math.random())]];
};
exports.randomColor = randomColor;
/**
 * Hook para padronizar o tema dos gráficos
 *
 * @param {ChartOptions} props - Props customizados
 * @returns {ChartOptions} - retorno com tema ajustado
 */
var useGraph = function (_a) {
    if (_a === void 0) { _a = {}; }
    var title = _a.title, _b = _a.legend, _c = _b === void 0 ? {} : _b, labels = _c.labels, legend = __rest(_c, ["labels"]), _d = _a.plugins, _e = _d === void 0 ? {} : _d, datalabels = _e.datalabels, plugins = __rest(_e, ["datalabels"]), _f = _a.scales, _g = _f === void 0 ? {} : _f, _h = _g.yAxes, _j = _h === void 0 ? [] : _h, _k = _j, _l = _k[0], y = _k.slice(1), _m = _l === void 0 ? {} : _l, _o = _m.ticks, yticks = _o === void 0 ? {} : _o, _p = _m.gridLines, ygridLines = _p === void 0 ? {} : _p, yAxes = __rest(_m, ["ticks", "gridLines"]), _q = _g.xAxes, _r = _q === void 0 ? [] : _q, _s = _r, _t = _s[0], x = _s.slice(1), _u = _t === void 0 ? {} : _t, _v = _u.ticks, xticks = _v === void 0 ? {} : _v, _w = _u.gridLines, xgridLines = _w === void 0 ? {} : _w, xAxes = __rest(_u, ["ticks", "gridLines"]), scales = __rest(_g, ["yAxes", "xAxes"]), props = __rest(_a, ["title", "legend", "plugins", "scales"]);
    var theme = core_1.useTheme();
    return __assign({ title: __assign({ fontColor: theme.palette.text.primary, fontSize: theme.typography.fontSize }, title), legend: __assign({ position: 'bottom', labels: __assign({ fontColor: theme.palette.text.primary }, labels) }, legend), plugins: __assign({ datalabels: __assign({ align: 'end', anchor: 'end', color: theme.palette.text.secondary, textShadowColor: theme.palette.background.default, textShadowBlur: 3 }, datalabels) }, plugins), scales: __assign({ yAxes: __spreadArray([__assign({ ticks: __assign({ fontColor: theme.palette.text.secondary }, yticks), gridLines: __assign({ color: theme.palette.divider, zeroLineColor: theme.palette.divider }, ygridLines) }, yAxes)], y), xAxes: __spreadArray([__assign({ ticks: __assign({ fontColor: theme.palette.text.secondary }, xticks), gridLines: __assign({ color: theme.palette.divider, zeroLineColor: theme.palette.divider }, xgridLines) }, xAxes)], x) }, scales) }, props);
};
exports.useGraph = useGraph;
var useModal = function () {
    var createModal = react_1.useContext(ModalProvider_1.ModalProviderContext);
    return createModal;
};
exports.useModal = useModal;
var useStore = function () {
    return store_1.getStore().getState().argous || {};
};
exports.useStore = useStore;
var reduxDispatch = function (action) {
    store_1.getStore().dispatch(action);
};
exports.reduxDispatch = reduxDispatch;
var formataTelefone = function (value) {
    if (!value)
        return value;
    var currentValue = value.replace(/[^\d]/g, '');
    var cvLength = currentValue.length;
    if (cvLength < 3)
        return currentValue;
    if (cvLength < 7)
        return "(" + currentValue.slice(0, 2) + ") " + currentValue.slice(2);
    if (cvLength < 11)
        return "(" + currentValue.slice(0, 2) + ") " + currentValue.slice(2, 6) + "-" + currentValue.slice(6);
    return "(" + currentValue.slice(0, 2) + ") " + currentValue.slice(2, 7) + "-" + currentValue.slice(7, 11);
};
exports.formataTelefone = formataTelefone;
var useWebSocket = function () {
    var _a = react_1.useState({}), value = _a[0], setValue = _a[1];
    react_1.useEffect(function () {
        fieldsRedux_1.setField('WSHandler', { onMessage: setValue });
    }, []);
    return value;
};
exports.useWebSocket = useWebSocket;
var formataCpf = function (value) { return value === null || value === void 0 ? void 0 : value.replace(/[^\d]/, '').replace(/^(.{3})(.{3})(.{3})(.{2})$/, '$1.$2.$3-$4'); };
exports.formataCpf = formataCpf;
var numbersOnly = function (value, type) { return value ? value.replace(type === 'float' ? /[^0-9/.,]/g : /[^0-9]/g, '') : ''; };
exports.numbersOnly = numbersOnly;
var currencyMask = function (value) {
    if (value === 0)
        return value.toString() + ",00";
    if (!value)
        return '';
    if (lodash_1.isNumber(value))
        value = value.toFixed(2);
    value = value.toString();
    value = value.replace(/\D/g, '');
    value = value.replace(/(\d)(\d{2})$/, '$1,$2');
    value = value.replace(/(?=(\d{3})+(\D))\B/g, '.');
    return value;
};
exports.currencyMask = currencyMask;
var toFloat = function (value) {
    if (!value)
        return;
    value = value.replace(/[.]/g, '');
    value = value.replace(/[,]/g, '.');
    return parseFloat(value);
};
exports.toFloat = toFloat;
var copyToClipboard = function (text) {
    if (navigator.clipboard)
        navigator.clipboard.writeText(text);
    else {
        var textField = document.createElement('input');
        textField.setAttribute('value', text);
        document.body.appendChild(textField);
        textField.focus();
        textField.select();
        textField.setSelectionRange(0, 99999);
        document.execCommand('copy');
        textField.remove();
    }
};
exports.copyToClipboard = copyToClipboard;
var confirm = function (props) { return new Promise(function (resolve, reject) {
    fieldsRedux_1.setAnotherProgramField('openModal', { value: Object.assign({ resolve: resolve, reject: reject, okLabel: 'Confirmar', cancelLabel: 'Cancelar', title: 'Confirmar?' }, typeof props === 'string' ? { description: props } : props) }, 'argousSystem');
}); };
exports.confirm = confirm;
exports.storageMeasures = {
    byte: 'B',
    kilobyte: 'KB',
    megabyte: 'MB',
    gigabyte: 'GB',
    terabyte: 'TB',
    petabyte: 'PB',
    exabyte: 'EB'
};
var bytesTranslator = function (bytes, decimals, binary) {
    if (bytes === void 0) { bytes = 0; }
    if (decimals === void 0) { decimals = 2; }
    if (binary === void 0) { binary = false; }
    var measures = Object.values(exports.storageMeasures);
    var divisor = ((binary) ? 1024 : 1000);
    decimals = ((decimals < 0) ? 0 : decimals);
    var index = Math.floor(Math.log(bytes) / Math.log(divisor));
    if (index < 0)
        index = 0;
    var size = parseFloat((bytes / Math.pow(divisor, index)).toFixed(decimals));
    var type = measures[index];
    return { type: type, size: size };
};
exports.bytesTranslator = bytesTranslator;
var formatCpfCnpj = function (value) {
    if (!value)
        return '';
    if (lodash_1.isNumber(value))
        value = value.toString();
    value = value.replace(/[^\d]/g, '');
    var valueLen = value.length;
    if (valueLen > 3 && valueLen < 7)
        value = value.substring(0, 3) + "." + value.substring(3);
    else if (valueLen > 6 && valueLen < 10)
        value = value.substring(0, 3) + "." + value.substring(3, 6) + "." + value.substring(6);
    else if (valueLen > 8 && valueLen < 12)
        value = value.substring(0, 3) + "." + value.substring(3, 6) + "." + value.substring(6, 9) + "-" + value.substring(9);
    else if (valueLen > 11 && valueLen < 13)
        value = value.substring(0, 2) + "." + value.substring(2, 5) + "." + value.substring(5, 8) + "/" + value.substring(8);
    else if (valueLen > 12)
        value = value.substring(0, 2) + "." + value.substring(2, 5) + "." + value.substring(5, 8) + "/" + value.substring(8, 12) + "-" + value.substring(12, 14);
    return value;
};
exports.formatCpfCnpj = formatCpfCnpj;
function dataUrlToBlob(dataUrl) {
    if (!dataUrl)
        return;
    var byteString = atob(dataUrl.split(',')[1]);
    var mimeString = dataUrl.split(',')[0].split(':')[1].split(';')[0];
    var arrayBuffer = new ArrayBuffer(byteString.length);
    var intArray = new Uint8Array(arrayBuffer);
    for (var i = 0; i < byteString.length; i++) {
        intArray[i] = byteString.charCodeAt(i);
    }
    var blob = new Blob([arrayBuffer], { type: mimeString });
    return blob;
}
exports.dataUrlToBlob = dataUrlToBlob;
function cpfTest(cpf) {
    if (cpf === '00000000000' || !cpf)
        return false;
    if (typeof cpf === 'number')
        cpf = cpf.toString();
    var sum = 0;
    var rest;
    for (var index = 1; index <= 9; index++)
        sum += (parseInt(cpf.substring(index - 1, index)) * (11 - index));
    rest = ((sum * 10) % 11);
    if ((rest === 10) || (rest === 11))
        rest = 0;
    if (rest !== parseInt(cpf.substring(9, 10)))
        return false;
    sum = 0;
    for (var index = 1; index <= 10; index++)
        sum += (parseInt(cpf.substring(index - 1, index)) * (12 - index));
    rest = ((sum * 10) % 11);
    if ((rest === 10) || (rest === 11))
        rest = 0;
    if (rest !== parseInt(cpf.substring(10, 11)))
        return false;
    return true;
}
exports.cpfTest = cpfTest;
var printScreen = function (_a) {
    var event = _a.event, _b = _a.id, id = _b === void 0 ? 'root' : _b, _c = _a.download, download = _c === void 0 ? false : _c;
    return __awaiter(void 0, void 0, void 0, function () {
        var status, file, linkElement, element, dataUrl, blob;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    status = false;
                    element = document.getElementById(id);
                    if (!element) return [3 /*break*/, 2];
                    return [4 /*yield*/, dom_to_image_1.default.toPng(element)];
                case 1:
                    dataUrl = _d.sent();
                    if (dataUrl) {
                        linkElement = document.createElement('a');
                        linkElement.download = "print_screen_" + moment_1.default(new Date()).format('DD-MM-YYYY_HH:mm:ss') + ".png";
                        linkElement.href = dataUrl;
                        blob = dataUrlToBlob(dataUrl);
                        if (blob)
                            file = new File([blob], linkElement.download, { type: blob.type });
                    }
                    _d.label = 2;
                case 2:
                    (linkElement && file) && (status = true);
                    (linkElement && download) && linkElement.click();
                    return [2 /*return*/, { event: event, status: status, file: file, element: element, link: linkElement }];
            }
        });
    });
};
exports.printScreen = printScreen;
var geraLog = function (idDocumento, descricao, tpAcao, tokenSistema) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b, _c, _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                if (!((_d = (_c = (_b = (_a = store_1.getStore()) === null || _a === void 0 ? void 0 : _a.getState()) === null || _b === void 0 ? void 0 : _b.argous) === null || _c === void 0 ? void 0 : _c.usuarioLogado) === null || _d === void 0 ? void 0 : _d.idUsuario))
                    return [2 /*return*/];
                return [4 /*yield*/, api_1.serverAction('geraLog', { idDocumento: idDocumento, descricao: descricao, tpAcao: tpAcao }, 'CtrlDocumentos', false, tokenSistema)];
            case 1:
                _e.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.geraLog = geraLog;
var printUrl = function (url) { return __awaiter(void 0, void 0, void 0, function () {
    var res, file, iframe;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(url)];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.blob()];
            case 2:
                file = _a.sent();
                iframe = document.createElement('iframe');
                document.body.appendChild(iframe);
                iframe.style.display = 'none';
                iframe.src = window.URL.createObjectURL(file);
                iframe.onload = function () {
                    setTimeout(function () {
                        var _a;
                        iframe.focus();
                        (_a = iframe === null || iframe === void 0 ? void 0 : iframe.contentWindow) === null || _a === void 0 ? void 0 : _a.print();
                    }, 1);
                };
                return [2 /*return*/];
        }
    });
}); };
exports.printUrl = printUrl;
function stopPrntScr(e) {
    if (e.key === 'PrintScreen') {
        e.preventDefault();
        e.stopPropagation();
        try {
            window.clipboardData.setData('text', 'Access Restricted');
        }
        catch (err) { }
    }
    var inpFld = document.createElement('input');
    inpFld.setAttribute('value', '.');
    inpFld.setAttribute('width', '0');
    inpFld.style.height = '0px';
    inpFld.style.width = '0px';
    inpFld.style.border = '0px';
    document.body.appendChild(inpFld);
    inpFld.select();
    document.execCommand('copy');
    inpFld.remove();
    return false;
}
exports.stopPrntScr = stopPrntScr;
