import { UsuarioLogado } from '../types';

export const setUsuarioLogado = (usuarioLogado: UsuarioLogado) => {
  return { type: 'setUsuarioLogado', usuarioLogado };
};

export const setLoading = (loading: boolean) => {
  return { type: 'setLoading', loading };
};

export const setProcesso = (processo: any) => {
  return { type: 'setProcesso', processo };
};

export const setInitialPage = (initialPage: string) => {
  return { type: 'setInitialPage', initialPage };
};

export const setCurrentProgram = (currentProgram: string) => {
  return { type: 'setCurrentProgram', currentProgram };
};

export const setCurrentField = (program: string, field: string, value: any) => {
  return { type: 'setCurrentField', program, field, value };
};

export const clearAllFields = () => {
  return { type: 'clearAllFields' };
};

export const setFields = (fields: any) => {
  return { type: 'setFields', fields };
};

export const setFavorites = (favorites: any[]) => {
  return { type: 'setFavorites', favorites };
};

export const setBlockUser = (block: boolean) => {
  return { type: 'setBlockUser', block };
};

export const setNotificacao = (notificacao: any) => {
  return { type: 'setNotificacao', notificacao };
};

export const setSidebar = (sidebar: boolean) => {
  return { type: 'setSidebar', sidebar };
};

export const setRightSidebar = (rightSidebar: boolean) => {
  return { type: 'setRightSidebar', rightSidebar };
};

export const setAddProgramWidget = (addProgramWidget: any) => {
  return { type: 'setAddProgramWidget', addProgramWidget };
};

export const setMensagensNaoLidas = (mensagensNaoLidas: number) => {
  return { type: 'setMensagensNaoLidas', mensagensNaoLidas };
};

export const setVldPsw = (vldPsw: boolean) => {
  return { type: 'vldPsw', vldPsw };
};

export const setProgramAnnotation = (programAnnotation: object) => {
  return { type: 'setProgramAnnotation', programAnnotation };
};