import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated
 */
class Alert extends Component {
  render() {
    const {
      titulo,
      mensagem,
      type = 'info',
      small,
      onClose,
      className = '',
      style,
    } = this.props;

    return (
      <div>
        {((mensagem) && (
          <div style={style} className={`pg-alert pg-alert-dismissible reset-margin pg-alert-${type} ${(small && 'pg-alert-sm')} ${className}`}>
            {(onClose && (
              <button onClick={onClose} type='button' className='close'>×</button>
            ))}
            {(titulo && (
              <h4>{titulo}</h4>
            ))}
            {(mensagem && (
              <p>{mensagem}</p>
            ))}
          </div>
        ))}
      </div>
    );
  }
}

Alert.propTypes = {
  titulo: PropTypes.string,
  mensagem: PropTypes.string,
  type: PropTypes.oneOf(['info', 'success', 'warning', 'danger']),
  small: PropTypes.bool,
  onClose: PropTypes.func,
  className: PropTypes.string,
  style: PropTypes.object,
};

export default Alert;
