import PropTypes from 'prop-types';
import React, { Component } from 'react';
import ReactPaginate from 'react-paginate';

/**
 * @deprecated 
 */
class Pagination extends Component {
  render() {
    const {
      pages,
      className = '',
      onChange,
      initialPage
    } = this.props;

    return (
      <div className={className}>
        <ReactPaginate initialPage={initialPage} pageCount={pages} pageRangeDisplayed={4} marginPagesDisplayed={0} onPageChange={onChange} previousLabel='Anterior' nextLabel='Próximo' activeClassName='active' containerClassName='pagination n-select reset-margin'/>
      </div>
    );
  }
}

Pagination.propTypes = {
  pages: PropTypes.number.isRequired,
  className: PropTypes.string,
  onChange: PropTypes.func,
  initialPage: PropTypes.number
};

export default Pagination;
