"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProgramAnnotations = exports.getPublicDoc = exports.sendWidgets = exports.getWidgetInfo = exports.getWidgets = exports.scanDocument = exports.getLink = exports.getFileFromLink = exports.createDocument = exports.prepareFile = exports.getDocsUrl = exports.searchUsers = exports.getFileInfo = exports.cancelFileUpload = exports.endFileUpload = exports.sendFilePart = exports.inicFileUpload = exports.enviaCompartilhamentoDePrograma = exports.fixTimelinePost = exports.removePostTimeLine = exports.publicaTimeline = exports.toggleLikePost = exports.recebeInfoEstatisticas = exports.recebeInfoLoginsAtivos = exports.recebeThreadsUsuario = exports.recebeInfoThread = exports.recebeThread = exports.readNotificacao = exports.readNotificacoes = exports.getNotificacoes = exports.callProgram = exports.toggleFavorite = exports.getFavorites = exports.method = exports.action = exports.agSet = exports.agGet = exports.getProgram = exports.getPostPublicacao = exports.removeCommentPost = exports.addCommentPost = exports.getPostsTimeline = exports.getMenu = exports.validaToken = exports.logout = exports.login = exports.fetchToArgous = exports.headers = exports.api = exports.server = void 0;
exports.sendProgramAnnotation = exports.saveProgramAnnotation = void 0;
var utils_1 = require("../utils");
var config_1 = require("../utils/config");
var server = function () { return "://" + config_1.getConfig()[/^[a-z]+.+\.com\.br$/.test(window.location.host) ? 'ip' : 'ip'] + "/" + (config_1.getConfig().path ? config_1.getConfig().path : 'jUniIII') + "/"; };
exports.server = server;
var api = function () { return "" + (config_1.getConfig().ssl ? 'https' : 'http') + exports.server() + "argous/"; };
exports.api = api;
var headers = function (token) { return ({ lgTkn: (token) ? token : utils_1.getCookie('lt') }); };
exports.headers = headers;
/**
 * @deprecated
 *
 * @param {string} request - Metodo chamado
 * @param {*} data - Dados Enviados
 *
 * @returns {*} retorno
 */
var fetchToArgous = function (request, data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch("" + exports.api() + request + ".rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.fetchToArgous = fetchToArgous;
var login = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aglogin.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.login = login;
var logout = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aglogout.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.logout = logout;
var validaToken = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agvldtkn.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.validaToken = validaToken;
var getMenu = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agetmenu.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getMenu = getMenu;
var getPostsTimeline = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agtimeline.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getPostsTimeline = getPostsTimeline;
var addCommentPost = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agpostcomment.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.addCommentPost = addCommentPost;
var removeCommentPost = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agrmcomentario.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.removeCommentPost = removeCommentPost;
var getPostPublicacao = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aggetpost.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getPostPublicacao = getPostPublicacao;
var getProgram = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agpgm.rslvr", {
                    method: 'POST',
                    body: JSON.stringify({ pgCode: data }),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getProgram = getProgram;
/**
 * @deprecated
 *
 * @param {*} data - Dados
 *
 * @returns {object} retorno
 */
var agGet = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agget.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.agGet = agGet;
/**
 * @deprecated
 *
 * @param {*} data - Dados
 *
 * @returns {object} retorno
 */
var agSet = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agset.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.agSet = agSet;
var action = function (data, token) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agaction.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers(token)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.action = action;
/**
 * @deprecated
 *
 * @param {*} data - Dados
 *
 * @returns {object} retorno
 */
var method = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agmethod.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.method = method;
var getFavorites = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agfvrts.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getFavorites = getFavorites;
var toggleFavorite = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agchfvrts.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.toggleFavorite = toggleFavorite;
var callProgram = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agcallpgm.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.callProgram = callProgram;
var getNotificacoes = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agnotfctn.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getNotificacoes = getNotificacoes;
var readNotificacoes = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agnotvista.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.readNotificacoes = readNotificacoes;
var readNotificacao = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agnotlida.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.readNotificacao = readNotificacao;
var recebeThread = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agthreads.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.recebeThread = recebeThread;
var recebeInfoThread = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aginfothread.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.recebeInfoThread = recebeInfoThread;
var recebeThreadsUsuario = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agthreadsusuario.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.recebeThreadsUsuario = recebeThreadsUsuario;
var recebeInfoLoginsAtivos = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agloginsativos.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.recebeInfoLoginsAtivos = recebeInfoLoginsAtivos;
var recebeInfoEstatisticas = function () { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agstatistics.rslvr", {
                    method: 'POST',
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.recebeInfoEstatisticas = recebeInfoEstatisticas;
var toggleLikePost = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aglike.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.toggleLikePost = toggleLikePost;
var publicaTimeline = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agpost.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.publicaTimeline = publicaTimeline;
var removePostTimeLine = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agerasepost.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.removePostTimeLine = removePostTimeLine;
var fixTimelinePost = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agfixapost.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.fixTimelinePost = fixTimelinePost;
var enviaCompartilhamentoDePrograma = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agsharepost.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.enviaCompartilhamentoDePrograma = enviaCompartilhamentoDePrograma;
var inicFileUpload = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "getProtocol.filepart", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inicFileUpload = inicFileUpload;
var sendFilePart = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "setFilePart.filepart", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.sendFilePart = sendFilePart;
var endFileUpload = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "setEndFileUpload.filepart", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.endFileUpload = endFileUpload;
var cancelFileUpload = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "setFileUploadCancel.filepart", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.cancelFileUpload = cancelFileUpload;
var getFileInfo = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "getFileUploadInfo.filepart", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getFileInfo = getFileInfo;
var searchUsers = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aggetlistausuarios.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.searchUsers = searchUsers;
var getDocsUrl = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agdocsurl.rslvr", {
                    method: 'POST',
                    body: JSON.stringify(data),
                    headers: exports.headers()
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getDocsUrl = getDocsUrl;
var prepareFile = function (file) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, status, docsUrl, formData, res, _b, _c;
    var _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0: return [4 /*yield*/, exports.getDocsUrl()];
            case 1:
                _a = _e.sent(), status = _a.status, docsUrl = _a.docsUrl;
                if (!status)
                    return [2 /*return*/];
                formData = new FormData();
                formData.append('blob', file);
                return [4 /*yield*/, fetch(docsUrl + "/argous/docs/upload.agdoc", {
                        method: 'POST',
                        headers: exports.headers(),
                        body: formData
                    })];
            case 2:
                res = _e.sent();
                _b = [{}];
                return [4 /*yield*/, res.json()];
            case 3:
                _c = [__assign.apply(void 0, _b.concat([_e.sent()]))];
                _d = { lastModified: file.lastModified, lastModifiedDate: file.lastModifiedDate, name: file.name, size: file.size, type: file.type, webkitRelativePath: file.webkitRelativePath };
                return [4 /*yield*/, file.arrayBuffer()];
            case 4: return [2 /*return*/, __assign.apply(void 0, _c.concat([(_d.arrayBuffer = _e.sent(), _d)]))];
        }
    });
}); };
exports.prepareFile = prepareFile;
var createDocument = function (_a) {
    var idUnidade = _a.idUnidade, cdUnidade = _a.cdUnidade, idDocPai = _a.idDocPai, path = _a.path, dsKeyWords = _a.dsKeyWords, dtValidade = _a.dtValidade, idTipoDocumento = _a.idTipoDocumento, FileName = _a.FileName, title = _a.title, idRecebimento = _a.idRecebimento, tpPrivacidade = _a.tpPrivacidade, description = _a.description, dsClassificacao = _a.dsClassificacao, dsCategoria = _a.dsCategoria, dsSubCategoria = _a.dsSubCategoria, snSensivel = _a.snSensivel;
    return __awaiter(void 0, void 0, void 0, function () {
        var _b, status, docsUrl;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, exports.getDocsUrl()];
                case 1:
                    _b = _c.sent(), status = _b.status, docsUrl = _b.docsUrl;
                    if (!status)
                        return [2 /*return*/];
                    return [4 /*yield*/, fetch(docsUrl + "argous/docs/upload.agdoc", {
                            method: 'POST',
                            headers: exports.headers(),
                            body: JSON.stringify({
                                idUnidade: idUnidade, cdUnidade: cdUnidade, idDocPai: idDocPai, path: path,
                                dsKeyWords: dsKeyWords, dtValidade: dtValidade, idTipoDocumento: idTipoDocumento,
                                FileName: FileName, title: title, idRecebimento: idRecebimento,
                                tpPrivacidade: tpPrivacidade, description: description, dsClassificacao: dsClassificacao,
                                dsCategoria: dsCategoria, dsSubCategoria: dsSubCategoria, snSensivel: snSensivel
                            })
                        })];
                case 2: return [2 /*return*/, (_c.sent()).json()];
            }
        });
    });
};
exports.createDocument = createDocument;
var getFileFromLink = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.URL, link = _c === void 0 ? '' : _c, _d = _b.token, token = _d === void 0 ? '' : _d;
    return __awaiter(void 0, void 0, void 0, function () {
        var file;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!link)
                        return [2 /*return*/, ''];
                    return [4 /*yield*/, fetch(link, {
                            method: 'post',
                            headers: exports.headers(token)
                        })];
                case 1: return [4 /*yield*/, (_e.sent()).blob()];
                case 2:
                    file = _e.sent();
                    return [2 /*return*/, URL.createObjectURL(file)];
            }
        });
    });
};
exports.getFileFromLink = getFileFromLink;
var getLink = function (idDocumento, nrRevisao, timeout) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!idDocumento)
                    return [2 /*return*/, ''];
                return [4 /*yield*/, fetch(exports.api() + "docs/getURL.agdoc", {
                        method: 'post',
                        headers: exports.headers(),
                        body: JSON.stringify({ idDocumento: idDocumento, nrRevisao: nrRevisao, timeout: timeout })
                    })];
            case 1: return [4 /*yield*/, (_a.sent()).json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getLink = getLink;
var scanDocument = function (idDocumento, nrRevisao) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, status, docsUrl, res;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, exports.getDocsUrl()];
            case 1:
                _a = _b.sent(), status = _a.status, docsUrl = _a.docsUrl;
                if (!status)
                    return [2 /*return*/];
                return [4 /*yield*/, fetch(docsUrl + "argous/docs/scan.agdoc", {
                        method: 'post',
                        headers: exports.headers(),
                        body: JSON.stringify({ idDocumento: idDocumento, nrRevisao: nrRevisao })
                    })];
            case 2:
                res = _b.sent();
                return [4 /*yield*/, res.json()];
            case 3: return [2 /*return*/, _b.sent()];
        }
    });
}); };
exports.scanDocument = scanDocument;
var getWidgets = function (data, abortController) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agetwidgets.rslvr", {
                    method: 'post',
                    headers: exports.headers(),
                    body: JSON.stringify(data),
                    signal: abortController === null || abortController === void 0 ? void 0 : abortController.signal
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getWidgets = getWidgets;
var getWidgetInfo = function (pgCode) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agetwidgetinfo.rslvr", {
                    method: 'post',
                    headers: exports.headers(),
                    body: JSON.stringify({ pgCode: pgCode })
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getWidgetInfo = getWidgetInfo;
var sendWidgets = function (widgets) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agsendwidgets.rslvr", {
                    method: 'post',
                    headers: exports.headers(),
                    body: JSON.stringify({ widgets: widgets })
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.sendWidgets = sendWidgets;
var getPublicDoc = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agpublicdoc.rslvr", {
                    method: 'post',
                    headers: exports.headers(),
                    body: JSON.stringify(data)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getPublicDoc = getPublicDoc;
var getProgramAnnotations = function (data, token) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "aggetpgannotation.rslvr", {
                    method: 'post',
                    headers: exports.headers(token),
                    body: JSON.stringify(data)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.getProgramAnnotations = getProgramAnnotations;
var saveProgramAnnotation = function (data, token) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agsavepgannotation.rslvr", {
                    method: 'post',
                    headers: exports.headers(token),
                    body: JSON.stringify(data)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.saveProgramAnnotation = saveProgramAnnotation;
var sendProgramAnnotation = function (data, token) { return __awaiter(void 0, void 0, void 0, function () {
    var res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch(exports.api() + "agsendpgannotation.rslvr", {
                    method: 'post',
                    headers: exports.headers(token),
                    body: JSON.stringify(data)
                })];
            case 1:
                res = _a.sent();
                return [4 /*yield*/, res.json()];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.sendProgramAnnotation = sendProgramAnnotation;
