import * as React from 'react';

export interface ArgousProgressBarProps {
  valueLabel?: string,
  valueSuffix?: string,
  maxValueSuffix?: string,
  maxValueLabel?: string,
  value: number,
  maxValue?: number,
  rightIndicatorColor?: string,
  topIndicatorColor?: string,
  borderColor?: string,
  barColor?: string,
  fullBarColor?: string,
  preset?: 'default' | 'primary' | 'secondary' | 'success' | 'info' | 'warning' | 'danger' | 'hot' | 'cold'
  compact?: boolean,
  className?: string
}

declare function ArgousProgressBar(props: ArgousProgressBarProps): JSX.Element

export default ArgousProgressBar;