"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chart_js_1 = __importDefault(require("chart.js"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var BarChart = /** @class */ (function (_super) {
    __extends(BarChart, _super);
    function BarChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.componentDidMount = function () {
            var _a = _this.props, _b = _a.labels, labels = _b === void 0 ? [] : _b, _c = _a.datasets, datasets = _c === void 0 ? [] : _c, horizontal = _a.horizontal, percentage = _a.percentage, maxTicksLimit = _a.maxTicksLimit, stepSize = _a.stepSize, _d = _a.scaleLabel, scaleLabel = _d === void 0 ? {} : _d, _e = _a.title, title = _e === void 0 ? { display: false } : _e, _f = _a.legend, legend = _f === void 0 ? false : _f, _g = _a.tooltip, tooltip = _g === void 0 ? false : _g, stacked = _a.stacked, onClick = _a.onClick;
            var chart = new chart_js_1.default(_this.canv, {
                type: horizontal ? 'horizontalBar' : 'bar',
                data: {
                    labels: labels,
                    datasets: datasets
                },
                options: {
                    maintainAspectRatio: false,
                    events: ['click'],
                    onClick: !onClick ? undefined : function (event, context) {
                        var activeElement = chart.getElementAtEvent(event);
                        if (activeElement.length > 0) {
                            var datasetIndex = activeElement[0]._datasetIndex;
                            var index = activeElement[0]._index;
                            var value = chart.data.datasets[activeElement[0]._datasetIndex].data[activeElement[0]._index];
                            var label = labels[activeElement[0]._index];
                            onClick(datasetIndex, index, value, label);
                        }
                    },
                    scales: {
                        xAxes: [{
                                stacked: stacked
                            }],
                        yAxes: [{
                                ticks: {
                                    suggestedMax: percentage ? 100 : undefined,
                                    maxTicksLimit: maxTicksLimit,
                                    stepSize: stepSize,
                                    beginAtZero: true,
                                },
                                scaleLabel: scaleLabel,
                                stacked: stacked
                            }]
                    },
                    title: title,
                    legend: {
                        display: legend
                    },
                    tooltips: {
                        enabled: tooltip
                    }
                }
            });
        };
        return _this;
    }
    BarChart.prototype.render = function () {
        var _this = this;
        var height = this.props.height;
        return (react_1.default.createElement("div", { style: { position: 'relative', height: height } },
            react_1.default.createElement("canvas", { ref: function (canv) {
                    _this.canv = canv;
                } })));
    };
    return BarChart;
}(react_1.Component));
BarChart.propTypes = {
    height: prop_types_1.default.number,
    labels: prop_types_1.default.array,
    datasets: prop_types_1.default.array,
    horizontal: prop_types_1.default.bool,
    percentage: prop_types_1.default.bool,
    maxTicksLimit: prop_types_1.default.number,
    stepSize: prop_types_1.default.number,
    scaleLabel: prop_types_1.default.object,
    title: prop_types_1.default.object,
    legend: prop_types_1.default.bool,
    tooltip: prop_types_1.default.bool,
    stacked: prop_types_1.default.bool,
    prefix: prop_types_1.default.string,
    suffix: prop_types_1.default.string,
    onClick: prop_types_1.default.func
};
exports.default = BarChart;
