"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
/**
 * @deprecated
 */
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function (event) {
            var onClick = _this.props.onClick;
            var allProgramFields = fieldsRedux_1.getAllFields();
            if (onClick) {
                onClick(allProgramFields, event);
            }
            _this.handleUpdates(allProgramFields);
        };
        _this.handleUpdates = function (allProgramFields, res) {
            var _a = _this.props, action = _a.action, dados = _a.dados, _b = _a.receiveUpdates, receiveUpdates = _b === void 0 ? [] : _b, _c = _a.sendUpdates, sendUpdates = _c === void 0 ? [] : _c, onAllUpdated = _a.onAllUpdated, onSuccess = _a.onSuccess;
            fieldsRedux_1.fieldUpdatesActionHandler(sendUpdates, receiveUpdates, action, dados, onSuccess, onAllUpdated, allProgramFields);
        };
        _this.resolveFieldValues = function (fields) {
            if (fields) {
                var fieldsValues_1 = {};
                Object.keys(fields).map(function (key) {
                    fieldsValues_1[key] = fields[key].value;
                    return null;
                });
                return fieldsValues_1;
            }
            return {};
        };
        _this.checkButtonProps = function () {
            var _a = _this.props, value = _a.value, _b = _a.type, type = _b === void 0 ? 'button' : _b, name = _a.name, autoFocus = _a.autoFocus, disabled = _a.disabled, formNoValidate = _a.formNoValidate, formTarget = _a.formTarget, formMethod = _a.formMethod, formEncType = _a.formEncType, formAction = _a.formAction, form = _a.form, style = _a.style, title = _a.title;
            var className = "" + (_this.props.className ? _this.props.className : 'btn');
            var onClick = _this.onClick;
            return {
                className: className,
                onClick: onClick,
                value: value,
                type: type,
                name: name,
                autoFocus: autoFocus,
                disabled: disabled,
                formNoValidate: formNoValidate,
                formTarget: formTarget,
                formMethod: formMethod,
                formEncType: formEncType,
                formAction: formAction,
                form: form,
                style: style,
                title: title,
            };
        };
        return _this;
    }
    Button.prototype.render = function () {
        var checkButtonProps = this.checkButtonProps;
        var children = this.props.children;
        var buttonProps = checkButtonProps();
        return react_1.default.createElement("button", __assign({}, buttonProps), children);
    };
    return Button;
}(react_1.Component));
Button.propTypes = {
    receiveUpdates: prop_types_1.default.array,
    sendUpdates: prop_types_1.default.array,
    onAllUpdated: prop_types_1.default.func,
    onSuccess: prop_types_1.default.func,
    className: prop_types_1.default.string,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    children: prop_types_1.default.oneOfType([prop_types_1.default.node, prop_types_1.default.element]),
    type: prop_types_1.default.oneOf(['submit', 'reset', 'button']),
    value: prop_types_1.default.string,
    style: prop_types_1.default.object,
    onClick: prop_types_1.default.func,
    name: prop_types_1.default.string,
    autoFocus: prop_types_1.default.bool,
    disabled: prop_types_1.default.bool,
    formNoValidate: prop_types_1.default.bool,
    formTarget: prop_types_1.default.oneOf(['_self', '_blank', '_parent', '_top']),
    formMethod: prop_types_1.default.oneOf(['post', 'get']),
    formEncType: prop_types_1.default.oneOf([
        'application/x-www-form-urlencoded',
        'multipart/form-data',
        'text/plain',
    ]),
    formAction: prop_types_1.default.string,
    form: prop_types_1.default.string,
    title: prop_types_1.default.string,
};
exports.default = Button;
