"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Input_1 = __importDefault(require("./../Input"));
var fieldsRedux_1 = require("../../fieldsRedux");
var api_1 = require("../../utils/api");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var go_1 = require("react-icons/go");
/**
 * @deprecated
 */
var Cabecalho = /** @class */ (function (_super) {
    __extends(Cabecalho, _super);
    function Cabecalho() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            ready: false,
            focus: false,
            isNew: true
        };
        _this.saveReceivedUpdatesValuesInState = function (field, value, state, receiveUpdates) {
            var _a;
            if (value) {
                for (var _i = 0, receiveUpdates_1 = receiveUpdates; _i < receiveUpdates_1.length; _i++) {
                    var ru = receiveUpdates_1[_i];
                    var receivedValue = fieldsRedux_1.getField(ru, 'value');
                    var exist = false;
                    for (var _b = 0, state_1 = state; _b < state_1.length; _b++) {
                        var s = state_1[_b];
                        if (s[0] === value) {
                            exist = true;
                            if (s[1][ru] !== receivedValue) {
                                s[1][ru] = receivedValue;
                                fieldsRedux_1.setField(field, 'state', state);
                            }
                            break;
                        }
                    }
                    if (!exist) {
                        state.push([value, (_a = {}, _a[ru] = receivedValue, _a)]);
                        fieldsRedux_1.setField(field, 'state', state);
                    }
                }
            }
        };
        _this.listener = function (obj) {
            var ready = _this.state.ready;
            if (ready) {
                _this.saveState(obj);
            }
            else if (typeof obj.value === 'object') {
                var field = _this.props.field;
                if (obj.value.length > 0) {
                    var cabecalho = obj.value[0][0];
                    fieldsRedux_1.setField(field, 'state', obj.value);
                    _this.setStates(obj.value, cabecalho);
                    _this.setState({ isNew: false });
                }
                else {
                    fieldsRedux_1.setField(field, 'value', 'Escreva um título para salvar...');
                    fieldsRedux_1.setField(field, 'active', undefined);
                    _this.setState({ isNew: true });
                }
            }
            else if (typeof obj.value !== 'undefined' && typeof obj.defaultValue !== 'undefined') {
                _this.setState({ ready: true });
            }
        };
        _this.setStates = function (state, cabecalho) {
            var _a = _this.props, field = _a.field, receiveUpdates = _a.receiveUpdates;
            var activeState = {};
            for (var _i = 0, state_2 = state; _i < state_2.length; _i++) {
                var s = state_2[_i];
                if (s[0] === cabecalho) {
                    activeState = s[1];
                    break;
                }
            }
            _this.sendAction(activeState);
            for (var _b = 0, receiveUpdates_2 = receiveUpdates; _b < receiveUpdates_2.length; _b++) {
                var ru = receiveUpdates_2[_b];
                fieldsRedux_1.setField(ru, 'value', activeState[ru]);
            }
            fieldsRedux_1.setField(field, 'value', cabecalho);
            fieldsRedux_1.setField(field, 'active', cabecalho);
        };
        _this.sendAction = function (activeState) {
            var action = _this.props.action;
            api_1.serverAction(action, { state: activeState });
        };
        _this.saveState = function (obj) {
            clearTimeout(_this.saveTimeout);
            _this.saveTimeout = setTimeout(function () {
                var _a = _this.props, field = _a.field, updateAction = _a.updateAction;
                var state = fieldsRedux_1.getField(field, 'state') || {};
                api_1.serverAction(updateAction, { states: state });
            }, 350);
        };
        _this.changeActiveState = function (nr) {
            var _a = _this.props, field = _a.field, receiveUpdates = _a.receiveUpdates;
            var _b = fieldsRedux_1.getField(field), value = _b.value, _c = _b.state, state = _c === void 0 ? [] : _c, active = _b.active;
            var index = -1;
            for (var _i = 0, state_3 = state; _i < state_3.length; _i++) {
                var s = state_3[_i];
                index++;
                if (s[0] === value) {
                    break;
                }
            }
            var newIndex = active ? index + nr : nr > 0 ? 0 : state.length - 1;
            if (newIndex < 0 || newIndex >= state.length) {
                fieldsRedux_1.setField(field, 'value', 'Escreva um título para salvar...');
                fieldsRedux_1.setField(field, 'active', undefined);
                var activeState = {};
                for (var _d = 0, receiveUpdates_3 = receiveUpdates; _d < receiveUpdates_3.length; _d++) {
                    var ru = receiveUpdates_3[_d];
                    fieldsRedux_1.setField(ru, 'value', undefined);
                    activeState[ru] = null;
                }
                _this.sendAction(activeState);
                _this.setState({ isNew: true });
            }
            else {
                _this.setStates(state, state[newIndex][0]);
                _this.setState({ isNew: false });
            }
        };
        _this.blur = function () {
            var isNew = _this.state.isNew;
            var field = _this.props.field;
            var _a = fieldsRedux_1.getField(field), value = _a.value, _b = _a.state, state = _b === void 0 ? [] : _b, active = _a.active;
            if (!isNew) {
                _this.editKeyValue(field, state, value, active);
            }
            else if (value !== 'Escreva um título para salvar...') {
                state.push([value, {}]);
                fieldsRedux_1.setField(field, 'state', state);
                fieldsRedux_1.setField(field, 'active', value);
                _this.setState({ isNew: false });
            }
            _this.setState({ focus: false });
        };
        _this.editKeyValue = function (field, state, value, active) {
            if (value !== active) {
                var index = -1;
                for (var _i = 0, state_4 = state; _i < state_4.length; _i++) {
                    var s = state_4[_i];
                    index++;
                    if (s[0] === active) {
                        s[0] = value;
                        break;
                    }
                }
                if (value === '') {
                    state.splice(index, 1);
                }
                fieldsRedux_1.setField(field, 'state', state);
                fieldsRedux_1.setField(field, 'active', value);
            }
        };
        return _this;
    }
    Cabecalho.prototype.componentDidUpdate = function () {
        var _a = this.state, focus = _a.focus, isNew = _a.isNew;
        if (!focus && !isNew) {
            var _b = this.props, field = _b.field, receiveUpdates = _b.receiveUpdates;
            var _c = fieldsRedux_1.getField(field), value = _c.value, _d = _c.state, state = _d === void 0 ? [] : _d;
            this.saveReceivedUpdatesValuesInState(field, value, state, receiveUpdates);
        }
    };
    Cabecalho.prototype.render = function () {
        var _this = this;
        var _a = this.props, field = _a.field, _b = _a.className, className = _b === void 0 ? '' : _b;
        return (react_1.default.createElement("div", { className: "ag-component-cabecalho transition-cubic " + className },
            react_1.default.createElement("div", { className: 'ag-arrow-cc', onClick: function () { return _this.changeActiveState(-1); } },
                react_1.default.createElement(go_1.GoTriangleLeft, { size: 25 })),
            react_1.default.createElement("div", { className: 'ag-painel-cc' },
                react_1.default.createElement(Input_1.default, { field: field, fieldListener: this.listener, onFocus: function () { return _this.setState({ focus: true }); }, onBlur: this.blur, className: 'ag-input-cabecalho' })),
            react_1.default.createElement("div", { className: 'ag-arrow-cc', onClick: function () { return _this.changeActiveState(1); } },
                react_1.default.createElement(go_1.GoTriangleRight, { size: 25 }))));
    };
    return Cabecalho;
}(react_1.Component));
Cabecalho.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    receiveUpdates: prop_types_1.default.array,
    action: prop_types_1.default.string,
    updateAction: prop_types_1.default.string,
    className: prop_types_1.default.string
};
exports.default = fieldsRedux_1.createField(Cabecalho);
