"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var MaterialButton_1 = __importDefault(require("../MaterialButton/MaterialButton"));
var core_1 = require("@material-ui/core");
var react_1 = __importDefault(require("react"));
var WrapperModal = function (Component) { return function (_a) {
    var proceed = _a.proceed, open = _a.open, title = _a.title, _b = _a.cancelLabel, cancelLabel = _b === void 0 ? 'Cancelar' : _b, _c = _a.okLabel, okLabel = _c === void 0 ? 'Ok' : _c, dialogProps = _a.dialogProps, props = __rest(_a, ["proceed", "open", "title", "cancelLabel", "okLabel", "dialogProps"]);
    return react_1.default.createElement(core_1.Dialog, __assign({ open: open, onClose: function () { return proceed(false); } }, dialogProps),
        title && react_1.default.createElement(core_1.DialogTitle, null, title),
        react_1.default.createElement(core_1.DialogContent, null,
            react_1.default.createElement(Component, __assign({}, props))),
        react_1.default.createElement(core_1.DialogActions, null,
            cancelLabel && react_1.default.createElement(MaterialButton_1.default, { variant: 'contained', color: 'secondary', onClick: function () { return proceed(false); } }, cancelLabel),
            okLabel && react_1.default.createElement(MaterialButton_1.default, { variant: 'contained', color: 'primary', onClick: function () { return proceed(true); } }, okLabel)));
}; };
exports.default = WrapperModal;
