"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var useStyles = core_1.makeStyles(function (theme) { return ({
    iframe: {
        width: '100%',
        height: '100%',
        border: 'none',
        background: theme.palette.background.default,
        '&:focus': {
            outline: 'none'
        },
        '&[seamless]': {
            display: 'block'
        }
    },
    restricSize: {
        maxWidth: '100%',
        maxHeight: '100%'
    }
}); });
var onchange = function () { return undefined; };
var Visualizacao = function (_a) {
    var _b;
    var idDocumento = _a.idDocumento, nrRevisao = _a.nrRevisao, setVisualizando = _a.setVisualizando, proceed = _a.proceed, documento = _a.URL, linkPronto = _a.linkPronto, tokenSistema = _a.tokenSistema, ariaLabel = _a.ariaLabel;
    var classes = useStyles();
    var blockLoop = react_1.useRef(null);
    var _c = react_1.useState({}), type = _c[0].type, setArquivo = _c[1];
    var tagType = (_b = type === null || type === void 0 ? void 0 : type.match(/^[^/]+/)) === null || _b === void 0 ? void 0 : _b.at(0);
    var _d = react_1.useState(linkPronto), link = _d[0], setLink = _d[1];
    var preparaLink = function () { return __awaiter(void 0, void 0, void 0, function () {
        var objGetLinkDocumento, res, _a, _b, file, url_1, error_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!linkPronto && ((!idDocumento && !documento) || (documento === blockLoop.current))) {
                        return [2 /*return*/];
                    }
                    objGetLinkDocumento = { idDocumento: idDocumento, nrRevisao: nrRevisao, dsToken: tokenSistema === null || tokenSistema === void 0 ? void 0 : tokenSistema.toString() };
                    if (!linkPronto) return [3 /*break*/, 1];
                    _a = { link: { URL: linkPronto } };
                    return [3 /*break*/, 5];
                case 1:
                    if (!documento) return [3 /*break*/, 2];
                    _b = { link: { URL: documento } };
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, api_1.serverAction('getLinkDocumento', objGetLinkDocumento, 'CtrlDocumentos', true)];
                case 3:
                    _b = _c.sent();
                    _c.label = 4;
                case 4:
                    _a = _b;
                    _c.label = 5;
                case 5:
                    res = (_a).link;
                    _c.label = 6;
                case 6:
                    _c.trys.push([6, 9, , 10]);
                    return [4 /*yield*/, fetch(res === null || res === void 0 ? void 0 : res.URL, {
                            method: 'post',
                            headers: { lgTkn: tokenSistema }
                        })];
                case 7: return [4 /*yield*/, (_c.sent()).blob()];
                case 8:
                    file = _c.sent();
                    url_1 = URL.createObjectURL(file);
                    setVisualizando(function (v) { return (__assign(__assign({}, v), { URL: url_1 })); });
                    blockLoop.current = url_1;
                    setLink(url_1);
                    setArquivo(__assign(__assign({}, res), { type: file === null || file === void 0 ? void 0 : file.type }));
                    return [3 /*break*/, 10];
                case 9:
                    error_1 = _c.sent();
                    api_1.setError('Não foi possível visualizar este documento.');
                    return [3 /*break*/, 10];
                case 10: return [2 /*return*/];
            }
        });
    }); };
    // eslint-disable-next-line react-hooks/exhaustive-deps
    react_1.useEffect(function () { return preparaLink(); }, []);
    react_1.useEffect(function () {
        onchange = function (evt) {
            var v = 'visible', h = 'hidden', evtMap = { focus: v, focusin: v, pageshow: v, blur: h, focusout: h, pagehide: h };
            evt = evt || window.event;
            if (evt.type in evtMap)
                document.body.style.opacity = evtMap[evt.type];
            else
                document.body.style.opacity = this[hidden] ? 0 : 1;
        };
        var hidden = 'hidden';
        if (hidden in document)
            document.addEventListener('visibilitychange', onchange);
        else if ((hidden = 'mozHidden') in document)
            document.addEventListener('mozvisibilitychange', onchange);
        else if ((hidden = 'webkitHidden') in document)
            document.addEventListener('webkitvisibilitychange', onchange);
        else if ((hidden = 'msHidden') in document)
            document.addEventListener('msvisibilitychange', onchange);
        else if ('onfocusin' in document)
            document.onfocusin = document.onfocusout = onchange;
        else
            window.onpageshow = window.onpagehide = window.onfocus = window.onblur = onchange;
        if (document[hidden] !== undefined)
            onchange({ type: document[hidden] ? 'blur' : 'focus' });
        window.onkeydown = function (e) {
            if (e.key === 'Escape')
                proceed(undefined);
            if (e.key === 'F12')
                return false;
            if (e.ctrlKey && e.shiftKey && e.key === 'I')
                return false;
            if (e.ctrlKey && e.shiftKey && e.key === 'C')
                return false;
            if (e.ctrlKey && e.shiftKey && e.key === 'J')
                return false;
            if (e.ctrlKey && e.key === 'u')
                return false;
        };
        return function () {
            window.onkeydown = undefined;
            onchange = function () { return undefined; };
        };
    }, [proceed]);
    switch (tagType) {
        case 'audio':
            return react_1.default.createElement("audio", { className: classes.restricSize, "aria-label": ariaLabel, src: link, controls: true, controlsList: 'nodownload' });
        case 'image':
            return react_1.default.createElement("img", { className: classes.restricSize, alt: ariaLabel || 'Imagem', "aria-label": ariaLabel, src: link, onClick: function (e) { return e.preventDefault(); } });
        case 'video':
            return react_1.default.createElement("video", { className: classes.restricSize, "aria-label": ariaLabel, controls: true, controlsList: 'nodownload', autoPlay: true, src: link });
        default:
            return link ? react_1.default.createElement("iframe", { className: classes.iframe, "aria-label": ariaLabel, title: 'Iframe', src: link + "#toolbar=0" }) : react_1.default.createElement(core_1.Box, { justifyContent: 'center', alignItems: 'center', display: 'flex' },
                react_1.default.createElement(core_1.CircularProgress, { disableShrink: true }));
    }
};
exports.default = Visualizacao;
