"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Html5FileSelector_1 = require("./Html5FileSelector");
var __1 = require("../");
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var DropArea = function (_a, ref) {
    var children = _a.children, onChange = _a.onChange, style = _a.style, props = __rest(_a, ["children", "onChange", "style"]);
    var _b = react_1.useState(false), abrir = _b[0], setAbrir = _b[1];
    var _c = react_1.useState(false), loading = _c[0], setLoading = _c[1];
    /** @param {React.DragEvent<HTMLDivElement>} e */
    var dropArquivo = function (e) { return __awaiter(void 0, void 0, void 0, function () {
        var finalArray;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    e.preventDefault();
                    setLoading(true);
                    return [4 /*yield*/, Html5FileSelector_1.getDroppedOrSelectedFiles(e)];
                case 1:
                    finalArray = _a.sent();
                    // console.log(temp, temp.reduce((acc, { fileObject, fullPath }) => {
                    //   const fileName = fullPath.match(/\/([^\/]*)$/)?.at(1);
                    //   const objectPath = fullPath.replace(fileName, '').substring(1).slice(0, -1);
                    //   return set(acc, objectPath.length ? [...objectPath.split('/'), fileName] : fileName, fileObject)
                    // }, {}));
                    // const length = e.dataTransfer.items.length, 
                    //     i = 0, itens = e.dataTransfer.items, finalArray = [];
                    // for (i; i < length; i++) {
                    //   const item = itens[i];
                    //   if (item.kind === 'file') finalArray.push(item.getAsFile())
                    // }
                    // onChange && onChange(finalArray)
                    // if (ref?.current) ref.current.preparaArquivo(finalArray)
                    onChange && onChange(finalArray);
                    if (ref === null || ref === void 0 ? void 0 : ref.current)
                        ref.current.preparaArquivo(finalArray);
                    setLoading(false);
                    setAbrir(false);
                    return [2 /*return*/];
            }
        });
    }); };
    return (react_1.default.createElement("div", __assign({ onDragEnter: function () { return setAbrir(true); }, style: __assign({ position: 'relative' }, style) }, props),
        abrir && (!(ref === null || ref === void 0 ? void 0 : ref.current) || (ref.current && !ref.current.loading)) && (react_1.default.createElement("div", { onDrop: dropArquivo, onDragOver: function (e) { return e.preventDefault(); }, onDragLeave: function () { return setAbrir(false); }, style: { position: 'absolute', border: '2px dashed', background: 'rgba(0, 0, 0, 0.5)', zIndex: 5, width: '100%', height: '100%', display: 'grid', placeItems: 'center' } }, (loading) ?
            react_1.default.createElement(core_1.Box, { display: 'flex', justifyContent: 'center', alignItems: 'center', height: '100%' },
                react_1.default.createElement(core_1.CircularProgress, { disableShrink: true }))
            :
                react_1.default.createElement(md_1.MdFileUpload, { style: { width: '100%', height: '99%' } }))),
        deepMap(children, function (filho) { return filho.type === __1.FilePreparer ? react_1.cloneElement(filho, __assign(__assign({}, filho.props), { ref: ref })) : filho; })));
};
exports.default = react_1.forwardRef(DropArea);
var deepMap = function (children, deepMapFn) {
    return react_1.Children.toArray(children).map(function (child, index, mapChildren) {
        if (react_1.isValidElement(child) && hasComplexChildren(child)) {
            return deepMapFn(react_1.cloneElement(child, __assign(__assign({}, child.props), { children: deepMap(child.props.children, deepMapFn) })));
        }
        return deepMapFn(child, index, mapChildren);
    });
};
var hasComplexChildren = function (element) {
    return react_1.isValidElement(element) &&
        hasChildren(element) &&
        react_1.Children.toArray(element.props.children).reduce(function (response, child) { return response || react_1.isValidElement(child); }, false);
};
var hasChildren = function (element) { return react_1.isValidElement(element) && element.props.children; };
