import { IProps } from './Editor';
import { IEvents } from '../Events';
import * as PropTypes from 'prop-types';
export declare type CopyProps<T> = {
    [P in keyof T]: PropTypes.Requireable<unknown>;
};
export declare type IEventPropTypes = CopyProps<IEvents>;
export interface IEditorPropTypes extends IEventPropTypes, CopyProps<IProps> {
}
export declare const eventPropTypes: IEventPropTypes;
export declare const EditorPropTypes: IEditorPropTypes;
