"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorLinearProgress = exports.retomaUpload = exports.pausaUpload = exports.confirmFileUpload = exports.fileUploader = void 0;
var index_1 = require("../../api/index");
var core_1 = require("@material-ui/core");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var estadoPausado = false;
var idProtocolo;
var tamLote;
var lote;
/* Valores para nr
  *   1 = fileExtension
  *   2 = retornaProgresso
  *   3 = enviarDireto
*/
function descobrePrm(prm2, prm3, prm4, nr) {
    switch (nr) {
        case 1: // fileExtension
            if (typeof prm2 === 'string')
                return prm2;
            if (typeof prm3 === 'string')
                return prm3;
            if (typeof prm4 === 'string')
                return prm4;
            break;
        case 2: // retornaProgresso
            if (typeof prm2 === 'function')
                return prm2;
            if (typeof prm3 === 'function')
                return prm3;
            if (typeof prm4 === 'function')
                return prm4;
            break;
        case 3: // enviarDireto
            if (typeof prm2 === 'boolean')
                return prm2;
            if (typeof prm3 === 'boolean')
                return prm3;
            if (typeof prm4 === 'boolean')
                return prm4;
            break;
        default:
            return undefined;
    }
}
function fileUploader(file, prm2, prm3, prm4) {
    return __awaiter(this, void 0, void 0, function () {
        var fileExtension, retornaProgresso, enviarDireto, arquivo;
        return __generator(this, function (_a) {
            fileExtension = descobrePrm(prm2, prm3, prm4, 1) || '';
            retornaProgresso = descobrePrm(prm2, prm3, prm4, 2);
            enviarDireto = descobrePrm(prm2, prm3, prm4, 3) === undefined ? true : descobrePrm(prm2, prm3, prm4, 3);
            file.preventDefault();
            arquivo = file.target.files[0];
            if (fileExtension && arquivo.name.split('.').pop() !== fileExtension)
                return [2 /*return*/, { dsErro: "O arquivo enviado deve ser do tipo \"." + fileExtension + "\".", status: false }];
            if (enviarDireto)
                return [2 /*return*/, confirmFileUpload(arquivo, retornaProgresso)];
            return [2 /*return*/, arquivo];
        });
    });
}
exports.fileUploader = fileUploader;
function confirmFileUpload(arquivo, retornaProgresso) {
    return __awaiter(this, void 0, void 0, function () {
        var res_1, parte, res_2, error_1, res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!idProtocolo) return [3 /*break*/, 2];
                    return [4 /*yield*/, index_1.inicFileUpload({ nomeArquivo: arquivo.name, tamanhoArquivo: arquivo.size })];
                case 1:
                    res_1 = _a.sent();
                    if (res_1.dsErro)
                        return [2 /*return*/, res_1];
                    idProtocolo = res_1.idProtocolo;
                    tamLote = res_1.tamLote;
                    lote = 0;
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 8, , 9]);
                    _a.label = 3;
                case 3:
                    if (retornaProgresso)
                        retornaProgresso(((lote * tamLote) * 100) / arquivo.size);
                    return [4 /*yield*/, converteBlobEmBase64(arquivo.slice((lote * tamLote), (lote * tamLote) + tamLote))];
                case 4:
                    parte = _a.sent();
                    if (estadoPausado)
                        return [2 /*return*/];
                    return [4 /*yield*/, index_1.sendFilePart({ idProtocolo: idProtocolo, nrLote: lote, dadosLote: parte })];
                case 5:
                    res_2 = _a.sent();
                    if (res_2.snAck)
                        lote++;
                    _a.label = 6;
                case 6:
                    if ((lote * tamLote) < arquivo.size) return [3 /*break*/, 3];
                    _a.label = 7;
                case 7: return [3 /*break*/, 9];
                case 8:
                    error_1 = _a.sent();
                    console.error(error_1);
                    return [3 /*break*/, 9];
                case 9:
                    if (estadoPausado)
                        return [2 /*return*/, { arquivo: arquivo, retornaProgresso: retornaProgresso }];
                    return [4 /*yield*/, index_1.endFileUpload({ idProtocolo: idProtocolo })];
                case 10:
                    res = _a.sent();
                    estadoPausado = false;
                    idProtocolo = undefined;
                    tamLote = undefined;
                    lote = undefined;
                    return [2 /*return*/, res];
            }
        });
    });
}
exports.confirmFileUpload = confirmFileUpload;
function converteBlobEmBase64(parte) {
    return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.onload = function () {
            resolve(reader.result.replace(/=/g, '').split(',').pop());
        };
        reader.onerror = reject;
        reader.readAsDataURL(parte);
    });
}
function pausaUpload() {
    estadoPausado = true;
}
exports.pausaUpload = pausaUpload;
function retomaUpload(dados) {
    estadoPausado = false;
    return confirmFileUpload(dados.arquivo, dados.retornaProgresso);
}
exports.retomaUpload = retomaUpload;
exports.ColorLinearProgress = core_1.withStyles({
    root: {
        margin: '5px 0px 0px 5px'
    },
    colorPrimary: {
        backgroundColor: '#d3deda',
    },
    barColorPrimary: {
        backgroundColor: '#009C6A',
    },
})(core_1.LinearProgress);
var estiloBotoes = {
    margin: '0px 3px',
    border: 0,
    padding: 0,
    fontSize: '20px',
    width: '30px',
    height: '30px',
    borderRadius: '15px'
};
var estiloBotoesCompact = {
    margin: '0px 3px',
    border: 0,
    padding: 0,
    fontSize: '15px',
    width: '30px',
    height: '30px',
    borderRadius: '15px'
};
function FileUploader(_a) {
    // ToDo fazer funcionar com varios arquivos
    // ToDo fazer um jeito de cancelar no meio do envio
    // ToDo  preparar para receber valor ja inicializado
    // Todo funcao que retorna estados para ter um spinner mais dinamico
    // Todo fazer um modal drag and drop minimizavel que busque o estado do upload
    // ToDo fazer aceitar mais de uma extensao
    // ToDo se inspirar no layout do uploader do sistema de chamados para fazer a versao default
    var extensao = _a.extensao, funcaoRetorno = _a.funcaoRetorno, enviarDireto = _a.enviarDireto, variant = _a.variant;
    var _b = react_1.useState(0), progresso = _b[0], setProgresso = _b[1];
    var _c = react_1.useState({}), aguardando = _c[0], setAguardando = _c[1];
    var _d = react_1.useState({}), infoPausa = _d[0], setInfoPausa = _d[1];
    var _e = react_1.useState(0), idKey = _e[0], setIdKey = _e[1];
    react_1.useEffect(function () {
        setIdKey(Math.floor(Math.random() * 100000) + 1);
        return function () { return cancelaEnvio(); };
        // eslint-disable-next-line 
    }, []);
    function carregaArquivo(arquivo) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fileUploader(arquivo, extensao || '', setProgresso, enviarDireto || false)];
                    case 1:
                        res = _a.sent();
                        // document.getElementById(`FileUploader_${idKey}`).value = ''
                        if (res.dsErro && funcaoRetorno)
                            manejaRetorno(res);
                        else if (enviarDireto) {
                            if (estadoPausado) {
                                setInfoPausa(res);
                            }
                            else {
                                if (funcaoRetorno)
                                    manejaRetorno(res);
                                setProgresso(0);
                                setAguardando({});
                                setInfoPausa({});
                            }
                        }
                        else
                            setAguardando(res);
                        return [2 /*return*/];
                }
            });
        });
    }
    function enviaArquivo() {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!estadoPausado) return [3 /*break*/, 2];
                        return [4 /*yield*/, retomaUpload(infoPausa)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, confirmFileUpload(aguardando, setProgresso)];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4:
                        res = _a;
                        if (estadoPausado) {
                            setInfoPausa(res);
                        }
                        else {
                            if (funcaoRetorno)
                                manejaRetorno(res);
                            setProgresso(0);
                            setAguardando({});
                            setInfoPausa({});
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    function cancelaEnvio() {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!idProtocolo) return [3 /*break*/, 2];
                        return [4 /*yield*/, index_1.cancelFileUpload({ idProtocolo: idProtocolo })];
                    case 1:
                        res = _a.sent();
                        if (funcaoRetorno)
                            manejaRetorno(res);
                        idProtocolo = undefined;
                        tamLote = undefined;
                        lote = undefined;
                        _a.label = 2;
                    case 2:
                        setProgresso(0);
                        setAguardando({});
                        setInfoPausa({});
                        estadoPausado = false;
                        return [2 /*return*/];
                }
            });
        });
    }
    function manejaRetorno(res) {
        if (res.status) {
            switch (res.tpStatus) {
                case '0':
                    funcaoRetorno(__assign({ dsStatus: 'Preparando Recebimento' }, res));
                    break;
                case '1':
                    funcaoRetorno(__assign({ dsStatus: 'Recebendo Arquivo' }, res));
                    break;
                case '2':
                    funcaoRetorno(__assign({ dsStatus: 'Arquivo Recebido' }, res));
                    break;
                case '3':
                    funcaoRetorno(__assign({ dsStatus: 'Arquivo Disponível' }, res));
                    break;
                case '4':
                    funcaoRetorno(__assign({ dsStatus: 'Arquivo Entregue ao Destinatário' }, res));
                    break;
                case '8':
                    funcaoRetorno(__assign({ dsStatus: 'Erro no Recebimento' }, res));
                    break;
                case '9':
                    funcaoRetorno(__assign({ dsStatus: 'Envio Cancelado' }, res));
                    break;
                default:
                    funcaoRetorno(res);
                    break;
            }
        }
        else {
            funcaoRetorno(res);
        }
    }
    if (variant === 'compact')
        return (react_1.default.createElement("div", null,
            (progresso !== 0 && progresso !== 100) && (react_1.default.createElement("div", { style: { width: 'max-content' } },
                react_1.default.createElement("div", { style: { width: '65px', display: 'flex', justifyContent: 'center' } },
                    react_1.default.createElement(core_1.CircularProgress, { variant: 'static', value: progresso }),
                    react_1.default.createElement("p", { style: { position: 'absolute', top: '25px' } },
                        progresso.toFixed(0),
                        "%")),
                react_1.default.createElement("div", { style: { width: '100px' } },
                    estadoPausado ?
                        react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoesCompact, onClick: function () { return enviaArquivo(); } },
                            react_1.default.createElement("i", { className: 'glyph-icon icon-play', title: 'Continuar' }))
                        :
                            react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoesCompact, onClick: function () { return pausaUpload(); } },
                                react_1.default.createElement("i", { className: 'glyph-icon icon-pause', title: 'Pausar' })),
                    react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoesCompact, onClick: function () { return cancelaEnvio(); } },
                        react_1.default.createElement("i", { className: 'glyph-icon icon-stop', title: 'Cancelar' }))))),
            (progresso === 0 && !aguardando.name) && (react_1.default.createElement("div", null,
                react_1.default.createElement("input", { id: "FileUploader_" + idKey, className: 'float-left', type: 'file', onChange: function (e) {
                        carregaArquivo(e);
                    }, style: { display: 'none' } }),
                react_1.default.createElement("button", { className: 'btn btn-default', style: { width: '50px', padding: '0px', border: 0, borderRadius: '15px' }, onClick: function () { return document.getElementById("FileUploader_" + idKey).click(); } },
                    react_1.default.createElement("svg", { viewBox: '0 0 1000 1000' },
                        react_1.default.createElement("g", { transform: 'translate(0.000000,512.000000) scale(0.100000,-0.100000)' },
                            react_1.default.createElement("path", { d: 'M1137.2,4987.5c-187.6-65.1-325.5-204.9-390.6-394.4C718,4510.7,716,4114.4,716,120.7c0-3980.3,1.9-4390,30.6-4478.1c47.9-145.5,151.3-268,294.8-346.5l124.4-68.9l1378.5-5.7c758.2-1.9,1527.8-1.9,1711.6,0l333.1,5.7l-141.7,109.1c-78.5,59.4-225.9,195.3-331.2,300.6l-189.5,193.4H2628.7h-1300V118.8v4288.5h1837.9h1836l5.8-999.4l5.7-1001.3l47.9-95.7c59.4-122.5,174.2-237.4,296.8-296.8l95.7-47.9l1001.3-5.7l999.4-5.7v-371.4V1212l107.2-30.6c61.3-17.2,187.6-65.1,283.3-107.2c95.7-42.1,185.7-82.3,199.1-88.1c17.2-7.7,23,157,23,790.7V2579L6846.4,3800.4L5626.8,5020H3425.1C1474.2,5018.1,1213.8,5014.3,1137.2,4987.5z M7436,2584.7c0-9.6-409.7-15.3-909.4-15.3h-909.4v922.8v924.7l909.4-909.4C7026.3,3007.8,7436,2592.4,7436,2584.7z' }),
                            react_1.default.createElement("path", { d: 'M6191.6,712.3C5561.7,624.2,5035.2,363.9,4593-80.3c-402.1-404-656.7-880.7-769.6-1441.6c-45.9-235.5-45.9-773.5,1.9-1009c111-561,363.8-1035.7,767.7-1437.8c396.3-398.2,836.7-635.6,1403.3-760.1c268-59.3,811.8-59.3,1079.8,0c566.7,124.5,1007,361.9,1403.3,760.1c398.2,396.3,635.6,836.6,760.1,1403.3c55.5,248.9,59.4,790.7,9.6,1043.4c-113,561-367.6,1037.7-769.6,1441.6C8088.9,312.2,7631.3,561.1,7095.3,674C6882.7,720,6390.7,739.1,6191.6,712.3z M6861.7,90.1c693.1-105.3,1278.9-534.2,1589.1-1167.9c306.3-624.1,306.3-1275.1,0-1895.4c-624.1-1265.5-2251.5-1589.1-3325.5-664.3c-448,386.7-733.3,1012.8-733.3,1612c0,643.3,302.5,1269.3,807.9,1673.3C5663.2,19.2,6270.1,180.1,6861.7,90.1z' }),
                            react_1.default.createElement("path", { d: 'M6411.8-827c-70.8-32.5-134-99.5-160.8-170.4c-11.5-30.6-21.1-197.2-21.1-386.7v-333.1L5868-1723c-396.3-5.7-413.5-11.5-507.3-137.9c-55.5-74.7-55.5-254.6,0-329.3c93.8-126.4,111-132.1,505.4-137.9l361.8-5.7l5.7-361.9c5.7-394.4,11.5-411.6,137.9-505.4c74.7-55.5,254.6-55.5,329.3,0c126.4,93.8,132.1,111.1,137.8,505.4l5.8,361.9l361.8,5.7c394.4,5.7,411.6,11.5,505.4,137.9c55.5,74.7,55.5,254.6,0,329.3c-93.8,126.4-111.1,132.1-505.4,137.9l-361.8,5.7l-5.8,361.9c-5.7,394.4-11.5,411.6-134,503.5C6639.6-804,6488.3-790.6,6411.8-827z' })))))),
            (progresso === 0 && aguardando.name) && (react_1.default.createElement("div", null,
                react_1.default.createElement("button", { className: 'btn btn-danger', style: { width: '50px', padding: '0px', border: 0, borderRadius: '15px' }, onClick: function () { return setAguardando({}); }, title: 'Cancelar Envio' },
                    react_1.default.createElement("i", { style: { fontSize: '35px' }, className: 'glyph-icon icon-remove' })),
                react_1.default.createElement("button", { className: 'btn btn-green', style: { width: '50px', padding: '0px', border: 0, borderRadius: '15px' }, onClick: function () { return enviaArquivo(); }, title: "Enviar arquivo: '" + aguardando.name + "'" },
                    react_1.default.createElement("i", { style: { fontSize: '35px' }, className: 'glyph-icon icon-send' }))))));
    return (react_1.default.createElement("div", null,
        (progresso !== 0 && progresso !== 100) && (react_1.default.createElement("div", { style: { display: 'flex' } },
            react_1.default.createElement("div", { style: { width: '100px' } },
                estadoPausado ?
                    react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoes, onClick: function () { return enviaArquivo(); } },
                        react_1.default.createElement("i", { className: 'glyph-icon icon-play', title: 'Continuar' }))
                    :
                        react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoes, onClick: function () { return pausaUpload(); } },
                            react_1.default.createElement("i", { className: 'glyph-icon icon-pause', title: 'Pausar' })),
                react_1.default.createElement("button", { className: 'btn btn-default', style: estiloBotoes, onClick: function () { return cancelaEnvio(); } },
                    react_1.default.createElement("i", { className: 'glyph-icon icon-stop', title: 'Cancelar' }))),
            react_1.default.createElement("div", { style: { width: '100%' } },
                react_1.default.createElement(exports.ColorLinearProgress, { variant: 'determinate', value: progresso }),
                react_1.default.createElement("p", { style: { float: 'right' } },
                    progresso.toFixed(2),
                    "%")))),
        (progresso === 0 && !aguardando.name) && (react_1.default.createElement("div", null,
            react_1.default.createElement("input", { id: "FileUploader_" + idKey, className: 'float-left', type: 'file', onChange: function (e) {
                    carregaArquivo(e);
                }, style: { display: 'none' } }),
            react_1.default.createElement("button", { className: 'btn btn-default', style: { width: '100%' }, onClick: function () { return document.getElementById("FileUploader_" + idKey).click(); } }, "Selecionar Arquivo"))),
        (progresso === 0 && aguardando.name) && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { style: { display: 'flex', width: '100%' } },
                react_1.default.createElement("button", { className: 'btn btn-green', style: { width: '100%' }, onClick: function () { return enviaArquivo(); } }, "Enviar Arquivo"),
                react_1.default.createElement("button", { className: 'btn btn-danger', style: { width: 'max-content' }, onClick: function () { return setAguardando({}); } }, "Cancelar")),
            react_1.default.createElement("p", { style: { width: '100%', overflow: 'hidden', textOverflow: 'ellipsis' } },
                "Arquivo a ser Enviado: ",
                aguardando.name)))));
}
exports.default = FileUploader;
FileUploader.propTypes = {
    extensao: prop_types_1.default.string,
    funcaoRetorno: prop_types_1.default.func,
    enviarDireto: prop_types_1.default.bool,
    variant: prop_types_1.default.string
};
