"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var highlight_js_1 = __importDefault(require("highlight.js"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var HighLight = /** @class */ (function (_super) {
    __extends(HighLight, _super);
    function HighLight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HighLight.prototype.componentDidMount = function () {
        highlight_js_1.default.highlightBlock(react_dom_1.findDOMNode(this.refs.code));
    };
    HighLight.prototype.shouldComponentUpdate = function (nextProps) {
        if (this.props.language !== nextProps.language || this.props.className !== nextProps.className || this.props.children !== nextProps.children) {
            return true;
        }
        return false;
    };
    HighLight.prototype.componentDidUpdate = function () {
        highlight_js_1.default.initHighlighting.called = false;
        highlight_js_1.default.highlightBlock(react_dom_1.findDOMNode(this.refs.code));
    };
    HighLight.prototype.render = function () {
        var _a = this.props, children = _a.children, className = _a.className, language = _a.language, style = _a.style;
        return (react_1.default.createElement("pre", { className: className, style: style },
            react_1.default.createElement("code", { className: language, ref: 'code' }, children)));
    };
    return HighLight;
}(react_1.Component));
HighLight.propTypes = {
    children: prop_types_1.default.node.isRequired,
    className: prop_types_1.default.string,
    language: prop_types_1.default.string,
    style: prop_types_1.default.object
};
exports.default = HighLight;
