"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_maskedinput_1 = __importDefault(require("react-maskedinput"));
/**
 * @deprecated
 */
var Input = /** @class */ (function (_super) {
    __extends(Input, _super);
    function Input() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.confs = '';
        _this.onChange = function (event) {
            var onChange = _this.props.onChange;
            var value = _this.handleValue(event.target);
            value = _this.handleWithTypeValues(value);
            if (onChange) {
                onChange(value);
            }
            _this.props.handleUpdates(value);
            _this.stopWritingHandler(value);
        };
        _this.stopWritingHandler = function (value) {
            var _a = _this.props, stopWriting = _a.stopWriting, _b = _a.stopWritingTime, stopWritingTime = _b === void 0 ? 2000 : _b;
            if (stopWriting) {
                clearTimeout(_this.stopWritingTimeout);
                _this.stopWritingTimeout = setTimeout(function () {
                    stopWriting(value);
                }, stopWritingTime);
            }
        };
        _this.handleWithTypeValues = function (value) {
            var _a = _this.props, field = _a.field, type = _a.type, optionValue = _a.optionValue;
            if (type === 'checkbox') {
                var fieldValue = fieldsRedux_1.getField(field, 'value') || [];
                var index = fieldValue.indexOf(optionValue);
                if (index < 0) {
                    fieldValue.push(optionValue);
                }
                else {
                    fieldValue.splice(index, 1);
                }
                value = fieldValue;
            }
            if (type === 'radio') {
                value = optionValue;
            }
            return value;
        };
        _this.handleValue = function (target) {
            var confs = _this.stateOptions();
            return confs.alias === 'check'
                ? target.checked
                : target.value;
        };
        _this.handleClassName = function () {
            var _a = _this.props.className, className = _a === void 0 ? '' : _a;
            var confs = _this.stateOptions();
            var cn = '';
            if (confs.alias === 'text' && !className) {
                cn += ' form-control ';
            }
            cn += className;
            return cn;
        };
        _this.checkInputProps = function () {
            var _a = _this.props, field = _a.field, id = _a.id, _b = _a.type, type = _b === void 0 ? 'text' : _b, _c = _a.name, name = _c === void 0 ? '' : _c, placeholder = _a.placeholder, min = _a.min, max = _a.max, step = _a.step, maxLength = _a.maxLength, minLength = _a.minLength, autoFocus = _a.autoFocus, disabled = _a.disabled, readOnly = _a.readOnly, required = _a.required, _d = _a.style, style = _d === void 0 ? {} : _d, optionValue = _a.optionValue;
            var confs = _this.stateOptions();
            var value = fieldsRedux_1.getField(field, 'value');
            var inputProps = {};
            switch (confs.alias) {
                case 'button':
                    break;
                case 'check':
                    value = type === 'radio' ? value.toString() : value;
                    inputProps['checked'] = value ? value.indexOf(optionValue) < 0 ? false : true : false;
                    break;
                case 'color':
                    inputProps['value'] = value;
                    break;
                case 'hidden':
                    inputProps['value'] = value;
                    break;
                default:
                    inputProps['min'] = min;
                    inputProps['max'] = max;
                    inputProps['step'] = step;
                    inputProps['maxLength'] = maxLength;
                    inputProps['minLength'] = minLength;
                    inputProps['value'] = value;
                    inputProps['placeholder'] = placeholder;
            }
            inputProps['readOnly'] = readOnly;
            inputProps['required'] = required;
            inputProps['disabled'] = disabled;
            inputProps['autoFocus'] = autoFocus;
            inputProps['id'] = id;
            inputProps['type'] = type;
            inputProps['name'] = name;
            inputProps['className'] = _this.handleClassName();
            inputProps['style'] = style;
            inputProps = __assign(__assign({}, inputProps), _this.events());
            return inputProps;
        };
        _this.stateOptions = function () {
            var confs = _this.confs;
            var type = _this.props.type;
            if (confs) {
                return confs;
            }
            var confsAux = {};
            switch (type) {
                case 'time':
                    confsAux['alias'] = 'text';
                    break;
                case 'date':
                    confsAux['alias'] = 'text';
                    break;
                case 'datetime-local':
                    confsAux['alias'] = 'text';
                    break;
                case 'email':
                    confsAux['alias'] = 'text';
                    break;
                case 'url':
                    confsAux['alias'] = 'text';
                    break;
                case 'month':
                    confsAux['alias'] = 'text';
                    break;
                case 'week':
                    confsAux['alias'] = 'text';
                    break;
                case 'number':
                    confsAux['alias'] = 'text';
                    break;
                case 'password':
                    confsAux['alias'] = 'text';
                    break;
                case 'search':
                    confsAux['alias'] = 'text';
                    break;
                case 'button':
                    confsAux['alias'] = 'button';
                    break;
                case 'submit':
                    confsAux['alias'] = 'button';
                    break;
                case 'file':
                    confsAux['alias'] = 'button';
                    break;
                case 'checkbox':
                    confsAux['alias'] = 'check';
                    break;
                case 'radio':
                    confsAux['alias'] = 'check';
                    break;
                case 'color':
                    confsAux['alias'] = 'color';
                    break;
                case 'hidden':
                    confsAux['alias'] = 'hidden';
                    break;
                case 'range':
                    confsAux['alias'] = 'range';
                    break;
                default:
                    confsAux['alias'] = 'text';
            }
            _this.confs = confsAux;
            return confsAux;
        };
        _this.events = function () {
            var _a = _this.props, onFocus = _a.onFocus, onBlur = _a.onBlur, onKeyDown = _a.onKeyDown, onKeyPress = _a.onKeyPress, onKeyUp = _a.onKeyUp, onMouseEnter = _a.onMouseEnter, onMouseOver = _a.onMouseOver, onMouseMove = _a.onMouseMove, onMouseDown = _a.onMouseDown, onMouseUp = _a.onMouseUp, onClick = _a.onClick, onDoubleClick = _a.onDoubleClick, onMouseLeave = _a.onMouseLeave, onMouseOut = _a.onMouseOut;
            var onChange = _this.onChange;
            return {
                onChange: onChange,
                onFocus: onFocus,
                onBlur: onBlur,
                onKeyDown: onKeyDown,
                onKeyPress: onKeyPress,
                onKeyUp: onKeyUp,
                onMouseEnter: onMouseEnter,
                onMouseOver: onMouseOver,
                onMouseMove: onMouseMove,
                onMouseDown: onMouseDown,
                onMouseUp: onMouseUp,
                onClick: onClick,
                onDoubleClick: onDoubleClick,
                onMouseLeave: onMouseLeave,
                onMouseOut: onMouseOut
            };
        };
        return _this;
    }
    Input.prototype.componentWillUnmount = function () {
        if (this.props.stopWriting) {
            clearTimeout(this.stopWritingTimeout);
        }
    };
    Input.prototype.render = function () {
        var checkInputProps = this.checkInputProps;
        var mask = this.props.mask;
        var inputProps = checkInputProps();
        return !mask
            ? (react_1.default.createElement("input", __assign({}, inputProps)))
            : (react_1.default.createElement(react_maskedinput_1.default, __assign({ mask: mask }, inputProps)));
    };
    return Input;
}(react_1.Component));
Input.propTypes = {
    field: prop_types_1.default.string.isRequired,
    defaultValue: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string, prop_types_1.default.object, prop_types_1.default.array]),
    ajax: prop_types_1.default.bool,
    onChange: prop_types_1.default.func,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    receiveUpdates: prop_types_1.default.array,
    sendUpdates: prop_types_1.default.array,
    onFieldSuccess: prop_types_1.default.func,
    onActionSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    mask: prop_types_1.default.string,
    type: prop_types_1.default.oneOf([
        'time',
        'date',
        'datetime-local',
        'email',
        'url',
        'month',
        'week',
        'number',
        'password',
        'search',
        'button',
        'submit',
        'file',
        'checkbox',
        'radio',
        'color',
        'hidden',
        'range',
        'text'
    ]),
    placeholder: prop_types_1.default.string,
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    id: prop_types_1.default.string,
    name: prop_types_1.default.string,
    min: prop_types_1.default.string,
    max: prop_types_1.default.string,
    step: prop_types_1.default.string,
    maxLength: prop_types_1.default.string,
    minLength: prop_types_1.default.string,
    autoFocus: prop_types_1.default.bool,
    disabled: prop_types_1.default.bool,
    readOnly: prop_types_1.default.bool,
    required: prop_types_1.default.bool,
    onFocus: prop_types_1.default.func,
    onBlur: prop_types_1.default.func,
    onKeyDown: prop_types_1.default.func,
    onKeyPress: prop_types_1.default.func,
    onKeyUp: prop_types_1.default.func,
    onMouseEnter: prop_types_1.default.func,
    onMouseOver: prop_types_1.default.func,
    onMouseMove: prop_types_1.default.func,
    onMouseDown: prop_types_1.default.func,
    onMouseUp: prop_types_1.default.func,
    onClick: prop_types_1.default.func,
    onDoubleClick: prop_types_1.default.func,
    onMouseLeave: prop_types_1.default.func,
    onMouseOut: prop_types_1.default.func,
    stopWriting: prop_types_1.default.func,
    stopWritingTime: prop_types_1.default.number
};
exports.default = fieldsRedux_1.createField(Input);
