import { ButtonProps } from '@material-ui/core';
import * as React from 'react';

export interface MaterialButtonProps extends Omit<ButtonProps, 'color'> {
  /**
   * Cor Aplicada ao botão
   */
  color?: 'default' | 'inherit' | 'primary' | 'secondary' | 'info' | 'success' | 'warning' | 'danger'
}

declare function MaterialButton(props: MaterialButtonProps): JSX.Element

export default MaterialButton;