import { BoxProps } from '@material-ui/core';
import * as React from 'react';

export interface ProgramaProps extends BoxProps {
  code: string,
  children: React.ReactNode,
  loading: boolean,
  threads: Array<any>,
  hint: string,
  title: string,
  panelTitle: string,
  hideTitle: boolean, 
  programDidMount: () => void,
  bfHabNavegador: boolean,
  bfAbas: Array<any>,
  bfFerramentas: Array<any>,
  bfExecutaFuncao: (prm: string) => void,
  bfNmFuncaoVoltar: string,
  bfNmCompartilhar: string,
  bfHabCrud: boolean,
  bfNmSalva: string,
  bfNmExclui: string,
  bfHabFavorito: boolean,
  bfTitulo: string, 
  linkCompartilhamento: string,
  className: string,
  annotationParameters?: object,
  openAnnotationParameters?: (event: Event, parameters: object) => void
}

declare function Programa(props: ProgramaProps): JSX.Element

export default Programa;