"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var BarraFerramentas_1 = __importDefault(require("./../BarraFerramentas"));
var PageCodeEasterEgg_1 = __importDefault(require("./PageCodeEasterEgg"));
var argous = __importStar(require("../../actions"));
var api_1 = require("../../api");
var core_1 = require("@material-ui/core");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var fa_1 = require("react-icons/fa");
var react_redux_1 = require("react-redux");
var initialStateToolbarLoading = {
    annotations: false
};
function Programa(_a) {
    var _this = this;
    var code = _a.code, children = _a.children, _b = _a.loading, loading = _b === void 0 ? false : _b, _c = _a.threads, threads = _c === void 0 ? [] : _c, hint = _a.hint, title = _a.title, panelTitle = _a.panelTitle, hideTitle = _a.hideTitle, setCurrentProgram = _a.setCurrentProgram, programDidMount = _a.programDidMount, favorites = _a.favorites, setFavorites = _a.setFavorites, bfHabNavegador = _a.bfHabNavegador, _d = _a.bfAbas, bfAbas = _d === void 0 ? [] : _d, _e = _a.bfFerramentas, bfFerramentas = _e === void 0 ? [] : _e, bfExecutaFuncao = _a.bfExecutaFuncao, bfNmFuncaoVoltar = _a.bfNmFuncaoVoltar, bfNmCompartilhar = _a.bfNmCompartilhar, bfHabCrud = _a.bfHabCrud, bfNmSalva = _a.bfNmSalva, bfNmExclui = _a.bfNmExclui, _f = _a.bfHabFavorito, bfHabFavorito = _f === void 0 ? true : _f, bfTitulo = _a.bfTitulo, 
    // permissoes = { salvar: true, editar: true, excluir: true },
    linkCompartilhamento = _a.linkCompartilhamento, className = _a.className, rightSidebar = _a.rightSidebar, setRightSidebar = _a.setRightSidebar, setAddProgramWidget = _a.setAddProgramWidget, setProgramAnnotation = _a.setProgramAnnotation, annotationParameters = _a.annotationParameters, openAnnotationParameters = _a.openAnnotationParameters, _ = _a.fields, props = __rest(_a, ["code", "children", "loading", "threads", "hint", "title", "panelTitle", "hideTitle", "setCurrentProgram", "programDidMount", "favorites", "setFavorites", "bfHabNavegador", "bfAbas", "bfFerramentas", "bfExecutaFuncao", "bfNmFuncaoVoltar", "bfNmCompartilhar", "bfHabCrud", "bfNmSalva", "bfNmExclui", "bfHabFavorito", "bfTitulo", "linkCompartilhamento", "className", "rightSidebar", "setRightSidebar", "setAddProgramWidget", "setProgramAnnotation", "annotationParameters", "openAnnotationParameters", "fields"]);
    var theme = core_1.useTheme();
    var _g = react_1.useState({}), programa = _g[0], setPrograma = _g[1];
    var _h = react_1.useState(false), favoriteAnimationInsert = _h[0], setFavoriteAnimationInsert = _h[1];
    var _j = react_1.useState(false), favoriteAnimationRemove = _j[0], setFavoriteAnimationRemove = _j[1];
    var toolbarLoading = react_1.useState(initialStateToolbarLoading)[0] /*, setToolbarLoading*/;
    react_1.useEffect(function () {
        (function () { return __awaiter(_this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        setCurrentProgram(code);
                        return [4 /*yield*/, api_1.getProgram(code)];
                    case 1:
                        res = _a.sent();
                        // TODO prever aqui tempo de bloqueio diferenciado
                        if (res.pgmOk)
                            setPrograma(__assign(__assign({}, res.pgmDd), { loaded: true, habWidget: res.habWidget }));
                        else
                            setPrograma(function (p) { return (__assign(__assign({}, p), { dsErro: res.dsErro, loaded: true })); });
                        programDidMount && programDidMount();
                        return [2 /*return*/];
                }
            });
        }); })();
        return function () { return setCurrentProgram(undefined); };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var openAnnotations = function (event) { return setProgramAnnotation(__assign(__assign({}, programa), { open: true, code: code, annotationParameters: annotationParameters, openAnnotationParameters: openAnnotationParameters })); };
    var addFavorite = function () {
        var path = window.location.pathname;
        api_1.toggleFavorite({ link: path }).then(function (res) {
            setFavorites(res.fvrts);
            var existIn = res.fvrts.filter(function (item) { return item[3] === path; });
            if (existIn.length > 0) {
                setFavoriteAnimationInsert(true);
                setTimeout(function () { return setFavoriteAnimationInsert(false); }, 300);
            }
            else {
                setFavoriteAnimationRemove(true);
                setTimeout(function () { return setFavoriteAnimationRemove(false); }, 500);
            }
        });
    };
    var addWidget = function () {
        if (!code)
            return;
        if (!rightSidebar)
            setRightSidebar && setRightSidebar(true);
        setAddProgramWidget && setAddProgramWidget(code);
    };
    var checkIfIsFavorite = function () {
        var path = window.location.pathname;
        var existIn = favorites.filter(function (item) { return item[3] === path; });
        return existIn.length > 0 ? 'active' : '';
    };
    var pgHint = programa.pgHint, pgTitle = programa.pgTitle, pnlTitle = programa.pnlTitle, dsErro = programa.dsErro, loaded = programa.loaded, habWidget = programa.habWidget, snAnotacaoPrograma = programa.snAnotacaoPrograma;
    if (title !== undefined)
        pgTitle = title;
    if (hint !== undefined)
        pgHint = hint;
    if (panelTitle !== undefined)
        pnlTitle = panelTitle;
    if (bfTitulo === undefined)
        bfTitulo = pnlTitle;
    return (react_1.default.createElement(core_1.Box, __assign({ fontFamily: 'Raleway, Helvetica, Arial, sans-serif', className: className }, props),
        !hideTitle &&
            react_1.default.createElement("span", { style: { cursor: 'default', overflow: 'hidden', display: 'block', marginBottom: '2px', color: theme.palette.text.primary } },
                react_1.default.createElement("h2", { className: 'reset-margin pull-left', style: { color: theme.palette.text.primary } },
                    pgTitle,
                    react_1.default.createElement("span", { className: 'text-muted', style: { color: theme.palette.text.primary } }, "\u00A0|\u00A0")),
                react_1.default.createElement("p", { id: 'pg-subtitulo', className: 'pull-left hw-program-subtitulo', style: { color: theme.palette.text.primary } }, pgHint)),
        react_1.default.createElement(core_1.Paper, { variant: 'outlined', style: { padding: 10, position: 'relative' } },
            react_1.default.createElement(BarraFerramentas_1.default, __assign({ titulo: bfTitulo, abas: bfAbas, habFavorito: bfHabFavorito, habNavegador: bfHabNavegador, executaFuncao: bfExecutaFuncao, nmFuncaoVoltar: bfNmFuncaoVoltar, nmCompartilhar: bfNmCompartilhar, habCrud: bfHabCrud, nmSalva: bfNmSalva, nmExclui: bfNmExclui, ferramentas: bfFerramentas, checkIfIsFavorite: checkIfIsFavorite, addFavorite: addFavorite, linkCompartilhamento: linkCompartilhamento, favoriteAnimationInsert: favoriteAnimationInsert, favoriteAnimationRemove: favoriteAnimationRemove, threads: threads, currentProgram: code }, { addWidget: addWidget, habWidget: habWidget, snAnotacaoPrograma: snAnotacaoPrograma, openAnnotations: openAnnotations, toolbarLoading: toolbarLoading })),
            dsErro ? (react_1.default.createElement(core_1.Box, { textAlign: 'center' },
                react_1.default.createElement(fa_1.FaExclamationTriangle, { style: { color: '#ED1651', width: '90px', height: '90px' } }),
                react_1.default.createElement(core_1.Typography, { variant: 'h6' }, dsErro))) : (!pnlTitle || loading || !loaded) ? (react_1.default.createElement(core_1.Box, { position: 'relative', top: 20, left: '50%', "z-index": 20, height: 80, width: 0, marginLeft: '-20px' },
                react_1.default.createElement(core_1.CircularProgress, { disableShrink: true }))) : children),
        react_1.default.createElement(PageCodeEasterEgg_1.default, __assign({}, { code: code }))));
}
var mapStateToProps = function (state) { return ({
    fields: state.argous.fields,
    favorites: state.argous.favorites,
    rightSidebar: state.argous.rightSidebar,
    programAnnotation: state.argous.programAnnotation
}); };
var mapDispatchToProps = function (dispatch) { return ({
    setAddProgramWidget: function (data) { return dispatch(argous.setAddProgramWidget(data)); },
    setCurrentProgram: function (data) { return dispatch(argous.setCurrentProgram(data)); },
    setRightSidebar: function (data) { return dispatch(argous.setRightSidebar(data)); },
    setFavorites: function (data) { return dispatch(argous.setFavorites(data)); },
    setProgramAnnotation: function (data) { return dispatch(argous.setProgramAnnotation(data)); }
}); };
Programa.propTypes = {
    code: prop_types_1.default.string.isRequired,
    loading: prop_types_1.default.bool,
    children: prop_types_1.default.oneOfType([prop_types_1.default.node, prop_types_1.default.element]),
    favorites: prop_types_1.default.array,
    setFavorites: prop_types_1.default.func,
    setCurrentProgram: prop_types_1.default.func,
    programDidMount: prop_types_1.default.func,
    threads: prop_types_1.default.array,
    hideTitle: prop_types_1.default.bool,
    bfHabNavegador: prop_types_1.default.bool,
    bfTitulo: prop_types_1.default.string,
    bfFerramentas: prop_types_1.default.array,
    bfAbas: prop_types_1.default.array,
    bfExecutaFuncao: prop_types_1.default.func,
    bfNmFuncaoVoltar: prop_types_1.default.string,
    bfNmCompartilhar: prop_types_1.default.string,
    bfHabCrud: prop_types_1.default.bool,
    bfNmSalva: prop_types_1.default.string,
    bfNmExclui: prop_types_1.default.string,
    bfHabFavorito: prop_types_1.default.bool,
    hint: prop_types_1.default.string,
    linkCompartilhamento: prop_types_1.default.string,
    title: prop_types_1.default.string,
    panelTitle: prop_types_1.default.string,
    // permissoes: PropTypes.object,
};
exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(Programa);
