"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = void 0;
var Button_1 = __importDefault(require("./../Button"));
var Pagination_1 = __importDefault(require("./../Pagination"));
var fieldsRedux_1 = require("../../fieldsRedux");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var fa_1 = require("react-icons/fa");
/**
 * @deprecated
 */
var Action = /** @class */ (function (_super) {
    __extends(Action, _super);
    function Action() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Action.prototype.render = function () {
        var _a = this.props, glyphicon = _a.glyphicon, _b = _a.type, type = _b === void 0 ? 'default' : _b, _c = _a.className, className = _c === void 0 ? '' : _c, onClick = _a.onClick, item = _a.item, action = _a.action, dados = _a.dados, sendUpdates = _a.sendUpdates, receiveUpdates = _a.receiveUpdates, onSuccess = _a.onSuccess, onAllUpdated = _a.onAllUpdated, children = _a.children, style = _a.style, title = _a.title;
        return (react_1.default.createElement(Button_1.default, { onClick: function (allFields, event) { return onClick && onClick(item, event); }, sendUpdates: sendUpdates, receiveUpdates: receiveUpdates, onSuccess: onSuccess, onAllUpdated: onAllUpdated, action: action, dados: {
                dados: dados,
                item: item,
            }, className: (glyphicon
                ? "btn btn-xs btn-round btn-action-min-size btn-" + type
                : '') + " " + className, style: style, title: title },
            glyphicon && react_1.default.createElement("i", { className: glyphicon }),
            children && react_1.default.createElement("span", null, children)));
    };
    return Action;
}(react_1.Component));
exports.Action = Action;
Action.propTypes = {
    glyphicon: prop_types_1.default.string,
    children: prop_types_1.default.node,
    onClick: prop_types_1.default.func,
    sendUpdates: prop_types_1.default.array,
    receiveUpdates: prop_types_1.default.array,
    onSuccess: prop_types_1.default.func,
    onAllUpdated: prop_types_1.default.func,
    action: prop_types_1.default.string,
    dados: prop_types_1.default.object,
    type: prop_types_1.default.oneOf([
        'default',
        'primary',
        'success',
        'info',
        'warning',
        'danger',
    ]),
    className: prop_types_1.default.string,
    style: prop_types_1.default.object,
    title: prop_types_1.default.string,
    item: prop_types_1.default.oneOfType([prop_types_1.default.array, prop_types_1.default.object]),
};
var SimpleTable = /** @class */ (function (_super) {
    __extends(SimpleTable, _super);
    function SimpleTable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            editActived: undefined,
            filterValue: '',
        };
        _this.filtraData = function (data) {
            var _a = _this.props, field = _a.field, rows = _a.rows;
            var offset = fieldsRedux_1.getField(field, 'offset');
            if (data) {
                if (offset !== undefined && rows !== undefined) {
                    var nr1_1 = offset * rows;
                    var nr2_1 = nr1_1 + rows;
                    return data.filter(function (item, index) {
                        if (index >= nr1_1 && index < nr2_1) {
                            return true;
                        }
                        return false;
                    });
                }
                return data;
            }
            return [];
        };
        _this.listaFilhos = function () {
            var children = _this.props.children;
            if (children) {
                if (!children.length) {
                    return [children];
                }
                return children;
            }
            return [];
        };
        _this.ordenaData = function (data) {
            var field = _this.props.field;
            var dtAux = JSON.stringify(data);
            dtAux = JSON.parse(dtAux);
            var order = fieldsRedux_1.getField(field, 'order');
            var sort = fieldsRedux_1.getField(field, 'sort');
            if (!(typeof order === 'string' && order.length === 0)) {
                var verificaData_1 = _this.verificaData;
                var sorted = dtAux.sort(function (a, b) {
                    return sort === 'asc'
                        ? verificaData_1(a[order]) > verificaData_1(b[order])
                        : verificaData_1(a[order]) < verificaData_1(b[order])
                            ? 1
                            : sort === 'asc'
                                ? verificaData_1(b[order]) > verificaData_1(a[order])
                                : verificaData_1(b[order]) < verificaData_1(a[order])
                                    ? -1
                                    : 0;
                });
                return sorted;
            }
            return data;
        };
        _this.verificaData = function (data) {
            if (typeof data !== 'undefined') {
                if (typeof data === 'string') {
                    data = data.trim().toLowerCase();
                    var aux = parseInt(data, 10);
                    data = isNaN(aux) ? data : aux;
                }
            }
            return data;
        };
        _this.setItemOrder = function (index) {
            var _a = _this.props, field = _a.field, alias = _a.alias;
            var order = fieldsRedux_1.getField(field, 'order');
            var sort = fieldsRedux_1.getField(field, 'sort');
            var newOrder;
            var newSort;
            if (order !== alias[index]) {
                newOrder = alias[index];
                newSort = 'asc';
            }
            else {
                newOrder = sort === 'desc' ? '' : alias[index];
                newSort = 'desc';
            }
            fieldsRedux_1.setField(field, 'order', newOrder);
            fieldsRedux_1.setField(field, 'sort', newSort);
        };
        _this.getPages = function (values, rows) {
            if (values) {
                var resto = values.length % rows;
                var aux = values.length - resto;
                var val = aux / rows;
                val = resto ? val + 1 : val;
                return val;
            }
            return 0;
        };
        _this.changePage = function (data) {
            var _a = _this.props, field = _a.field, onPageChange = _a.onPageChange;
            var pagina = data.selected;
            if (onPageChange) {
                onPageChange(data);
            }
            fieldsRedux_1.setField(field, 'offset', pagina);
        };
        _this.filterData = function (value, data) {
            var filter = _this.props.filter;
            return data.filter(function (d) {
                for (var _i = 0, filter_1 = filter; _i < filter_1.length; _i++) {
                    var f = filter_1[_i];
                    if (d[f] && d[f].toString().toLowerCase().indexOf(value) >= 0) {
                        return true;
                    }
                }
                return false;
            });
        };
        _this.checkColumnOptions = function (item, value, key, columnOptions) {
            if (columnOptions) {
                for (var _i = 0, columnOptions_1 = columnOptions; _i < columnOptions_1.length; _i++) {
                    var co = columnOptions_1[_i];
                    if (co.alias === key) {
                        if (typeof co.decimalScale !== 'undefined') {
                            try {
                                if (!isNaN(value))
                                    value = parseFloat(value, 10).toFixed(co.decimalScale);
                            }
                            catch (e) { }
                        }
                        if (co.decimalSeparator) {
                            value = value.replace('.', co.decimalSeparator);
                        }
                        if (co.percentage) {
                            if (!isNaN(value)) {
                                value = value * 100;
                                value = value + "%";
                            }
                        }
                        value
                            = typeof co.prefixo !== 'undefined' ? "" + co.prefixo + value : value;
                        value
                            = typeof co.sufixo !== 'undefined' ? "" + value + co.sufixo : value;
                        if (co.customJsx && typeof co.customJsx === 'function') {
                            value = co.customJsx({ item: item, value: value });
                        }
                    }
                }
            }
            return value;
        };
        _this.checkEditConfs = function (editConfs, a, index1, index2) {
            var editActived = _this.state.editActived;
            if (!editActived && editConfs[a]) {
                _this.setState({ editActived: { a: a, index1: index1, index2: index2 } });
            }
        };
        _this.finishEditing = function () {
            _this.setState({ editActived: undefined });
        };
        _this.checkIfIsEditing = function (item, a, columnOptions, editConfs, index1, index2) {
            var _a = _this.state.editActived, editActived = _a === void 0 ? {} : _a;
            if (editActived.a === a &&
                editActived.index1 === index1 &&
                editActived.index2 === index2) {
                return editConfs[a]({
                    item: item,
                    value: item[a],
                    indexY: index1,
                    indexX: index2,
                    finishEditing: _this.finishEditing,
                });
            }
            return _this.checkColumnOptions(item, item[a], a, columnOptions);
        };
        _this.showFullContent = function (e) {
            var cells = Array.from(e.currentTarget.cells);
            cells.forEach(function (c) {
                c.style.whiteSpace = 'normal';
            });
        };
        _this.hideFullContent = function (e) {
            var cells = Array.from(e.currentTarget.cells);
            cells.forEach(function (c) {
                c.style.whiteSpace = 'nowrap';
            });
        };
        return _this;
    }
    SimpleTable.prototype.componentDidMount = function () {
        var _this = this;
        var _a = this.props, field = _a.field, defaultValue = _a.defaultValue, filterLastValue = _a.filterLastValue;
        fieldsRedux_1.initField(field, defaultValue).then(function (value) {
            var _a = _this.props, order = _a.order, sort = _a.sort, initialPage = _a.initialPage;
            if (order) {
                fieldsRedux_1.setField(field, 'order', order);
                fieldsRedux_1.setField(field, 'sort', sort ? sort : 'asc');
            }
            fieldsRedux_1.setField(field, 'offset', initialPage ? initialPage : 0);
        });
        if (filterLastValue) {
            this.setState({ filterValue: filterLastValue });
        }
    };
    SimpleTable.prototype.render = function () {
        var _this = this;
        var _a = this, filtraData = _a.filtraData, listaFilhos = _a.listaFilhos, ordenaData = _a.ordenaData, getPages = _a.getPages, changePage = _a.changePage;
        var filterValue = this.state.filterValue;
        var _b = this.props, field = _b.field, _c = _b.head, head = _c === void 0 ? [] : _c, alias = _b.alias, _d = _b.className, className = _d === void 0 ? '' : _d, onClick = _b.onClick, onMouseDown = _b.onMouseDown, _e = _b.tdClassName, tdClassName = _e === void 0 ? '' : _e, rows = _b.rows, id = _b.id, initialPage = _b.initialPage, columnOptions = _b.columnOptions, _f = _b.editConfs, editConfs = _f === void 0 ? {} : _f, filter = _b.filter, _g = _b.filterPlaceholder, filterPlaceholder = _g === void 0 ? 'Digite aqui para buscar...' : _g, _h = _b.filterClasses, filterClasses = _h === void 0 ? 'form-control' : _h, filterKeepLastValue = _b.filterKeepLastValue, wrap = _b.wrap, _j = _b.wrapWidth, wrapWidth = _j === void 0 ? 250 : _j;
        var wrapStyle = {
            maxWidth: wrapWidth,
            whiteSpace: 'nowrap',
            overflow: 'hidden',
            textOverflow: 'ellipsis',
        };
        var data = fieldsRedux_1.getField(field, 'value');
        data = filterValue ? this.filterData(filterValue, data) : data;
        var order = fieldsRedux_1.getField(field, 'order');
        var sort = fieldsRedux_1.getField(field, 'sort');
        var nrPages = getPages(data, rows);
        var dataOrdenada = data ? ordenaData(data) : data;
        var dataFiltrada = filtraData(dataOrdenada);
        var listaChildrens = listaFilhos();
        return (react_1.default.createElement("div", { id: id, className: 'over-hidden' },
            filter && (react_1.default.createElement("input", { value: filterValue, placeholder: filterPlaceholder, onChange: function (e) {
                    _this.setState({ filterValue: e.target.value.toLowerCase() });
                    filterKeepLastValue && filterKeepLastValue(e);
                }, className: filterClasses })),
            react_1.default.createElement("table", { className: "table argous-table " + className },
                head.length > 0 && (react_1.default.createElement("thead", null,
                    react_1.default.createElement("tr", null,
                        head.map(function (item, index) { return (react_1.default.createElement("th", { key: index, 
                            // onClick={() => setItemOrder(index)}
                            className: order === alias[index] ? 'active' : undefined },
                            item,
                            order === alias[index] &&
                                sort === 'asc' && react_1.default.createElement(fa_1.FaSortAmountAsc, null),
                            order === alias[index] &&
                                sort === 'desc' && react_1.default.createElement(fa_1.FaSortAmountDesc, null))); }),
                        listaChildrens.map(function (item, index) { return (react_1.default.createElement("th", { key: "act" + index }, item.props.head)); })))),
                react_1.default.createElement("tbody", null, dataFiltrada.length > 0 &&
                    dataFiltrada.map(function (item, index1) {
                        return item && (react_1.default.createElement("tr", __assign({}, item.argousProps, { key: index1, onClick: function () { return onClick && onClick(item, index1); }, onMouseDown: onMouseDown, onMouseEnter: wrap ? (function (e) { return _this.showFullContent(e); }) : undefined, onMouseLeave: wrap ? (function (e) { return _this.hideFullContent(e); }) : undefined }),
                            alias &&
                                alias.map(function (a, index2) { return (react_1.default.createElement("td", { key: index2, onClick: function () {
                                        return _this.checkEditConfs(editConfs, a, index1, index2);
                                    }, className: tdClassName, style: wrap ? wrapStyle : undefined }, _this.checkIfIsEditing(item, a, columnOptions, editConfs, index1, index2))); }),
                            !alias &&
                                item.map(function (a, index2) { return react_1.default.createElement("td", { key: index2 }, a); }),
                            listaChildrens.map(function (act, index3) { return (react_1.default.createElement("td", { key: "act" + index3, className: tdClassName }, react_1.default.cloneElement(act, __assign(__assign({}, item.props), { item: item })))); })));
                    }))),
            nrPages > 0 && (react_1.default.createElement(Pagination_1.default, { pages: nrPages, initialPage: initialPage, onChange: changePage, className: 'pull-right' }))));
    };
    return SimpleTable;
}(react_1.Component));
SimpleTable.propTypes = {
    field: prop_types_1.default.string.isRequired,
    id: prop_types_1.default.string,
    ref: prop_types_1.default.func,
    alias: prop_types_1.default.array,
    defaultValue: prop_types_1.default.oneOfType([
        prop_types_1.default.number,
        prop_types_1.default.string,
        prop_types_1.default.object,
        prop_types_1.default.array,
    ]),
    fieldListener: prop_types_1.default.func,
    onPageChange: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    head: prop_types_1.default.array,
    className: prop_types_1.default.string,
    rows: prop_types_1.default.number,
    order: prop_types_1.default.string,
    sort: prop_types_1.default.oneOf(['asc', 'desc']),
    onClick: prop_types_1.default.func,
    children: prop_types_1.default.oneOfType([prop_types_1.default.node, prop_types_1.default.element]),
    initialPage: prop_types_1.default.number,
    columnOptions: prop_types_1.default.array,
    editConfs: prop_types_1.default.object,
    filter: prop_types_1.default.array,
    filterKeepLastValue: prop_types_1.default.func,
    filterLastValue: prop_types_1.default.string,
    filterPlaceholder: prop_types_1.default.string,
    filterClasses: prop_types_1.default.string,
    onMouseDown: prop_types_1.default.func,
    tdClassName: prop_types_1.default.string,
    wrap: prop_types_1.default.bool,
    wrapWidth: prop_types_1.default.number,
};
exports.default = fieldsRedux_1.createField(SimpleTable, { disableInitField: true });
