"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Input_1 = __importDefault(require("./../Input"));
var SimpleTable_1 = __importStar(require("./../SimpleTable"));
var fieldsRedux_1 = require("../../fieldsRedux");
var api_1 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importStar(require("react"));
var react_custom_scrollbars_1 = require("react-custom-scrollbars");
/**
 * @deprecated
 */
var TablePicker = /** @class */ (function (_super) {
    __extends(TablePicker, _super);
    function TablePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            dropOpen: false,
            typeMessage: 0,
            resultHeight: 0
        };
        _this.changesAfterSelect = 2;
        _this.doSearchAction = function (value) {
            var recemSelecionado = _this.resultRecemSelecionado();
            clearTimeout(_this.searchTimeout);
            if (value.value && value.value.length > 2 && !recemSelecionado) {
                _this.setState({ typeMessage: 2, resultHeight: 50 });
                _this.searchTimeout = setTimeout(function () {
                    api_1.serverAction(_this.props.searchAction, { value: value.value }).then(function (res) {
                        if (res.result) {
                            var resultsFiltrados = _this.filtraResults(res.result);
                            var aux = resultsFiltrados.length > 0;
                            _this.setState({ typeMessage: aux ? 0 : 3, resultHeight: aux ? resultsFiltrados.length * 38 : 50 });
                            fieldsRedux_1.setField("results-" + _this.props.field, 'value', resultsFiltrados);
                        }
                        else {
                            _this.setState({ typeMessage: 3, resultHeight: 50 });
                        }
                    });
                }, 350);
            }
            else {
                var aux = value.value && value.value.length > 0;
                _this.setState({ typeMessage: !recemSelecionado && aux ? 1 : 0, resultHeight: !recemSelecionado && aux ? 50 : 0 });
                fieldsRedux_1.setField("results-" + _this.props.field, 'value', []);
            }
        };
        _this.filtraResults = function (results) {
            var itensAlreadyAdded = fieldsRedux_1.getField(_this.props.field, 'value');
            if (itensAlreadyAdded && itensAlreadyAdded.length > 0) {
                var resultsFiltrados = results.filter(function (r) {
                    var exist = itensAlreadyAdded.filter(function (a) { return !_this.compareObjectsWithAlias(a, r); }).length > 0;
                    return !exist;
                });
                return resultsFiltrados;
            }
            return results;
        };
        _this.resultRecemSelecionado = function () {
            _this.changesAfterSelect++;
            if (_this.changesAfterSelect === 1) {
                return true;
            }
            else if (_this.changesAfterSelect === 2) {
                fieldsRedux_1.setField("search-" + _this.props.field, 'selectedResult', undefined);
            }
            return false;
        };
        _this.selectResult = function (item) {
            var _a = _this.props, field = _a.field, alias = _a.alias;
            fieldsRedux_1.setField("search-" + field, 'selectedResult', item);
            _this.changesAfterSelect = 0;
            fieldsRedux_1.setField("search-" + field, 'value', _this.createSearchSelectedValue(item, alias));
            fieldsRedux_1.setField("results-" + field, 'value', []);
            _this.setState({ typeMessage: 0, resultHeight: 0 });
            _this.add();
        };
        _this.createSearchSelectedValue = function (item, alias) {
            var text = '';
            alias.map(function (m) { return text = text + (item[m] + " "); });
            return text;
        };
        _this.add = function () {
            var itemToAdd = fieldsRedux_1.getField("search-" + _this.props.field, 'selectedResult');
            if (itemToAdd) {
                if (_this.props.addAction) {
                    api_1.serverAction(_this.props.addAction, { item: itemToAdd }).then(function (res) {
                        if (res.pgmOk) {
                            var itensAlreadyAdded = fieldsRedux_1.getField(_this.props.field, 'value');
                            fieldsRedux_1.setField(_this.props.field, 'value', __spreadArray([itemToAdd], itensAlreadyAdded));
                            fieldsRedux_1.setField("search-" + _this.props.field, 'value', '');
                            fieldsRedux_1.setField("search-" + _this.props.field, 'selectedResult', undefined);
                        }
                    });
                }
                else {
                    var itensAlreadyAdded = fieldsRedux_1.getField(_this.props.field, 'value');
                    fieldsRedux_1.setField(_this.props.field, 'value', __spreadArray([itemToAdd], itensAlreadyAdded));
                    fieldsRedux_1.setField("search-" + _this.props.field, 'value', '');
                    fieldsRedux_1.setField("search-" + _this.props.field, 'selectedResult', undefined);
                }
            }
        };
        _this.focusTypeMessage = function () {
            var resultsData = fieldsRedux_1.getField("results-" + _this.props.field, 'value');
            if (resultsData.length === 0) {
                _this.setState({ typeMessage: 1, resultHeight: 50 });
            }
            else {
                _this.setState({ resultHeight: resultsData.length * 38 });
            }
        };
        _this.blurTypeMessage = function () {
            _this.blurTimeout = setTimeout(function () {
                _this.setState({ typeMessage: 0, resultHeight: 0 });
            }, 250);
        };
        _this.removeItem = function (item) {
            api_1.serverAction(_this.props.removeAction, { item: item }).then(function (res) {
                if (res.pgmOk) {
                    var itensAlreadyAdded = fieldsRedux_1.getField(_this.props.field, 'value');
                    var newItens = itensAlreadyAdded.filter(function (i) { return _this.compareObjectsWithAlias(i, item); });
                    fieldsRedux_1.setField(_this.props.field, 'value', newItens);
                }
            });
        };
        _this.compareObjectsWithAlias = function (a, b) {
            var different = false;
            _this.props.alias.map(function (i) {
                if (a[i] !== b[i]) {
                    different = true;
                }
                return null;
            });
            return different;
        };
        return _this;
    }
    TablePicker.prototype.componentWillUnmount = function () {
        clearTimeout(this.searchTimeout);
        clearTimeout(this.blurTimeout);
    };
    TablePicker.prototype.render = function () {
        var _a = this.props, field = _a.field, defaultValue = _a.defaultValue, alias = _a.alias, head = _a.head, rows = _a.rows, removeAction = _a.removeAction, fieldListener = _a.fieldListener, placeholder = _a.placeholder;
        var _b = this.state, typeMessage = _b.typeMessage, resultHeight = _b.resultHeight;
        var value = fieldsRedux_1.getField(field, 'value');
        return (react_1.default.createElement("form", { onSubmit: function (e) { return e.preventDefault(); } },
            react_1.default.createElement("table", { className: 'argous-groupselect' },
                react_1.default.createElement("tbody", null,
                    react_1.default.createElement("tr", { className: 'head' },
                        react_1.default.createElement("td", { className: 'gs-search' },
                            react_1.default.createElement(Input_1.default, { placeholder: placeholder, onFocus: this.focusTypeMessage, onBlur: this.blurTypeMessage, field: "search-" + field, fieldListener: this.doSearchAction }))),
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement("td", { colSpan: '2' },
                            react_1.default.createElement("div", { className: 'argous-list-dropdown', style: { height: resultHeight } },
                                react_1.default.createElement(react_custom_scrollbars_1.Scrollbars, null,
                                    typeMessage > 0 && (react_1.default.createElement("div", { className: 'padding-top-sm padding-bottom-sm color999 text-center' },
                                        typeMessage === 1 && 'Escreva para começar a buscar',
                                        typeMessage === 2 && 'Pesquisando...',
                                        typeMessage === 3 && 'Nenhum resultado foi encontrado')),
                                    react_1.default.createElement(SimpleTable_1.default, { field: "results-" + field, alias: alias, onClick: this.selectResult, className: 'reset-margin' }))),
                            react_1.default.createElement(SimpleTable_1.default, { field: field, defaultValue: defaultValue, alias: alias, head: head, rows: value && value.length > rows ? rows : undefined, fieldListener: fieldListener, className: 'reset-margin-bottom' }, removeAction && react_1.default.createElement(SimpleTable_1.Action, { onClick: this.removeItem, glyphicon: 'glyph-icon icon-close' })),
                            (!value || (value && value.length < 1)) && (react_1.default.createElement("div", { className: 'padding-top-sm padding-bottom-sm text-center', style: { backgroundColor: this.props.theme.palette.background.paper } }, "Pesquise acima para adicionar"))))))));
    };
    return TablePicker;
}(react_1.Component));
TablePicker.propTypes = {
    field: prop_types_1.default.string.isRequired,
    alias: prop_types_1.default.array.isRequired,
    searchAction: prop_types_1.default.string.isRequired,
    fieldListener: prop_types_1.default.func,
    destroyOnUnmount: prop_types_1.default.bool,
    addAction: prop_types_1.default.string,
    placeholder: prop_types_1.default.string,
    removeAction: prop_types_1.default.string,
    head: prop_types_1.default.array,
    rows: prop_types_1.default.number
};
exports.default = core_1.withTheme(TablePicker);
