"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../../utils");
var api_1 = require("../../utils/api");
var core_1 = require("@material-ui/core");
var lab_1 = require("@material-ui/lab");
var lodash_1 = require("lodash");
var react_1 = __importStar(require("react"));
// import PropTypes from 'prop-types';
var retornaType = function (type) {
    switch (type) {
        case 'beneficiarios':
            return ({
                label: 'Beneficiário',
                action: 'getBeneficiarios',
                busca: 'dsBusca',
                res: 'Beneficiarios',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? utils_1.formataNome(option[1]) : '' : option ? lista.filter(function (i) { return i[0] === option[0]; })[0][1] : ''; }
            });
        case 'empresas':
            return ({
                label: 'Empresa',
                action: 'getEmpresas',
                busca: 'dsBusca',
                res: 'Empresas',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? option[2] + " - " + option[3] : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        case 'gruposUnimed':
            return ({
                label: 'Grupos Unimed',
                action: 'getGruposUnimed',
                busca: 'dsBusca',
                res: 'Unimeds',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? option[1] : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        case 'estados':
            return ({
                label: 'Estado',
                action: 'getEstados',
                busca: 'dsBusca',
                res: 'Estados',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? option[0] + " - " + option[1] : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        case 'cidades':
            return ({
                label: 'Cidade',
                action: 'getCidades',
                busca: 'dsCidade',
                res: 'cidades',
                getLabel: function (option, lista) { var _a, _b; return lodash_1.isArray(option) ? option.length ? utils_1.formataNome((_a = option[1]) === null || _a === void 0 ? void 0 : _a.trim()) + " - " + ((_b = option[2]) === null || _b === void 0 ? void 0 : _b.trim()) : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        case 'unimeds':
            return ({
                label: 'Unimed',
                action: 'getUnimeds',
                busca: 'dsBusca',
                res: 'Unimeds',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? option[0] + " - " + option[1] : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        case 'prestadores':
            return ({
                label: 'Prestadores',
                action: 'getPrestadores',
                busca: 'dsBusca',
                res: 'Prestadores',
                getLabel: function (option, lista) { return lodash_1.isArray(option) ? option.length ? option[1] + " - " + utils_1.formataNome(option[2]) : '' : option ? lista.filter(function (i) { return i[0] === option; })[0][1] : ''; }
            });
        default:
            return ({});
    }
};
var UtilAutoComplete = function (_a) {
    var _b = _a.type, type = _b === void 0 ? '' : _b, label = _a.label, value = _a.value, _c = _a.textFieldProps, textFieldProps = _c === void 0 ? {} : _c, _d = _a.onChange, onChange = _d === void 0 ? function (e) { return e; } : _d, excluidos = _a.excluidos, idEmpresa = _a.idEmpresa, cdEstado = _a.cdEstado, cdUnimed = _a.cdUnimed, getOptionLabel = _a.getOptionLabel, _e = _a.pgCode, pgCode = _e === void 0 ? 'BuscasHelper' : _e, action = _a.action, busca = _a.busca, resposta = _a.resposta, searchParams = _a.searchParams, filterFunction = _a.filterFunction, forceUpdate = _a.forceUpdate, readOnly = _a.readOnly, props = __rest(_a, ["type", "label", "value", "textFieldProps", "onChange", "excluidos", "idEmpresa", "cdEstado", "cdUnimed", "getOptionLabel", "pgCode", "action", "busca", "resposta", "searchParams", "filterFunction", "forceUpdate", "readOnly"]);
    var _f = react_1.useState(false), open = _f[0], setOpen = _f[1];
    var _g = react_1.useState([]), lista = _g[0], setLista = _g[1];
    var _h = react_1.useState(''), inputValue = _h[0], setInputValue = _h[1];
    var buscar = react_1.useCallback(function (valor) { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        var _a;
        var _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, api_1.serverAction(action || retornaType(type).action, __assign((_a = {}, _a[busca || ((_b = retornaType(type)) === null || _b === void 0 ? void 0 : _b.busca) || 'value'] = valor || inputValue, _a.excluidos = excluidos, _a.idEmpresa = idEmpresa, _a.cdEstado = cdEstado, _a.cdUnimed = cdUnimed, _a), searchParams), true, pgCode)];
                case 1:
                    res = _d.sent();
                    setLista(res[resposta || ((_c = retornaType(type)) === null || _c === void 0 ? void 0 : _c.res) || 'result'] || []);
                    return [2 /*return*/];
            }
        });
    }); }, [inputValue, type, searchParams]);
    react_1.useEffect(function () {
        if (lodash_1.isString(value))
            buscar(value);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    react_1.useEffect(function () {
        // if (inputValue.length < 2) return;
        buscar();
    }, [inputValue, buscar]);
    return (react_1.default.createElement(lab_1.Autocomplete, __assign({ open: open, onOpen: function () { return !readOnly && setOpen(true); }, onClose: function () { return setOpen(false); }, disableClearable: readOnly, options: lodash_1.isObject(value) ? lista.filter(function (v) { return filterFunction ? filterFunction(v, value) : true || v[0] !== value[0]; }) : lista, getOptionSelected: function (o, v) { return o[0] === v; }, getOptionLabel: getOptionLabel ? (function (option) { return getOptionLabel(option, lista); }) : (function (option) { return retornaType(type).getLabel(option, lista); }), noOptionsText: inputValue.length < 2 ? 'Digite para pesquisar' : 'Não Encontrado', clearText: 'Limpar', openText: 'Abrir', onInputChange: function (e) { var _a; return setInputValue(((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value) || ''); }, filterSelectedOptions: true, autoComplete: true, autoHighlight: true }, { value: value, onChange: onChange }, props, { renderInput: function (params) { return (react_1.default.createElement(core_1.TextField, __assign({ margin: 'dense', variant: 'outlined', label: label || retornaType(type).label }, params, textFieldProps, { InputProps: __assign(__assign({}, textFieldProps.InputProps), params.InputProps), inputProps: __assign(__assign(__assign({}, textFieldProps.inputProps), params.inputProps), { readOnly: readOnly }) }))); } })));
};
// UtilAutoComplete.propTypes = {
//   type: PropTypes.oneOf(['beneficiarios', 'empresas', 'gruposUnimed', 'estados', 'cidades', 'unimeds', 'prestadores']).isRequired,
//   value: PropTypes.array,
//   textFieldProps: PropTypes.object,
//   onChange: PropTypes.func,
//   excluidos: PropTypes.bool,
//   idEmpresa: PropTypes.string,
//   cdEstado: PropTypes.string,
//   cdUnimed: PropTypes.string,
//   getOptionLabel: PropTypes.func
// }
exports.default = UtilAutoComplete;
