"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitFieldsData = exports.fieldUpdatesActionHandler = exports.fieldChangeListener = exports.setFieldValueToServer = exports.setServerValueToField = exports.clearAllFields = exports.clearField = exports.getAllFields = exports.getPreviousField = exports.getField = exports.getFieldsByPrefix = exports.setFieldsByObject = exports.setAnotherProgramField = exports.setField = exports.initField = exports.getCurrentProgram = void 0;
var argous = __importStar(require("../actions"));
var api_1 = require("../api");
var store_1 = require("../utils/store");
var getCurrentProgram = function () {
    var state = store_1.getStore().getState();
    var currentProgram = state.argous.currentProgram;
    return currentProgram;
};
exports.getCurrentProgram = getCurrentProgram;
/**
 * @deprecated
 */
var initField = function (field, defaultValue) { return __awaiter(void 0, void 0, void 0, function () {
    var state, _a, currentProgram, fields, res, value, alreadyHaveValue;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!!exports.getField(field).ready) return [3 /*break*/, 2];
                state = store_1.getStore().getState();
                _a = state.argous, currentProgram = _a.currentProgram, fields = _a.fields;
                exports.setField(field, 'ready', true);
                return [4 /*yield*/, api_1.agGet({ pgCode: currentProgram, field: field })];
            case 1:
                res = _b.sent();
                value = handleFieldValue(currentProgram, fields, field, res, defaultValue);
                alreadyHaveValue = typeof exports.getField(field).value !== 'undefined';
                if (!alreadyHaveValue) {
                    exports.setField(field, 'value', value);
                }
                exports.setField(field, 'defaultValue', value);
                return [2 /*return*/, value];
            case 2: return [2 /*return*/, new Promise(function (resolve) { return resolve(); })];
        }
    });
}); };
exports.initField = initField;
var setField = function (field, key, value, ajax) {
    var _a, _b;
    var currentProgram = store_1.getStore().getState().argous.currentProgram;
    var fieldInfo = exports.getField(field);
    if ((typeof key !== 'object' || Array.isArray(key)) && typeof value === 'undefined') {
        key = { value: key };
    }
    if (typeof key === 'string' && typeof value !== 'undefined') {
        store_1.getStore().dispatch(argous.setCurrentField(currentProgram, field, __assign(__assign({}, fieldInfo), (_a = {}, _a[key] = value, _a))));
    }
    else {
        store_1.getStore().dispatch(argous.setCurrentField(currentProgram, field, __assign(__assign({}, fieldInfo), key)));
    }
    if ((key === 'value' && ajax) || (typeof key !== 'string' && key['value'] && value)) {
        return api_1.agSet((_b = {}, _b[field] = value, _b.pgCode = currentProgram, _b));
    }
    return new Promise(function (resolve) { return resolve({ pgmOk: false }); });
};
exports.setField = setField;
var setAnotherProgramField = function (field, obj, program) {
    var fieldInfo = exports.getField(field);
    if ((typeof obj !== 'object' || Array.isArray(obj))) {
        obj = { value: obj };
    }
    store_1.getStore().dispatch(argous.setCurrentField(program, field, __assign(__assign({}, fieldInfo), obj)));
};
exports.setAnotherProgramField = setAnotherProgramField;
/**
 * @deprecated
 */
var setFieldsByObject = function (object, prefix) {
    Object.keys(object).forEach(function (o) {
        if (typeof object[o] !== 'object' || Array.isArray(object[o])) {
            exports.setField("" + (prefix ? prefix : '') + o, object[o]);
        }
    });
};
exports.setFieldsByObject = setFieldsByObject;
/**
 * @deprecated
 */
var getFieldsByPrefix = function (prefix, letPrefix) {
    var state = store_1.getStore().getState();
    var _a = state.argous, fields = _a.fields, currentProgram = _a.currentProgram;
    var prefixLength = prefix.length;
    var fieldsPgm = fields[currentProgram] || {};
    var fieldsWithPrefix = {};
    for (var _i = 0, _b = Object.keys(fieldsPgm); _i < _b.length; _i++) {
        var key = _b[_i];
        if (key.indexOf(prefix) === 0 && typeof fieldsPgm[key].value !== 'undefined') {
            fieldsWithPrefix[letPrefix ? key : key.substring(prefixLength)] = fieldsPgm[key].value;
        }
    }
    return fieldsWithPrefix;
};
exports.getFieldsByPrefix = getFieldsByPrefix;
var getField = function (field, key, program) {
    var state = store_1.getStore().getState();
    var _a = state.argous, fields = _a.fields, currentProgram = _a.currentProgram;
    var exist = fields[program || currentProgram]
        ? fields[program || currentProgram][field]
            ? fields[program || currentProgram][field]
            : ''
        : '';
    if (exist) {
        if (key) {
            return typeof exist[key] === 'undefined'
                ? ''
                : exist[key];
        }
        return exist;
    }
    return '';
};
exports.getField = getField;
/**
 * @deprecated
 */
var getPreviousField = function (field, prevProps, key) {
    var state = store_1.getStore().getState();
    var currentProgram = state.argous.currentProgram;
    var exist = prevProps.fields
        ? prevProps.fields[currentProgram]
            ? prevProps.fields[currentProgram][field]
                ? prevProps.fields[currentProgram][field]
                : ''
            : ''
        : '';
    if (exist) {
        if (key) {
            return typeof exist[key] === 'undefined'
                ? ''
                : exist[key];
        }
        return exist;
    }
    return '';
};
exports.getPreviousField = getPreviousField;
/**
 * @deprecated
 */
var getAllFields = function () {
    var state = store_1.getStore().getState();
    var _a = state.argous, fields = _a.fields, currentProgram = _a.currentProgram;
    return fields[currentProgram];
};
exports.getAllFields = getAllFields;
var clearField = function (field) {
    var state = store_1.getStore().getState();
    var _a = state.argous, fields = _a.fields, currentProgram = _a.currentProgram;
    var clonedFields = __assign({}, fields);
    if (clonedFields && clonedFields[currentProgram] && clonedFields[currentProgram][field]) {
        delete clonedFields[currentProgram][field];
        store_1.getStore().dispatch(argous.setFields(clonedFields));
    }
};
exports.clearField = clearField;
var clearAllFields = function () {
    store_1.getStore().dispatch(argous.clearAllFields());
};
exports.clearAllFields = clearAllFields;
/**
 * @deprecated
 */
var setServerValueToField = function (field) { return __awaiter(void 0, void 0, void 0, function () {
    var state, currentProgram, res, value;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                state = store_1.getStore().getState();
                currentProgram = state.argous.currentProgram;
                return [4 /*yield*/, api_1.agGet({ pgCode: currentProgram, field: field })];
            case 1:
                res = _a.sent();
                if (res.pgmOk) {
                    value = res[field];
                    try {
                        value = typeof value === 'object'
                            ? value
                            : JSON.parse(value);
                    }
                    catch (err) { }
                    exports.setField(field, 'value', value);
                    return [2 /*return*/, res[field]];
                }
                return [2 /*return*/, ''];
        }
    });
}); };
exports.setServerValueToField = setServerValueToField;
/**
 * @deprecated
 */
var setFieldValueToServer = function (field) { return __awaiter(void 0, void 0, void 0, function () {
    var state, currentProgram, value, res;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                state = store_1.getStore().getState();
                currentProgram = state.argous.currentProgram;
                value = exports.getField(field, 'value');
                return [4 /*yield*/, api_1.agSet((_a = {}, _a[field] = value, _a.pgCode = currentProgram, _a))];
            case 1:
                res = _b.sent();
                if (res.pgmOk) {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
        }
    });
}); };
exports.setFieldValueToServer = setFieldValueToServer;
/**
 * @deprecated
 */
var fieldChangeListener = function (field, fieldListener, prevProps) {
    var state = store_1.getStore().getState();
    var _a = state.argous, currentProgram = _a.currentProgram, fields = _a.fields;
    if (fieldListener) {
        var fieldAux = fields
            ? fields[currentProgram]
                ? fields[currentProgram][field]
                    ? fields[currentProgram][field]
                    : undefined
                : undefined
            : undefined;
        var prevFieldAux = prevProps.fields
            ? prevProps.fields[currentProgram]
                ? prevProps.fields[currentProgram][field]
                    ? prevProps.fields[currentProgram][field]
                    : undefined
                : undefined
            : undefined;
        if (fieldAux !== prevFieldAux) {
            fieldListener(fieldAux ? fieldAux : {}, prevFieldAux ? prevFieldAux : {});
        }
    }
};
exports.fieldChangeListener = fieldChangeListener;
/**
 * @deprecated
 */
var fieldUpdatesActionHandler = function (sendUpdates, receiveUpdates, action, dados, onActionSuccess, onAllUpdated, dataCallback) {
    var sendUpdatesCount = 0;
    var receiveUpdatesCount = 0;
    if (sendUpdates.length > 0) {
        sendUpdates.map(function (f) { return exports.setFieldValueToServer(f).then(function () {
            if (sendUpdates.length === ++sendUpdatesCount) {
                if (receiveUpdates.length > 0) {
                    if (action) {
                        handleAction(action, dados, onActionSuccess)
                            .then(function (res) { return receiveUpdates.map(function (f) { return exports.setServerValueToField(f)
                            .then(function () { return (receiveUpdates.length === ++receiveUpdatesCount) && onAllUpdated && onAllUpdated(dataCallback, res); }); }); });
                    }
                    else {
                        receiveUpdates.map(function (f) { return exports.setServerValueToField(f)
                            .then(function () { return (receiveUpdates.length === ++receiveUpdatesCount) && onAllUpdated && onAllUpdated(dataCallback); }); });
                    }
                }
                else if (action) {
                    handleAction(action, dados, onActionSuccess)
                        .then(function (res) { return onAllUpdated && onAllUpdated(dataCallback, res); });
                }
                else {
                    onAllUpdated && onAllUpdated(dataCallback);
                }
            }
        }); });
    }
    else if (action) {
        handleAction(action, dados, onActionSuccess)
            .then(function (res) { return receiveUpdates.map(function (f) { return exports.setServerValueToField(f)
            .then(function () { return (receiveUpdates.length === ++receiveUpdatesCount) && onAllUpdated && onAllUpdated(dataCallback, res); }); }); });
    }
    else {
        receiveUpdates.map(function (f) { return exports.setServerValueToField(f)
            .then(function () { return (receiveUpdates.length === ++receiveUpdatesCount) && onAllUpdated && onAllUpdated(dataCallback); }); });
    }
};
exports.fieldUpdatesActionHandler = fieldUpdatesActionHandler;
/**
 * @deprecated
 */
var waitFieldsData = function (wFields, wDatas, rejectMilliseconds, milliseconds) {
    if (wFields === void 0) { wFields = []; }
    if (wDatas === void 0) { wDatas = []; }
    if (rejectMilliseconds === void 0) { rejectMilliseconds = 5000; }
    if (milliseconds === void 0) { milliseconds = 100; }
    return new Promise(function (resolve, reject) {
        var lengthWait = wFields.length * wDatas.length;
        var alreadyHaveLoaded = 0;
        var interval = setInterval(function () {
            alreadyHaveLoaded = 0;
            for (var _i = 0, wFields_1 = wFields; _i < wFields_1.length; _i++) {
                var field = wFields_1[_i];
                var f = exports.getField(field);
                for (var _a = 0, wDatas_1 = wDatas; _a < wDatas_1.length; _a++) {
                    var data = wDatas_1[_a];
                    if (typeof f[data] !== 'undefined') {
                        alreadyHaveLoaded++;
                    }
                }
            }
            if (lengthWait === alreadyHaveLoaded) {
                clearInterval(interval);
                clearTimeout(timeout);
                resolve();
            }
        }, milliseconds);
        var timeout = setTimeout(function () {
            clearInterval(interval);
            reject();
        }, rejectMilliseconds);
    });
};
exports.waitFieldsData = waitFieldsData;
/**
 * @deprecated
 */
var handleFieldValue = function (currentProgram, fields, field, res, defaultValue) {
    var vlAux = fields[currentProgram]
        ? fields[currentProgram][field]
            ? fields[currentProgram][field]
            : res.pgmOk
                ? res[field] !== 'null'
                    ? res[field]
                    : undefined
                : undefined
        : res.pgmOk
            ? res[field] !== 'null'
                ? res[field]
                : undefined
            : undefined;
    var value = typeof vlAux !== 'undefined'
        ? vlAux
        : typeof defaultValue !== 'undefined'
            ? defaultValue
            : '';
    try {
        value = typeof value === 'object'
            ? value
            : JSON.parse(value);
    }
    catch (err) { }
    return value;
};
/**
 * @deprecated
 */
var handleAction = function (ac, dados, onActionSuccess) { return __awaiter(void 0, void 0, void 0, function () {
    var data, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                data = {
                    pgCode: exports.getCurrentProgram(),
                    action: ac,
                    dados: dados ? dados : {}
                };
                return [4 /*yield*/, api_1.action(data)];
            case 1:
                res = _a.sent();
                if (onActionSuccess) {
                    onActionSuccess(res);
                }
                return [2 /*return*/, res];
        }
    });
}); };
