"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUrlParameters = exports.sendNotification = exports.setWarning = exports.setInfo = exports.setSuccess = exports.setError = exports.setAlert = exports.serverAction = exports.enableDebugger = exports.setServerValue = exports.getServerValue = void 0;
var config_1 = require("./config");
var store_1 = require("./store");
var api_1 = require("../api");
var fieldsRedux_1 = require("../fieldsRedux");
var getCurrentProgram = function (n) {
    if (n === void 0) { n = 0; }
    return __awaiter(void 0, void 0, void 0, function () {
        var state, currentProgram;
        return __generator(this, function (_a) {
            state = store_1.getStore().getState();
            currentProgram = state.argous.currentProgram;
            if (!currentProgram) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        if (n >= 10)
                            reject(console.error('getServerValue, setServerValue ou serverAction chamado antes do mount do Programa. Use programDidMount().'));
                        setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = resolve;
                                        return [4 /*yield*/, getCurrentProgram(n++)];
                                    case 1:
                                        _a.apply(void 0, [_b.sent()]);
                                        return [2 /*return*/];
                                }
                            });
                        }); }, 100);
                    })];
            }
            return [2 /*return*/, currentProgram];
        });
    });
};
/**
 * @deprecated
 */
var getServerValue = function (field) { return __awaiter(void 0, void 0, void 0, function () {
    var currentProgram, res, value;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, getCurrentProgram()];
            case 1:
                currentProgram = _a.sent();
                return [4 /*yield*/, api_1.agGet({ pgCode: currentProgram, field: field })];
            case 2:
                res = _a.sent();
                if (res.pgmOk) {
                    value = res[field];
                    try {
                        value = typeof value === 'object'
                            ? value : JSON.parse(value);
                    }
                    catch (err) { }
                    return [2 /*return*/, value];
                }
                return [2 /*return*/, ''];
        }
    });
}); };
exports.getServerValue = getServerValue;
/**
 * @deprecated
 *
 * @param {string} field - String
 * @param {any} value - Valor
 *
 * @returns {Promise<any>} retorno
 */
var setServerValue = function (field, value) { return __awaiter(void 0, void 0, void 0, function () {
    var currentProgram, res;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, getCurrentProgram()];
            case 1:
                currentProgram = _b.sent();
                return [4 /*yield*/, api_1.agSet((_a = { pgCode: currentProgram }, _a[field] = value, _a))];
            case 2:
                res = _b.sent();
                return [2 /*return*/, !!res.pgmOk];
        }
    });
}); };
exports.setServerValue = setServerValue;
var debuging = false;
var enableDebugger = function () {
    debuging = true;
};
exports.enableDebugger = enableDebugger;
var serverAction = function (metodo, dados, pgCode, tratarErro, token) {
    if (dados === void 0) { dados = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var code, tErro, currentProgram, _a, data, res;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    code = typeof pgCode === 'string' ? pgCode : typeof tratarErro === 'string' ? tratarErro : undefined;
                    tErro = typeof tratarErro === 'boolean' ? tratarErro : typeof pgCode === 'boolean' ? pgCode : false;
                    _a = code;
                    if (_a) return [3 /*break*/, 2];
                    return [4 /*yield*/, getCurrentProgram()];
                case 1:
                    _a = (_b.sent());
                    _b.label = 2;
                case 2:
                    currentProgram = _a;
                    data = {
                        pgCode: currentProgram,
                        action: metodo,
                        dados: dados
                    };
                    return [4 /*yield*/, api_1.action(data, token)];
                case 3:
                    res = _b.sent();
                    if (debuging && process.env.NODE_ENV !== 'production') {
                        console.log('-------- Server Action ---------');
                        console.log('pgCode: ', currentProgram);
                        console.log('action: ', metodo);
                        console.log('dados: ', dados);
                        console.log('res: ', res);
                        if (res.dsErro)
                            console.error(res.dsErro);
                        console.log('--------------------------------');
                    }
                    if (res.dsErro && tErro)
                        setError(res.dsErro);
                    if (res.chTkn)
                        document.cookie = "lt=" + res.chTkn + ";path=/;SameSite=Lax;" + (config_1.getConfig().ssl ? 'secure' : '');
                    if (res.blkTkn) {
                        setInfo(res.blkTkn, 'Justificativa de Bloqueio', 0);
                        window.localStorage.setItem('blkUs', JSON.stringify(store_1.getStore().getState().argous.usuarioLogado));
                        store_1.getStore().dispatch({ type: 'setUsuarioLogado', usuarioLogado: {} });
                        document.cookie = "lt=;path=/;SameSite=Lax;" + (config_1.getConfig().ssl ? 'secure' : '');
                        store_1.getStore().dispatch({ type: 'setBlockUser', block: true });
                    }
                    if (res.vldPsw)
                        store_1.getStore().dispatch({ type: 'setVldPsw', vldPsw: true });
                    return [2 /*return*/, res];
            }
        });
    });
};
exports.serverAction = serverAction;
function setAlert(mensagem, type, title, time) {
    if (time === void 0) { time = 5000; }
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { mensagem: mensagem, type: type, title: title, time: time }, 'argousSystem');
    }, 0);
}
exports.setAlert = setAlert;
function setError(mensagem, title) {
    if (title === void 0) { title = 'Erro'; }
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { mensagem: mensagem, type: 'error', title: title }, 'argousSystem');
    }, 0);
}
exports.setError = setError;
function setSuccess(mensagem, title, time) {
    if (time === void 0) { time = 5000; }
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { mensagem: mensagem, type: 'success', title: title, time: time }, 'argousSystem');
    }, 0);
}
exports.setSuccess = setSuccess;
function setInfo(mensagem, title, time) {
    if (time === void 0) { time = 5000; }
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { mensagem: mensagem, type: 'info', title: title, time: time }, 'argousSystem');
    }, 0);
}
exports.setInfo = setInfo;
function setWarning(mensagem, title, time) {
    if (time === void 0) { time = 5000; }
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { mensagem: mensagem, type: 'warning', title: title, time: time }, 'argousSystem');
    }, 0);
}
exports.setWarning = setWarning;
function sendNotification(_a) {
    var id = _a.id, mensagem = _a.mensagem, title = _a.title, type = _a.type, link = _a.link, dsLabel = _a.dsLabel;
    setTimeout(function () {
        fieldsRedux_1.setAnotherProgramField('systemTopAlert', { type: 'notification', id: id, mensagem: mensagem, title: title, link: link, dsLabel: dsLabel, icon: type }, 'argousSystem');
    }, 0);
}
exports.sendNotification = sendNotification;
var getUrlVars = function () {
    var vars = {};
    window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (_, key, value) {
        vars[key] = value;
        return '';
    });
    return vars;
};
var deleteURLParameters = function () {
    var params = window.location.href;
    var pos = params.indexOf('?');
    if (pos > 0)
        params = params.substring(0, pos);
    window.history.replaceState('object or string', 'Title', params);
};
var getUrlParameters = function (pgCode) { return __awaiter(void 0, void 0, void 0, function () {
    var urlPrms;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                urlPrms = getUrlVars();
                if (!urlPrms.ctrl) return [3 /*break*/, 2];
                deleteURLParameters();
                return [4 /*yield*/, exports.serverAction('getURLParameters', { ctrl: urlPrms.ctrl }, pgCode, true)];
            case 1: return [2 /*return*/, _a.sent()];
            case 2: return [2 /*return*/];
        }
    });
}); };
exports.getUrlParameters = getUrlParameters;
