import { headers, server } from './';
import { getConfig } from '../utils/config';

const api = () => `${getConfig().ssl ? 'wss' : 'ws'}${ server() }ws`;

let argousWS = null;

export const connectArgousWS = (data) => {
  argousWS = new WebSocket(api());
};

export const getArgousWS = (data) => {
  return argousWS;
};

export const disconnect = () => {
  if (argousWS)
    argousWS.close();
};

export const enviaMensagem = (data) => {
  const argousWS = getArgousWS();
  argousWS.send(JSON.stringify({
    ...headers(),
    ...data
  }));
};
