import PropTypes from 'prop-types';
import React, { Component } from 'react';

/**
 * @deprecated 
 */
class Tabs extends Component {
  state = {
    active: 0
  }

  render() {
    const {
      tabs = [],
      children,
      classContainer = '',
      classContainerIndex = [],
      classTabs = '',
      classTabsIndex = [],
      classSelected = '',
      classSelectedIndex = [],
      classActive = '',
      classActiveIndex = []
    } = this.props;

    const { active } = this.state;
    return (
      <div className={`${classContainer} ${classContainerIndex[active] ? classContainerIndex[active] : ''}`}>
        <ul className={`${classTabs} ${classTabsIndex[active] ? classTabsIndex[active] : ''}`}>
          {tabs.map((tab, index) => (
            <li key={index}
              className={`${index === active ? classActive : ''} ${index === active ? classActiveIndex[active] ? classActiveIndex[active] : '' : ''}`}
              onClick={() => this.setState({ active: index })}>
              {tab}
            </li>
          ))}
        </ul>
        <div className={`${classSelected} ${classSelectedIndex[active] ? classSelectedIndex[active] : ''}`}>
          {children && children[active]}
        </div>
      </div>
    );
  }
}

Tabs.propTypes = {
  tabs: PropTypes.array,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.element]),
  classContainer: PropTypes.string,
  classContainerIndex: PropTypes.array,
  classTabs: PropTypes.string,
  classTabsIndex: PropTypes.array,
  classSelected: PropTypes.string,
  classSelectedIndex: PropTypes.array,
  classActive: PropTypes.string,
  classActiveIndex: PropTypes.array,
};

export default Tabs;
